module     p0_dd_emnebardu_d17h0l1
   ! file:      /home/pcl305a/luisonig/Documents/GoSamSherpa/W2jets/1.4/Virtual/
   ! p0_dd_emnebardu/helicity0/d17h0l1.f90
   ! generator: haggies (1.1)
   use p0_dd_emnebardu_config, only: ki
   use p0_dd_emnebardu_util, only: cond
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   public :: numerator_samurai
   public :: numerator_golem95
contains
!---#[ numerator interfaces:
   !------#[ function numerator_samurai:
   function numerator_samurai(ncut,Q_ext, mu2_ext) result(numerator)
      use precision, only: ki_sam => ki
!      use p0_dd_emnebardu_groups, only: &
!           & sign => diagram17_sign, shift => diagram17_shift
      use p0_dd_emnebardu_globalsl1, only: epspow
      use p0_dd_emnebardu_kinematics
      use p0_dd_emnebardu_abbrevd17h0
      implicit none

      integer, intent(in) :: ncut
      complex(ki_sam), dimension(4), intent(in) :: Q_ext
      complex(ki_sam), intent(in) :: mu2_ext
      complex(ki_sam) :: numerator
      complex(ki) :: d17
      complex(ki) :: t1

      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      real(ki), dimension(0:3) :: qshift

      qshift = -k5
      Q(1)   = cmplx(real(-Q_ext(4) - qshift(0),   ki_sam), aimag(-Q_ext(4)),   &
      &ki)
      Q(2:4) = cmplx(real(-Q_ext(1:3) - qshift(1:3), ki_sam), aimag(-Q_ext(1:3))&
      &, ki)
      d17 = 0.0_ki
      t1 = (Q(1)*spvak5k2(1)-Q(2)*spvak5k2(2)-Q(3)*spvak5k2(3)-Q(4)*spvak5k2(4))
      d17 = (abb17n2+t1*abb17n5+abb17n3*(Q(1)*k1(1)-Q(2)*k1(2)-Q(3)*k1(3)-Q(4)*k&
      &1(4))+abb17n3*(Q(1)*k5(1)-Q(2)*k5(2)-Q(3)*k5(3)-Q(4)*k5(4))+abb17n4*(Q(1)&
      &*k2(1)-Q(2)*k2(2)-Q(3)*k2(3)-Q(4)*k2(4))+abb17n6*(Q(1)*spvak5k1(1)-Q(2)*s&
      &pvak5k1(2)-Q(3)*spvak5k1(3)-Q(4)*spvak5k1(4))+abb17n7*(Q(1)*spvak3k2(1)-Q&
      &(2)*spvak3k2(2)-Q(3)*spvak3k2(3)-Q(4)*spvak3k2(4))+abb17n8*(Q(1)*spvak6k2&
      &(1)-Q(2)*spvak6k2(2)-Q(3)*spvak6k2(3)-Q(4)*spvak6k2(4))+abb17n9*(Q(1)*Q(1&
      &)-Q(2)*Q(2)-Q(3)*Q(3)-Q(4)*Q(4))+t1*abb17n10*(Q(1)*spvak3k1(1)-Q(2)*spvak&
      &3k1(2)-Q(3)*spvak3k1(3)-Q(4)*spvak3k1(4))+t1*abb17n11*(Q(1)*spvak6k1(1)-Q&
      &(2)*spvak6k1(2)-Q(3)*spvak6k1(3)-Q(4)*spvak6k1(4)))
      numerator = cmplx(real(d17, ki), aimag(d17), ki_sam)
   end function numerator_samurai
   !------#] function numerator_samurai:
   !------#[ function numerator_golem95:
   function numerator_golem95(Q_ext, mu2_ext) result(numerator)
      use precision_golem, only: ki_gol => ki
      use p0_dd_emnebardu_globalsl1, only: epspow
      use p0_dd_emnebardu_kinematics
      use p0_dd_emnebardu_abbrevd17h0
      implicit none

      real(ki_gol), dimension(0:3), intent(in) :: Q_ext
      real(ki_gol), intent(in) :: mu2_ext
      complex(ki_gol) :: numerator
      complex(ki) :: d17
      complex(ki) :: t1

      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      real(ki), dimension(4) :: qshift

      qshift = -k5
      Q(:) = cmplx(real(-Q_ext(:) - qshift(:), ki_gol), 0.0_ki_gol, ki)
      d17 = 0.0_ki
      t1 = (Q(1)*spvak5k2(1)-Q(2)*spvak5k2(2)-Q(3)*spvak5k2(3)-Q(4)*spvak5k2(4))
      d17 = (abb17n2+t1*abb17n5+abb17n3*(Q(1)*k1(1)-Q(2)*k1(2)-Q(3)*k1(3)-Q(4)*k&
      &1(4))+abb17n3*(Q(1)*k5(1)-Q(2)*k5(2)-Q(3)*k5(3)-Q(4)*k5(4))+abb17n4*(Q(1)&
      &*k2(1)-Q(2)*k2(2)-Q(3)*k2(3)-Q(4)*k2(4))+abb17n6*(Q(1)*spvak5k1(1)-Q(2)*s&
      &pvak5k1(2)-Q(3)*spvak5k1(3)-Q(4)*spvak5k1(4))+abb17n7*(Q(1)*spvak3k2(1)-Q&
      &(2)*spvak3k2(2)-Q(3)*spvak3k2(3)-Q(4)*spvak3k2(4))+abb17n8*(Q(1)*spvak6k2&
      &(1)-Q(2)*spvak6k2(2)-Q(3)*spvak6k2(3)-Q(4)*spvak6k2(4))+abb17n9*(Q(1)*Q(1&
      &)-Q(2)*Q(2)-Q(3)*Q(3)-Q(4)*Q(4))+t1*abb17n10*(Q(1)*spvak3k1(1)-Q(2)*spvak&
      &3k1(2)-Q(3)*spvak3k1(3)-Q(4)*spvak3k1(4))+t1*abb17n11*(Q(1)*spvak6k1(1)-Q&
      &(2)*spvak6k1(2)-Q(3)*spvak6k1(3)-Q(4)*spvak6k1(4)))

      numerator = cmplx(real(d17, ki), aimag(d17), ki_gol)
   end function numerator_golem95
   !------#] function numerator_golem95:
!---#] numerator interfaces:
end module p0_dd_emnebardu_d17h0l1
