module     p0_dd_emnebardu_d54h0l1d
   ! file:      /home/pcl305a/luisonig/Documents/GoSamSherpa/W2jets/1.4/Virtual/
   ! p0_dd_emnebardu/helicity0/d54h0l1d.f90
   ! generator: haggies (1.1)
   use p0_dd_emnebardu_config, only: ki
   use p0_dd_emnebardu_util, only: cond, d => metric_tensor
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   integer, private :: iv0
   integer, private :: iv1
   real(ki), dimension(4), private :: qshift


   public :: derivative, reconstruct_d54
contains

!---#[ function derivative:
   function derivative(mu2, i1) result(numerator)
      use p0_dd_emnebardu_globalsl1, only: epspow
      use p0_dd_emnebardu_kinematics
      use p0_dd_emnebardu_abbrevd54h0
      implicit none
      complex(ki), intent(in) :: mu2
      integer, intent(in), optional :: i1
      complex(ki) :: numerator
      complex(ki) :: loc
      integer :: deg
      complex(ki), dimension(4), parameter :: Q = (/&
        &(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki)/)
      qshift = k6+k5
      numerator = 0.0_ki
      deg = 0
      if(present(i1)) then
         iv1 = i1
         deg = 1
      else
         iv1 = 1
      end if
      if(deg.eq.0) then
         numerator = (abb54n11+abb54n20*(spvak5k1(1)*qshift(1)-spvak5k1(2)*qshif&
         &t(2)-spvak5k1(3)*qshift(3)-spvak5k1(4)*qshift(4))+abb54n21*(spvak6k1(1&
         &)*qshift(1)-spvak6k1(2)*qshift(2)-spvak6k1(3)*qshift(3)-spvak6k1(4)*qs&
         &hift(4))+abb54n22*(spvak5k4(1)*qshift(1)-spvak5k4(2)*qshift(2)-spvak5k&
         &4(3)*qshift(3)-spvak5k4(4)*qshift(4))+abb54n23*(spvak6k4(1)*qshift(1)-&
         &spvak6k4(2)*qshift(2)-spvak6k4(3)*qshift(3)-spvak6k4(4)*qshift(4))+abb&
         &54n24*dotproduct(k3, qshift)+abb54n24*dotproduct(k4, qshift)+abb54n25*&
         &dotproduct(k1, qshift)+abb54n26*(spvak3k4(1)*qshift(1)-spvak3k4(2)*qsh&
         &ift(2)-spvak3k4(3)*qshift(3)-spvak3k4(4)*qshift(4))+abb54n27*(spvak3k1&
         &(1)*qshift(1)-spvak3k1(2)*qshift(2)-spvak3k1(3)*qshift(3)-spvak3k1(4)*&
         &qshift(4)))
         return
      end if
      if(deg.eq.1) then
         numerator = (k1(iv1)*abb54n14+k3(iv1)*abb54n15+k4(iv1)*abb54n15+spvak3k&
         &1(iv1)*abb54n12+spvak3k4(iv1)*abb54n13+spvak5k1(iv1)*abb54n19+spvak5k4&
         &(iv1)*abb54n17+spvak6k1(iv1)*abb54n18+spvak6k4(iv1)*abb54n16)
         return
      end if
   end function derivative
!---#] function derivative:
!---#[ subroutine reconstruct_d54:
   subroutine     reconstruct_d54(coeffs)
      use p0_dd_emnebardu_groups, only: tensrec_info_group5
      implicit none
      complex(ki), parameter :: czip = (0.0_ki, 0.0_ki)
      complex(ki), parameter :: cone = (1.0_ki, 0.0_ki)

      type(tensrec_info_group5), intent(out) :: coeffs
      ! rank 1 case:
      !---[# reconstruct coeffs%coeffs_54:
      coeffs%coeffs_54%c0 = derivative(czip)
      coeffs%coeffs_54%c1(1,1) = derivative(czip,1)
      coeffs%coeffs_54%c1(2,1) = -derivative(czip,2)
      coeffs%coeffs_54%c1(3,1) = -derivative(czip,3)
      coeffs%coeffs_54%c1(4,1) = -derivative(czip,4)
      !---#] reconstruct coeffs%coeffs_54:
   end subroutine reconstruct_d54
!---#] subroutine reconstruct_d54:
end module p0_dd_emnebardu_d54h0l1d
