module     p0_dd_emnebardu_d7h0l1d
   ! file:      /home/pcl305a/luisonig/Documents/GoSamSherpa/W2jets/1.4/Virtual/
   ! p0_dd_emnebardu/helicity0/d7h0l1d.f90
   ! generator: haggies (1.1)
   use p0_dd_emnebardu_config, only: ki
   use p0_dd_emnebardu_util, only: cond, d => metric_tensor
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   integer, private :: iv0
   integer, private :: iv1
   integer, private :: iv2
   real(ki), dimension(4), private :: qshift


   public :: derivative, reconstruct_d7
contains

!---#[ function derivative:
   function derivative(mu2, i1, i2) result(numerator)
      use p0_dd_emnebardu_globalsl1, only: epspow
      use p0_dd_emnebardu_kinematics
      use p0_dd_emnebardu_abbrevd7h0
      implicit none
      complex(ki), intent(in) :: mu2
      integer, intent(in), optional :: i1
      integer, intent(in), optional :: i2
      complex(ki) :: numerator
      complex(ki) :: loc
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11
      complex(ki) :: t12
      complex(ki) :: t13
      complex(ki) :: t14
      real(ki) :: t15
      real(ki) :: t16
      real(ki) :: t17
      integer :: deg
      complex(ki), dimension(4), parameter :: Q = (/&
        &(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki)/)
      qshift = -k3-k4
      numerator = 0.0_ki
      deg = 0
      if(present(i1)) then
         iv1 = i1
         deg = 1
      else
         iv1 = 1
      end if
      if(present(i2)) then
         iv2 = i2
         deg = 2
      else
         iv2 = 1
      end if
      t1 = (spvak3k4(1)*qshift(1)-spvak3k4(2)*qshift(2)-spvak3k4(3)*qshift(3)-sp&
      &vak3k4(4)*qshift(4))
      t2 = (spvak5k1(1)*qshift(1)-spvak5k1(2)*qshift(2)-spvak5k1(3)*qshift(3)-sp&
      &vak5k1(4)*qshift(4))
      t3 = (spvak5k2(1)*qshift(1)-spvak5k2(2)*qshift(2)-spvak5k2(3)*qshift(3)-sp&
      &vak5k2(4)*qshift(4))
      t15 = dotproduct(k1, qshift)
      t16 = dotproduct(k2, qshift)
      t17 = dotproduct(k5, qshift)
      t4 = (spvak6k2(1)*qshift(1)-spvak6k2(2)*qshift(2)-spvak6k2(3)*qshift(3)-sp&
      &vak6k2(4)*qshift(4))
      t5 = (spvak6k1(1)*qshift(1)-spvak6k1(2)*qshift(2)-spvak6k1(3)*qshift(3)-sp&
      &vak6k1(4)*qshift(4))
      if(deg.eq.0) then
         numerator = (t1*abb7n23+abb7n13*(spvak6k4(1)*qshift(1)-spvak6k4(2)*qshi&
         &ft(2)-spvak6k4(3)*qshift(3)-spvak6k4(4)*qshift(4))+abb7n19*dotproduct(&
         &qshift, qshift)+abb7n22*dotproduct(k3, qshift)+abb7n22*dotproduct(k4, &
         &qshift)+t1*t15*abb7n16+t1*t16*abb7n16+t1*t17*abb7n17+t1*t2*abb7n14+t1*&
         &t3*abb7n15+t1*t4*abb7n18+t1*t5*abb7n20)
         return
      end if
      t6 = spvak3k4(iv1)
      t7 = k1(iv1)
      t8 = k2(iv1)
      t9 = k5(iv1)
      t10 = t6*abb7n16
      t11 = spvak5k1(iv1)
      t12 = spvak5k2(iv1)
      t13 = spvak6k1(iv1)
      t14 = spvak6k2(iv1)
      if(deg.eq.1) then
         numerator = (k3(iv1)*abb7n22+k4(iv1)*abb7n22+qshift(iv1)*abb7n21+spvak6&
         &k4(iv1)*abb7n13+t10*t15+t10*t16+t6*abb7n23+t1*t11*abb7n14+t1*t12*abb7n&
         &15+t1*t13*abb7n20+t1*t14*abb7n18+t1*t7*abb7n16+t1*t8*abb7n16+t1*t9*abb&
         &7n17+t17*t6*abb7n17+t2*t6*abb7n14+t3*t6*abb7n15+t4*t6*abb7n18+t5*t6*ab&
         &b7n20)
         return
      end if
      t1 = spvak3k4(iv2)
      if(deg.eq.2) then
         numerator = ((2.0_ki)*d(iv1,iv2)*abb7n19+k1(iv2)*t6*abb7n16+k2(iv2)*t6*&
         &abb7n16+k5(iv2)*t6*abb7n17+spvak5k1(iv2)*t6*abb7n14+spvak5k2(iv2)*t6*a&
         &bb7n15+spvak6k1(iv2)*t6*abb7n20+spvak6k2(iv2)*t6*abb7n18+t1*t11*abb7n1&
         &4+t1*t12*abb7n15+t1*t13*abb7n20+t1*t14*abb7n18+t1*t7*abb7n16+t1*t8*abb&
         &7n16+t1*t9*abb7n17)
         return
      end if
   end function derivative
!---#] function derivative:
!---#[ subroutine reconstruct_d7:
   subroutine     reconstruct_d7(coeffs)
      use p0_dd_emnebardu_groups, only: tensrec_info_group7
      implicit none
      complex(ki), parameter :: czip = (0.0_ki, 0.0_ki)
      complex(ki), parameter :: cone = (1.0_ki, 0.0_ki)

      type(tensrec_info_group7), intent(out) :: coeffs
      ! rank 2 case:
      !---[# reconstruct coeffs%coeffs_7:
      coeffs%coeffs_7%c0 = derivative(czip)
      coeffs%coeffs_7%c1(1,1) = derivative(czip,1)
      coeffs%coeffs_7%c1(1,2) = derivative(czip,1,1) / 2.0_ki
      coeffs%coeffs_7%c1(2,1) = -derivative(czip,2)
      coeffs%coeffs_7%c1(2,2) = derivative(czip,2,2) / 2.0_ki
      coeffs%coeffs_7%c1(3,1) = -derivative(czip,3)
      coeffs%coeffs_7%c1(3,2) = derivative(czip,3,3) / 2.0_ki
      coeffs%coeffs_7%c1(4,1) = -derivative(czip,4)
      coeffs%coeffs_7%c1(4,2) = derivative(czip,4,4) / 2.0_ki
      coeffs%coeffs_7%c2(1,1) = -derivative(czip,1,2)
      coeffs%coeffs_7%c2(2,1) = -derivative(czip,1,3)
      coeffs%coeffs_7%c2(3,1) = -derivative(czip,1,4)
      coeffs%coeffs_7%c2(4,1) = derivative(czip,2,3)
      coeffs%coeffs_7%c2(5,1) = derivative(czip,2,4)
      coeffs%coeffs_7%c2(6,1) = derivative(czip,3,4)
      !---#] reconstruct coeffs%coeffs_7:
   end subroutine reconstruct_d7
!---#] subroutine reconstruct_d7:
end module p0_dd_emnebardu_d7h0l1d
