module     p0_dd_emnebardu_d4h1l1d
   ! file:      /home/pcl305a/luisonig/Documents/GoSamSherpa/W2jets/1.4/Virtual/
   ! p0_dd_emnebardu/helicity1/d4h1l1d.f90
   ! generator: haggies (1.1)
   use p0_dd_emnebardu_config, only: ki
   use p0_dd_emnebardu_util, only: cond, d => metric_tensor
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   integer, private :: iv0
   integer, private :: iv1
   integer, private :: iv2
   integer, private :: iv3
   real(ki), dimension(4), private :: qshift


   public :: derivative, reconstruct_d4
contains

!---#[ function derivative:
   function derivative(mu2, i1, i2, i3) result(numerator)
      use p0_dd_emnebardu_globalsl1, only: epspow
      use p0_dd_emnebardu_kinematics
      use p0_dd_emnebardu_abbrevd4h1
      implicit none
      complex(ki), intent(in) :: mu2
      integer, intent(in), optional :: i1
      integer, intent(in), optional :: i2
      integer, intent(in), optional :: i3
      complex(ki) :: numerator
      complex(ki) :: loc
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11
      complex(ki) :: t12
      complex(ki) :: t13
      complex(ki) :: t14
      complex(ki) :: t15
      complex(ki) :: t16
      complex(ki) :: t17
      complex(ki) :: t18
      real(ki) :: t19
      real(ki) :: t20
      real(ki) :: t21
      integer :: deg
      complex(ki), dimension(4), parameter :: Q = (/&
        &(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki)/)
      qshift(:) = 0.0_ki
      numerator = 0.0_ki
      deg = 0
      if(present(i1)) then
         iv1 = i1
         deg = 1
      else
         iv1 = 1
      end if
      if(present(i2)) then
         iv2 = i2
         deg = 2
      else
         iv2 = 1
      end if
      if(present(i3)) then
         iv3 = i3
         deg = 3
      else
         iv3 = 1
      end if
      if(deg.eq.0) then
         numerator = abb4n32
         return
      end if
      t1 = k1(iv1)
      t2 = k5(iv1)
      t3 = k6(iv1)
      t4 = spvak1k2(iv1)
      t5 = spvak1k5(iv1)
      t6 = spvak3k2(iv1)
      t7 = spvak3k4(iv1)
      t8 = spvak6k2(iv1)
      if(deg.eq.1) then
         numerator = (t1*abb4n50+t2*abb4n51+t3*abb4n55+t4*abb4n54+t5*abb4n59+t6*&
         &abb4n56+t7*abb4n53+t8*abb4n57)
         return
      end if
      t19 = d(iv1,iv2)
      t9 = spvak1k2(iv2)
      t10 = spvak3k2(iv2)
      t11 = spvak6k5(iv2)
      t12 = k1(iv2)
      t13 = spvak6k5(iv1)
      t14 = k5(iv2)
      t15 = spvak1k5(iv2)
      t16 = spvak3k4(iv2)
      t17 = k6(iv2)
      t18 = spvak6k2(iv2)
      if(deg.eq.2) then
         numerator = ((2.0_ki)*t19*abb4n44+spvak5k2(iv1)*t15*abb4n36+spvak5k2(iv&
         &2)*t5*abb4n36+spvak6k1(iv1)*t15*abb4n48+spvak6k1(iv2)*t5*abb4n48+t1*t1&
         &0*abb4n42+t1*t11*abb4n49+t1*t9*abb4n35+t10*t2*abb4n41+t10*t3*abb4n41+t&
         &10*t5*abb4n33+t11*t2*abb4n47+t11*t3*abb4n47+t11*t5*abb4n39+t11*t7*abb4&
         &n43+t12*t13*abb4n49+t12*t4*abb4n35+t12*t6*abb4n42+t13*t14*abb4n47+t13*&
         &t15*abb4n39+t13*t16*abb4n43+t13*t17*abb4n47+t14*t4*abb4n37+t14*t6*abb4&
         &n41+t15*t3*abb4n38+t15*t4*abb4n46+t15*t6*abb4n33+t15*t8*abb4n34+t16*t3&
         &*abb4n45+t16*t8*abb4n40+t17*t4*abb4n37+t17*t5*abb4n38+t17*t6*abb4n41+t&
         &17*t7*abb4n45+t18*t5*abb4n34+t18*t7*abb4n40+t2*t9*abb4n37+t3*t9*abb4n3&
         &7+t5*t9*abb4n46)
         return
      end if
      t20 = d(iv2,iv3)
      t21 = d(iv1,iv3)
      t1 = spvak1k5(iv3)
      t2 = spvak6k2(iv3)
      t3 = spvak3k4(iv3)
      if(deg.eq.3) then
         numerator = ((2.0_ki)*(spvak1k2(iv3)*t19*abb4n61+spvak3k2(iv3)*t19*abb4&
         &n58+spvak6k5(iv3)*t19*abb4n52+t1*t19*abb4n60+t10*t21*abb4n58+t11*t21*a&
         &bb4n52+t13*t20*abb4n52+t15*t21*abb4n60+t20*t4*abb4n61+t20*t5*abb4n60+t&
         &20*t6*abb4n58+t21*t9*abb4n61)+t1*t16*t8*abb4n62+t1*t18*t7*abb4n62+t15*&
         &t2*t7*abb4n62+t15*t3*t8*abb4n62+t16*t2*t5*abb4n62+t18*t3*t5*abb4n62)
         return
      end if
   end function derivative
!---#] function derivative:
!---#[ subroutine reconstruct_d4:
   subroutine     reconstruct_d4(coeffs)
      use p0_dd_emnebardu_groups, only: tensrec_info_group2
      implicit none
      complex(ki), parameter :: czip = (0.0_ki, 0.0_ki)
      complex(ki), parameter :: cone = (1.0_ki, 0.0_ki)

      type(tensrec_info_group2), intent(out) :: coeffs
      ! rank 3 case:
      !---[# reconstruct coeffs%coeffs_4:
      coeffs%coeffs_4%c0 = derivative(czip)
      coeffs%coeffs_4%c1(1,1) = derivative(czip,1)
      coeffs%coeffs_4%c1(1,2) = derivative(czip,1,1) / 2.0_ki
      coeffs%coeffs_4%c1(1,3) = derivative(czip,1,1,1) / 6.0_ki
      coeffs%coeffs_4%c1(2,1) = -derivative(czip,2)
      coeffs%coeffs_4%c1(2,2) = derivative(czip,2,2) / 2.0_ki
      coeffs%coeffs_4%c1(2,3) = -derivative(czip,2,2,2) / 6.0_ki
      coeffs%coeffs_4%c1(3,1) = -derivative(czip,3)
      coeffs%coeffs_4%c1(3,2) = derivative(czip,3,3) / 2.0_ki
      coeffs%coeffs_4%c1(3,3) = -derivative(czip,3,3,3) / 6.0_ki
      coeffs%coeffs_4%c1(4,1) = -derivative(czip,4)
      coeffs%coeffs_4%c1(4,2) = derivative(czip,4,4) / 2.0_ki
      coeffs%coeffs_4%c1(4,3) = -derivative(czip,4,4,4) / 6.0_ki
      coeffs%coeffs_4%c2(1,1) = -derivative(czip,1,2)
      coeffs%coeffs_4%c2(1,2) = derivative(czip,1,2,2) / 2.0_ki
      coeffs%coeffs_4%c2(1,3) = -derivative(czip,1,1,2) / 2.0_ki
      coeffs%coeffs_4%c2(2,1) = -derivative(czip,1,3)
      coeffs%coeffs_4%c2(2,2) = derivative(czip,1,3,3) / 2.0_ki
      coeffs%coeffs_4%c2(2,3) = -derivative(czip,1,1,3) / 2.0_ki
      coeffs%coeffs_4%c2(3,1) = -derivative(czip,1,4)
      coeffs%coeffs_4%c2(3,2) = derivative(czip,1,4,4) / 2.0_ki
      coeffs%coeffs_4%c2(3,3) = -derivative(czip,1,1,4) / 2.0_ki
      coeffs%coeffs_4%c2(4,1) = derivative(czip,2,3)
      coeffs%coeffs_4%c2(4,2) = -derivative(czip,2,3,3) / 2.0_ki
      coeffs%coeffs_4%c2(4,3) = -derivative(czip,2,2,3) / 2.0_ki
      coeffs%coeffs_4%c2(5,1) = derivative(czip,2,4)
      coeffs%coeffs_4%c2(5,2) = -derivative(czip,2,4,4) / 2.0_ki
      coeffs%coeffs_4%c2(5,3) = -derivative(czip,2,2,4) / 2.0_ki
      coeffs%coeffs_4%c2(6,1) = derivative(czip,3,4)
      coeffs%coeffs_4%c2(6,2) = -derivative(czip,3,4,4) / 2.0_ki
      coeffs%coeffs_4%c2(6,3) = -derivative(czip,3,3,4) / 2.0_ki
      coeffs%coeffs_4%c3(1,1) = derivative(czip,1,2,3)
      coeffs%coeffs_4%c3(2,1) = derivative(czip,1,2,4)
      coeffs%coeffs_4%c3(3,1) = derivative(czip,1,3,4)
      coeffs%coeffs_4%c3(4,1) = -derivative(czip,2,3,4)
      !---#] reconstruct coeffs%coeffs_4:
   end subroutine reconstruct_d4
!---#] subroutine reconstruct_d4:
end module p0_dd_emnebardu_d4h1l1d
