module     p17_ddbar_neepdubar_d35h0l1d
   ! file:      /home/pcl305a/luisonig/Documents/GoSamSherpa/W2jets/1.4/Virtual/
   ! p17_ddbar_neepdubar/helicity0/d35h0l1d.f90
   ! generator: haggies (1.1)
   use p17_ddbar_neepdubar_config, only: ki
   use p17_ddbar_neepdubar_util, only: cond, d => metric_tensor
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   integer, private :: iv0
   integer, private :: iv1
   integer, private :: iv2
   real(ki), dimension(4), private :: qshift


   public :: derivative, reconstruct_d35
contains

!---#[ function derivative:
   function derivative(mu2, i1, i2) result(numerator)
      use p17_ddbar_neepdubar_globalsl1, only: epspow
      use p17_ddbar_neepdubar_kinematics
      use p17_ddbar_neepdubar_abbrevd35h0
      implicit none
      complex(ki), intent(in) :: mu2
      integer, intent(in), optional :: i1
      integer, intent(in), optional :: i2
      complex(ki) :: numerator
      complex(ki) :: loc
      complex(ki) :: t1
      integer :: deg
      complex(ki), dimension(4), parameter :: Q = (/&
        &(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki)/)
      qshift = -k3-k6-k4
      numerator = 0.0_ki
      deg = 0
      if(present(i1)) then
         iv1 = i1
         deg = 1
      else
         iv1 = 1
      end if
      if(present(i2)) then
         iv2 = i2
         deg = 2
      else
         iv2 = 1
      end if
      t1 = 0.0_ki
      if(deg.eq.0) then
         numerator = t1
         return
      end if
      if(deg.eq.1) then
         numerator = t1
         return
      end if
      if(deg.eq.2) then
         numerator = t1
         return
      end if
   end function derivative
!---#] function derivative:
!---#[ subroutine reconstruct_d35:
   subroutine     reconstruct_d35(coeffs)
      use p17_ddbar_neepdubar_groups, only: tensrec_info_group7
      implicit none
      complex(ki), parameter :: czip = (0.0_ki, 0.0_ki)
      complex(ki), parameter :: cone = (1.0_ki, 0.0_ki)

      type(tensrec_info_group7), intent(out) :: coeffs
      ! rank 2 case:
      !---[# reconstruct coeffs%coeffs_35:
      coeffs%coeffs_35%c0 = derivative(czip)
      coeffs%coeffs_35%c1(1,1) = derivative(czip,1)
      coeffs%coeffs_35%c1(1,2) = derivative(czip,1,1) / 2.0_ki
      coeffs%coeffs_35%c1(2,1) = -derivative(czip,2)
      coeffs%coeffs_35%c1(2,2) = derivative(czip,2,2) / 2.0_ki
      coeffs%coeffs_35%c1(3,1) = -derivative(czip,3)
      coeffs%coeffs_35%c1(3,2) = derivative(czip,3,3) / 2.0_ki
      coeffs%coeffs_35%c1(4,1) = -derivative(czip,4)
      coeffs%coeffs_35%c1(4,2) = derivative(czip,4,4) / 2.0_ki
      coeffs%coeffs_35%c2(1,1) = -derivative(czip,1,2)
      coeffs%coeffs_35%c2(2,1) = -derivative(czip,1,3)
      coeffs%coeffs_35%c2(3,1) = -derivative(czip,1,4)
      coeffs%coeffs_35%c2(4,1) = derivative(czip,2,3)
      coeffs%coeffs_35%c2(5,1) = derivative(czip,2,4)
      coeffs%coeffs_35%c2(6,1) = derivative(czip,3,4)
      !---#] reconstruct coeffs%coeffs_35:
   end subroutine reconstruct_d35
!---#] subroutine reconstruct_d35:
end module p17_ddbar_neepdubar_d35h0l1d
