module     p18_ddbar_neepscbar_d3h0l1
   ! file:      /home/pcl305a/luisonig/Documents/GoSamSherpa/W2jets/1.4/Virtual/
   ! p18_ddbar_neepscbar/helicity0/d3h0l1.f90
   ! generator: haggies (1.1)
   use p18_ddbar_neepscbar_config, only: ki
   use p18_ddbar_neepscbar_util, only: cond
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   public :: numerator_samurai
   public :: numerator_golem95
contains
!---#[ numerator interfaces:
   !------#[ function numerator_samurai:
   function numerator_samurai(ncut,Q_ext, mu2_ext) result(numerator)
      use precision, only: ki_sam => ki
!      use p18_ddbar_neepscbar_groups, only: &
!           & sign => diagram3_sign, shift => diagram3_shift
      use p18_ddbar_neepscbar_globalsl1, only: epspow
      use p18_ddbar_neepscbar_kinematics
      use p18_ddbar_neepscbar_abbrevd3h0
      implicit none

      integer, intent(in) :: ncut
      complex(ki_sam), dimension(4), intent(in) :: Q_ext
      complex(ki_sam), intent(in) :: mu2_ext
      complex(ki_sam) :: numerator
      complex(ki) :: d3
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11
      complex(ki) :: t12

      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q

      Q(1)   = cmplx(real(+Q_ext(4),   ki_sam), aimag(+Q_ext(4)),   ki)
      Q(2:4) = cmplx(real(+Q_ext(1:3), ki_sam), aimag(+Q_ext(1:3)), ki)
      d3 = 0.0_ki
      t1 = (Q(1)*k6(1)-Q(2)*k6(2)-Q(3)*k6(3)-Q(4)*k6(4))
      t2 = (Q(1)*Q(1)-Q(2)*Q(2)-Q(3)*Q(3)-Q(4)*Q(4))
      t3 = (Q(1)*k5(1)-Q(2)*k5(2)-Q(3)*k5(3)-Q(4)*k5(4))
      t4 = (Q(1)*spvak1k2(1)-Q(2)*spvak1k2(2)-Q(3)*spvak1k2(3)-Q(4)*spvak1k2(4))
      t5 = (Q(1)*spvak3k4(1)-Q(2)*spvak3k4(2)-Q(3)*spvak3k4(3)-Q(4)*spvak3k4(4))
      t6 = (Q(1)*spvak1k6(1)-Q(2)*spvak1k6(2)-Q(3)*spvak1k6(3)-Q(4)*spvak1k6(4))
      t7 = (Q(1)*k1(1)-Q(2)*k1(2)-Q(3)*k1(3)-Q(4)*k1(4))
      t8 = (Q(1)*k2(1)-Q(2)*k2(2)-Q(3)*k2(3)-Q(4)*k2(4))
      t9 = (Q(1)*spvak2k6(1)-Q(2)*spvak2k6(2)-Q(3)*spvak2k6(3)-Q(4)*spvak2k6(4))
      t10 = (Q(1)*spvak3k6(1)-Q(2)*spvak3k6(2)-Q(3)*spvak3k6(3)-Q(4)*spvak3k6(4)&
      &)
      t11 = (Q(1)*spvak5k6(1)-Q(2)*spvak5k6(2)-Q(3)*spvak5k6(3)-Q(4)*spvak5k6(4)&
      &)
      t12 = (Q(1)*spvak5k4(1)-Q(2)*spvak5k4(2)-Q(3)*spvak5k4(3)-Q(4)*spvak5k4(4)&
      &)
      d3 = (abb3n1+t1*abb3n13+t2*abb3n14+t3*abb3n17+t4*abb3n19+t5*abb3n2+t6*abb3&
      &n24+t7*abb3n4+t8*abb3n4+t9*abb3n9+t1*t10*abb3n12+t1*t12*abb3n5+t1*t4*abb3&
      &n27+t1*t5*abb3n15+t1*t6*abb3n21+t10*t2*abb3n11+t10*t4*abb3n28+t10*t7*abb3&
      &n10+t10*t8*abb3n10+t11*t4*abb3n26+t11*t5*abb3n18+t12*t2*abb3n6+t12*t4*abb&
      &3n20+t12*t7*abb3n7+t12*t8*abb3n7+t2*t5*abb3n16+t2*t6*abb3n22+t3*t4*abb3n2&
      &7+t4*t6*abb3n8+t4*t9*abb3n22+t5*t6*abb3n25+t5*abb3n3*(Q(1)*spvak5k2(1)-Q(&
      &2)*spvak5k2(2)-Q(3)*spvak5k2(3)-Q(4)*spvak5k2(4))+t6*t7*abb3n23+t6*t8*abb&
      &3n23+t11*t4*t5*abb3n29)
      numerator = cmplx(real(d3, ki), aimag(d3), ki_sam)
   end function numerator_samurai
   !------#] function numerator_samurai:
   !------#[ function numerator_golem95:
   function numerator_golem95(Q_ext, mu2_ext) result(numerator)
      use precision_golem, only: ki_gol => ki
      use p18_ddbar_neepscbar_globalsl1, only: epspow
      use p18_ddbar_neepscbar_kinematics
      use p18_ddbar_neepscbar_abbrevd3h0
      implicit none

      real(ki_gol), dimension(0:3), intent(in) :: Q_ext
      real(ki_gol), intent(in) :: mu2_ext
      complex(ki_gol) :: numerator
      complex(ki) :: d3
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11
      complex(ki) :: t12

      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      Q(:) = cmplx(real(+Q_ext(:), ki_gol), 0.0_ki_gol, ki)
      d3 = 0.0_ki
      t1 = (Q(1)*k6(1)-Q(2)*k6(2)-Q(3)*k6(3)-Q(4)*k6(4))
      t2 = (Q(1)*Q(1)-Q(2)*Q(2)-Q(3)*Q(3)-Q(4)*Q(4))
      t3 = (Q(1)*k5(1)-Q(2)*k5(2)-Q(3)*k5(3)-Q(4)*k5(4))
      t4 = (Q(1)*spvak1k2(1)-Q(2)*spvak1k2(2)-Q(3)*spvak1k2(3)-Q(4)*spvak1k2(4))
      t5 = (Q(1)*spvak3k4(1)-Q(2)*spvak3k4(2)-Q(3)*spvak3k4(3)-Q(4)*spvak3k4(4))
      t6 = (Q(1)*spvak1k6(1)-Q(2)*spvak1k6(2)-Q(3)*spvak1k6(3)-Q(4)*spvak1k6(4))
      t7 = (Q(1)*k1(1)-Q(2)*k1(2)-Q(3)*k1(3)-Q(4)*k1(4))
      t8 = (Q(1)*k2(1)-Q(2)*k2(2)-Q(3)*k2(3)-Q(4)*k2(4))
      t9 = (Q(1)*spvak2k6(1)-Q(2)*spvak2k6(2)-Q(3)*spvak2k6(3)-Q(4)*spvak2k6(4))
      t10 = (Q(1)*spvak3k6(1)-Q(2)*spvak3k6(2)-Q(3)*spvak3k6(3)-Q(4)*spvak3k6(4)&
      &)
      t11 = (Q(1)*spvak5k6(1)-Q(2)*spvak5k6(2)-Q(3)*spvak5k6(3)-Q(4)*spvak5k6(4)&
      &)
      t12 = (Q(1)*spvak5k4(1)-Q(2)*spvak5k4(2)-Q(3)*spvak5k4(3)-Q(4)*spvak5k4(4)&
      &)
      d3 = (abb3n1+t1*abb3n13+t2*abb3n14+t3*abb3n17+t4*abb3n19+t5*abb3n2+t6*abb3&
      &n24+t7*abb3n4+t8*abb3n4+t9*abb3n9+t1*t10*abb3n12+t1*t12*abb3n5+t1*t4*abb3&
      &n27+t1*t5*abb3n15+t1*t6*abb3n21+t10*t2*abb3n11+t10*t4*abb3n28+t10*t7*abb3&
      &n10+t10*t8*abb3n10+t11*t4*abb3n26+t11*t5*abb3n18+t12*t2*abb3n6+t12*t4*abb&
      &3n20+t12*t7*abb3n7+t12*t8*abb3n7+t2*t5*abb3n16+t2*t6*abb3n22+t3*t4*abb3n2&
      &7+t4*t6*abb3n8+t4*t9*abb3n22+t5*t6*abb3n25+t5*abb3n3*(Q(1)*spvak5k2(1)-Q(&
      &2)*spvak5k2(2)-Q(3)*spvak5k2(3)-Q(4)*spvak5k2(4))+t6*t7*abb3n23+t6*t8*abb&
      &3n23+t11*t4*t5*abb3n29)

      numerator = cmplx(real(d3, ki), aimag(d3), ki_gol)
   end function numerator_golem95
   !------#] function numerator_golem95:
!---#] numerator interfaces:
end module p18_ddbar_neepscbar_d3h0l1
