module     p24_udbar_neepuubar_d35h1l1d
   ! file:      /home/pcl305a/luisonig/Documents/GoSamSherpa/W2jets/1.4/Virtual/
   ! p24_udbar_neepuubar/helicity1/d35h1l1d.f90
   ! generator: haggies (1.1)
   use p24_udbar_neepuubar_config, only: ki
   use p24_udbar_neepuubar_util, only: cond, d => metric_tensor
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   integer, private :: iv0
   integer, private :: iv1
   integer, private :: iv2
   real(ki), dimension(4), private :: qshift


   public :: derivative, reconstruct_d35
contains

!---#[ function derivative:
   function derivative(mu2, i1, i2) result(numerator)
      use p24_udbar_neepuubar_globalsl1, only: epspow
      use p24_udbar_neepuubar_kinematics
      use p24_udbar_neepuubar_abbrevd35h1
      implicit none
      complex(ki), intent(in) :: mu2
      integer, intent(in), optional :: i1
      integer, intent(in), optional :: i2
      complex(ki) :: numerator
      complex(ki) :: loc
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11
      complex(ki) :: t12
      complex(ki) :: t13
      complex(ki) :: t14
      real(ki) :: t15
      real(ki) :: t16
      real(ki) :: t17
      integer :: deg
      complex(ki), dimension(4), parameter :: Q = (/&
        &(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki)/)
      qshift = -k3-k4
      numerator = 0.0_ki
      deg = 0
      if(present(i1)) then
         iv1 = i1
         deg = 1
      else
         iv1 = 1
      end if
      if(present(i2)) then
         iv2 = i2
         deg = 2
      else
         iv2 = 1
      end if
      t1 = (spvak5k6(1)*qshift(1)-spvak5k6(2)*qshift(2)-spvak5k6(3)*qshift(3)-sp&
      &vak5k6(4)*qshift(4))
      t2 = (spvak3k1(1)*qshift(1)-spvak3k1(2)*qshift(2)-spvak3k1(3)*qshift(3)-sp&
      &vak3k1(4)*qshift(4))
      t3 = (spvak2k1(1)*qshift(1)-spvak2k1(2)*qshift(2)-spvak2k1(3)*qshift(3)-sp&
      &vak2k1(4)*qshift(4))
      t4 = (spvak2k4(1)*qshift(1)-spvak2k4(2)*qshift(2)-spvak2k4(3)*qshift(3)-sp&
      &vak2k4(4)*qshift(4))
      t5 = (spvak3k4(1)*qshift(1)-spvak3k4(2)*qshift(2)-spvak3k4(3)*qshift(3)-sp&
      &vak3k4(4)*qshift(4))
      t15 = dotproduct(k1, qshift)
      t16 = dotproduct(k3, qshift)
      t17 = dotproduct(k4, qshift)
      if(deg.eq.0) then
         numerator = (abb35n17+t1*abb35n29+abb35n20*dotproduct(qshift, qshift)+a&
         &bb35n25*(spvak5k4(1)*qshift(1)-spvak5k4(2)*qshift(2)-spvak5k4(3)*qshif&
         &t(3)-spvak5k4(4)*qshift(4))+abb35n26*(spvak2k6(1)*qshift(1)-spvak2k6(2&
         &)*qshift(2)-spvak2k6(3)*qshift(3)-spvak2k6(4)*qshift(4))+abb35n28*dotp&
         &roduct(k5, qshift)+abb35n28*dotproduct(k6, qshift)+abb35n30*(spvak3k6(&
         &1)*qshift(1)-spvak3k6(2)*qshift(2)-spvak3k6(3)*qshift(3)-spvak3k6(4)*q&
         &shift(4))+abb35n31*(spvak5k1(1)*qshift(1)-spvak5k1(2)*qshift(2)-spvak5&
         &k1(3)*qshift(3)-spvak5k1(4)*qshift(4))+t1*t15*abb35n23+t1*t16*abb35n24&
         &+t1*t17*abb35n24+t1*t2*abb35n18+t1*t3*abb35n19+t1*t4*abb35n21+t1*t5*ab&
         &b35n22)
         return
      end if
      t6 = spvak5k6(iv1)
      t7 = k1(iv1)
      t8 = k3(iv1)
      t9 = k4(iv1)
      t10 = spvak2k1(iv1)
      t11 = spvak2k4(iv1)
      t12 = spvak3k1(iv1)
      t13 = spvak3k4(iv1)
      t14 = t6*abb35n24
      if(deg.eq.1) then
         numerator = (k5(iv1)*abb35n28+k6(iv1)*abb35n28+qshift(iv1)*abb35n27+spv&
         &ak2k6(iv1)*abb35n26+spvak3k6(iv1)*abb35n30+spvak5k1(iv1)*abb35n31+spva&
         &k5k4(iv1)*abb35n25+t14*t16+t14*t17+t6*abb35n29+t1*t10*abb35n19+t1*t11*&
         &abb35n21+t1*t12*abb35n18+t1*t13*abb35n22+t1*t7*abb35n23+t1*t8*abb35n24&
         &+t1*t9*abb35n24+t15*t6*abb35n23+t2*t6*abb35n18+t3*t6*abb35n19+t4*t6*ab&
         &b35n21+t5*t6*abb35n22)
         return
      end if
      t1 = spvak5k6(iv2)
      if(deg.eq.2) then
         numerator = ((2.0_ki)*d(iv1,iv2)*abb35n20+k1(iv2)*t6*abb35n23+k3(iv2)*t&
         &6*abb35n24+k4(iv2)*t6*abb35n24+spvak2k1(iv2)*t6*abb35n19+spvak2k4(iv2)&
         &*t6*abb35n21+spvak3k1(iv2)*t6*abb35n18+spvak3k4(iv2)*t6*abb35n22+t1*t1&
         &0*abb35n19+t1*t11*abb35n21+t1*t12*abb35n18+t1*t13*abb35n22+t1*t7*abb35&
         &n23+t1*t8*abb35n24+t1*t9*abb35n24)
         return
      end if
   end function derivative
!---#] function derivative:
!---#[ subroutine reconstruct_d35:
   subroutine     reconstruct_d35(coeffs)
      use p24_udbar_neepuubar_groups, only: tensrec_info_group7
      implicit none
      complex(ki), parameter :: czip = (0.0_ki, 0.0_ki)
      complex(ki), parameter :: cone = (1.0_ki, 0.0_ki)

      type(tensrec_info_group7), intent(out) :: coeffs
      ! rank 2 case:
      !---[# reconstruct coeffs%coeffs_35:
      coeffs%coeffs_35%c0 = derivative(czip)
      coeffs%coeffs_35%c1(1,1) = derivative(czip,1)
      coeffs%coeffs_35%c1(1,2) = derivative(czip,1,1) / 2.0_ki
      coeffs%coeffs_35%c1(2,1) = -derivative(czip,2)
      coeffs%coeffs_35%c1(2,2) = derivative(czip,2,2) / 2.0_ki
      coeffs%coeffs_35%c1(3,1) = -derivative(czip,3)
      coeffs%coeffs_35%c1(3,2) = derivative(czip,3,3) / 2.0_ki
      coeffs%coeffs_35%c1(4,1) = -derivative(czip,4)
      coeffs%coeffs_35%c1(4,2) = derivative(czip,4,4) / 2.0_ki
      coeffs%coeffs_35%c2(1,1) = -derivative(czip,1,2)
      coeffs%coeffs_35%c2(2,1) = -derivative(czip,1,3)
      coeffs%coeffs_35%c2(3,1) = -derivative(czip,1,4)
      coeffs%coeffs_35%c2(4,1) = derivative(czip,2,3)
      coeffs%coeffs_35%c2(5,1) = derivative(czip,2,4)
      coeffs%coeffs_35%c2(6,1) = derivative(czip,3,4)
      !---#] reconstruct coeffs%coeffs_35:
   end subroutine reconstruct_d35
!---#] subroutine reconstruct_d35:
end module p24_udbar_neepuubar_d35h1l1d
