module     p26_udbar_neepgg_d10h0l1d
   ! file:      /home/pcl305a/luisonig/Documents/GoSamSherpa/W2jets/1.4/Virtual/
   ! p26_udbar_neepgg/helicity0/d10h0l1d.f90
   ! generator: haggies (1.1)
   use p26_udbar_neepgg_config, only: ki
   use p26_udbar_neepgg_util, only: cond, d => metric_tensor
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   integer, private :: iv0
   integer, private :: iv1
   integer, private :: iv2
   real(ki), dimension(4), private :: qshift


   public :: derivative, reconstruct_d10
contains

!---#[ function derivative:
   function derivative(mu2, i1, i2) result(numerator)
      use p26_udbar_neepgg_globalsl1, only: epspow
      use p26_udbar_neepgg_kinematics
      use p26_udbar_neepgg_abbrevd10h0
      implicit none
      complex(ki), intent(in) :: mu2
      integer, intent(in), optional :: i1
      integer, intent(in), optional :: i2
      complex(ki) :: numerator
      complex(ki) :: loc
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      integer :: deg
      complex(ki), dimension(4), parameter :: Q = (/&
        &(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki)/)
      qshift(:) = 0.0_ki
      numerator = 0.0_ki
      deg = 0
      if(present(i1)) then
         iv1 = i1
         deg = 1
      else
         iv1 = 1
      end if
      if(present(i2)) then
         iv2 = i2
         deg = 2
      else
         iv2 = 1
      end if
      if(deg.eq.0) then
         numerator = abb10n19
         return
      end if
      t1 = k1(iv1)
      t2 = k5(iv1)
      t3 = spvak3k4(iv1)
      t4 = spvak6k1(iv1)
      t5 = spvak6k5(iv1)
      if(deg.eq.1) then
         numerator = (k2(iv1)*abb10n30+spvak2k4(iv1)*abb10n28+spvak2k6(iv1)*abb1&
         &0n34+t1*abb10n33+t2*abb10n32+t3*abb10n27+t4*abb10n29+t5*abb10n31)
         return
      end if
      t6 = spvak3k4(iv2)
      if(deg.eq.2) then
         numerator = ((2.0_ki)*d(iv1,iv2)*abb10n22+k1(iv2)*t3*abb10n25+k5(iv2)*t&
         &3*abb10n26+spvak2k1(iv1)*t6*abb10n23+spvak2k1(iv2)*t3*abb10n23+spvak2k&
         &5(iv1)*t6*abb10n20+spvak2k5(iv2)*t3*abb10n20+spvak6k1(iv2)*t3*abb10n24&
         &+spvak6k5(iv2)*t3*abb10n21+t1*t6*abb10n25+t2*t6*abb10n26+t4*t6*abb10n2&
         &4+t5*t6*abb10n21)
         return
      end if
   end function derivative
!---#] function derivative:
!---#[ subroutine reconstruct_d10:
   subroutine     reconstruct_d10(coeffs)
      use p26_udbar_neepgg_groups, only: tensrec_info_group2
      implicit none
      complex(ki), parameter :: czip = (0.0_ki, 0.0_ki)
      complex(ki), parameter :: cone = (1.0_ki, 0.0_ki)

      type(tensrec_info_group2), intent(out) :: coeffs
      ! rank 2 case:
      !---[# reconstruct coeffs%coeffs_10:
      coeffs%coeffs_10%c0 = derivative(czip)
      coeffs%coeffs_10%c1(1,1) = derivative(czip,1)
      coeffs%coeffs_10%c1(1,2) = derivative(czip,1,1) / 2.0_ki
      coeffs%coeffs_10%c1(2,1) = -derivative(czip,2)
      coeffs%coeffs_10%c1(2,2) = derivative(czip,2,2) / 2.0_ki
      coeffs%coeffs_10%c1(3,1) = -derivative(czip,3)
      coeffs%coeffs_10%c1(3,2) = derivative(czip,3,3) / 2.0_ki
      coeffs%coeffs_10%c1(4,1) = -derivative(czip,4)
      coeffs%coeffs_10%c1(4,2) = derivative(czip,4,4) / 2.0_ki
      coeffs%coeffs_10%c2(1,1) = -derivative(czip,1,2)
      coeffs%coeffs_10%c2(2,1) = -derivative(czip,1,3)
      coeffs%coeffs_10%c2(3,1) = -derivative(czip,1,4)
      coeffs%coeffs_10%c2(4,1) = derivative(czip,2,3)
      coeffs%coeffs_10%c2(5,1) = derivative(czip,2,4)
      coeffs%coeffs_10%c2(6,1) = derivative(czip,3,4)
      !---#] reconstruct coeffs%coeffs_10:
   end subroutine reconstruct_d10
!---#] subroutine reconstruct_d10:
end module p26_udbar_neepgg_d10h0l1d
