module     p26_udbar_neepgg_d11h0l1d
   ! file:      /home/pcl305a/luisonig/Documents/GoSamSherpa/W2jets/1.4/Virtual/
   ! p26_udbar_neepgg/helicity0/d11h0l1d.f90
   ! generator: haggies (1.1)
   use p26_udbar_neepgg_config, only: ki
   use p26_udbar_neepgg_util, only: cond, d => metric_tensor
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   integer, private :: iv0
   integer, private :: iv1
   integer, private :: iv2
   real(ki), dimension(4), private :: qshift


   public :: derivative, reconstruct_d11
contains

!---#[ function derivative:
   function derivative(mu2, i1, i2) result(numerator)
      use p26_udbar_neepgg_globalsl1, only: epspow
      use p26_udbar_neepgg_kinematics
      use p26_udbar_neepgg_abbrevd11h0
      implicit none
      complex(ki), intent(in) :: mu2
      integer, intent(in), optional :: i1
      integer, intent(in), optional :: i2
      complex(ki) :: numerator
      complex(ki) :: loc
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11
      complex(ki) :: t12
      real(ki) :: t13
      real(ki) :: t14
      integer :: deg
      complex(ki), dimension(4), parameter :: Q = (/&
        &(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki)/)
      qshift = -k5
      numerator = 0.0_ki
      deg = 0
      if(present(i1)) then
         iv1 = i1
         deg = 1
      else
         iv1 = 1
      end if
      if(present(i2)) then
         iv2 = i2
         deg = 2
      else
         iv2 = 1
      end if
      t1 = (spvak3k4(1)*qshift(1)-spvak3k4(2)*qshift(2)-spvak3k4(3)*qshift(3)-sp&
      &vak3k4(4)*qshift(4))
      t2 = (spvak5k1(1)*qshift(1)-spvak5k1(2)*qshift(2)-spvak5k1(3)*qshift(3)-sp&
      &vak5k1(4)*qshift(4))
      t13 = dotproduct(k6, qshift)
      t14 = dotproduct(k1, qshift)
      t3 = (spvak5k6(1)*qshift(1)-spvak5k6(2)*qshift(2)-spvak5k6(3)*qshift(3)-sp&
      &vak5k6(4)*qshift(4))
      t4 = (spvak2k6(1)*qshift(1)-spvak2k6(2)*qshift(2)-spvak2k6(3)*qshift(3)-sp&
      &vak2k6(4)*qshift(4))
      t5 = (spvak2k1(1)*qshift(1)-spvak2k1(2)*qshift(2)-spvak2k1(3)*qshift(3)-sp&
      &vak2k1(4)*qshift(4))
      if(deg.eq.0) then
         numerator = (abb11n19+t1*abb11n27+t13*abb11n32+t14*abb11n33+t2*abb11n29&
         &+t3*abb11n34+abb11n22*dotproduct(qshift, qshift)+abb11n28*(spvak2k4(1)&
         &*qshift(1)-spvak2k4(2)*qshift(2)-spvak2k4(3)*qshift(3)-spvak2k4(4)*qsh&
         &ift(4))+abb11n31*dotproduct(k2, qshift)+abb11n35*(spvak2k5(1)*qshift(1&
         &)-spvak2k5(2)*qshift(2)-spvak2k5(3)*qshift(3)-spvak2k5(4)*qshift(4))+t&
         &1*t13*abb11n25+t1*t14*abb11n26+t1*t2*abb11n24+t1*t3*abb11n21+t1*t4*abb&
         &11n20+t1*t5*abb11n23)
         return
      end if
      t6 = k1(iv1)
      t7 = k6(iv1)
      t8 = spvak3k4(iv1)
      t9 = spvak5k1(iv1)
      t10 = spvak5k6(iv1)
      t11 = spvak2k1(iv1)
      t12 = spvak2k6(iv1)
      if(deg.eq.1) then
         numerator = (k2(iv1)*abb11n31+qshift(iv1)*abb11n30+spvak2k4(iv1)*abb11n&
         &28+spvak2k5(iv1)*abb11n35+t10*abb11n34+t6*abb11n33+t7*abb11n32+t8*abb1&
         &1n27+t9*abb11n29+t1*t10*abb11n21+t1*t11*abb11n23+t1*t12*abb11n20+t1*t6&
         &*abb11n26+t1*t7*abb11n25+t1*t9*abb11n24+t13*t8*abb11n25+t14*t8*abb11n2&
         &6+t2*t8*abb11n24+t3*t8*abb11n21+t4*t8*abb11n20+t5*t8*abb11n23)
         return
      end if
      t1 = spvak3k4(iv2)
      if(deg.eq.2) then
         numerator = ((2.0_ki)*d(iv1,iv2)*abb11n22+k1(iv2)*t8*abb11n26+k6(iv2)*t&
         &8*abb11n25+spvak2k1(iv2)*t8*abb11n23+spvak2k6(iv2)*t8*abb11n20+spvak5k&
         &1(iv2)*t8*abb11n24+spvak5k6(iv2)*t8*abb11n21+t1*t10*abb11n21+t1*t11*ab&
         &b11n23+t1*t12*abb11n20+t1*t6*abb11n26+t1*t7*abb11n25+t1*t9*abb11n24)
         return
      end if
   end function derivative
!---#] function derivative:
!---#[ subroutine reconstruct_d11:
   subroutine     reconstruct_d11(coeffs)
      use p26_udbar_neepgg_groups, only: tensrec_info_group3
      implicit none
      complex(ki), parameter :: czip = (0.0_ki, 0.0_ki)
      complex(ki), parameter :: cone = (1.0_ki, 0.0_ki)

      type(tensrec_info_group3), intent(out) :: coeffs
      ! rank 2 case:
      !---[# reconstruct coeffs%coeffs_11:
      coeffs%coeffs_11%c0 = derivative(czip)
      coeffs%coeffs_11%c1(1,1) = derivative(czip,1)
      coeffs%coeffs_11%c1(1,2) = derivative(czip,1,1) / 2.0_ki
      coeffs%coeffs_11%c1(2,1) = -derivative(czip,2)
      coeffs%coeffs_11%c1(2,2) = derivative(czip,2,2) / 2.0_ki
      coeffs%coeffs_11%c1(3,1) = -derivative(czip,3)
      coeffs%coeffs_11%c1(3,2) = derivative(czip,3,3) / 2.0_ki
      coeffs%coeffs_11%c1(4,1) = -derivative(czip,4)
      coeffs%coeffs_11%c1(4,2) = derivative(czip,4,4) / 2.0_ki
      coeffs%coeffs_11%c2(1,1) = -derivative(czip,1,2)
      coeffs%coeffs_11%c2(2,1) = -derivative(czip,1,3)
      coeffs%coeffs_11%c2(3,1) = -derivative(czip,1,4)
      coeffs%coeffs_11%c2(4,1) = derivative(czip,2,3)
      coeffs%coeffs_11%c2(5,1) = derivative(czip,2,4)
      coeffs%coeffs_11%c2(6,1) = derivative(czip,3,4)
      !---#] reconstruct coeffs%coeffs_11:
   end subroutine reconstruct_d11
!---#] subroutine reconstruct_d11:
end module p26_udbar_neepgg_d11h0l1d
