module     p26_udbar_neepgg_d91h0l1
   ! file:      /home/pcl305a/luisonig/Documents/GoSamSherpa/W2jets/1.4/Virtual/
   ! p26_udbar_neepgg/helicity0/d91h0l1.f90
   ! generator: haggies (1.1)
   use p26_udbar_neepgg_config, only: ki
   use p26_udbar_neepgg_util, only: cond
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   public :: numerator_samurai
   public :: numerator_golem95
contains
!---#[ numerator interfaces:
   !------#[ function numerator_samurai:
   function numerator_samurai(ncut,Q_ext, mu2_ext) result(numerator)
      use precision, only: ki_sam => ki
!      use p26_udbar_neepgg_groups, only: &
!           & sign => diagram91_sign, shift => diagram91_shift
      use p26_udbar_neepgg_globalsl1, only: epspow
      use p26_udbar_neepgg_kinematics
      use p26_udbar_neepgg_abbrevd91h0
      implicit none

      integer, intent(in) :: ncut
      complex(ki_sam), dimension(4), intent(in) :: Q_ext
      complex(ki_sam), intent(in) :: mu2_ext
      complex(ki_sam) :: numerator
      complex(ki) :: d91
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11
      complex(ki) :: t12
      complex(ki) :: t13
      complex(ki) :: t14

      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q

      Q(1)   = cmplx(real(+Q_ext(4),   ki_sam), aimag(+Q_ext(4)),   ki)
      Q(2:4) = cmplx(real(+Q_ext(1:3), ki_sam), aimag(+Q_ext(1:3)), ki)
      d91 = 0.0_ki
      t1 = (Q(1)*spvak6k5(1)-Q(2)*spvak6k5(2)-Q(3)*spvak6k5(3)-Q(4)*spvak6k5(4))
      t2 = (Q(1)*spvak2k1(1)-Q(2)*spvak2k1(2)-Q(3)*spvak2k1(3)-Q(4)*spvak2k1(4))
      t3 = (Q(1)*k5(1)-Q(2)*k5(2)-Q(3)*k5(3)-Q(4)*k5(4))
      t4 = (Q(1)*spvak3k4(1)-Q(2)*spvak3k4(2)-Q(3)*spvak3k4(3)-Q(4)*spvak3k4(4))
      t5 = (Q(1)*spvak3k1(1)-Q(2)*spvak3k1(2)-Q(3)*spvak3k1(3)-Q(4)*spvak3k1(4))
      t6 = (Q(1)*Q(1)-Q(2)*Q(2)-Q(3)*Q(3)-Q(4)*Q(4))
      t7 = (Q(1)*spvak2k6(1)-Q(2)*spvak2k6(2)-Q(3)*spvak2k6(3)-Q(4)*spvak2k6(4))
      t8 = (Q(1)*k2(1)-Q(2)*k2(2)-Q(3)*k2(3)-Q(4)*k2(4))
      t9 = (Q(1)*spvak6k1(1)-Q(2)*spvak6k1(2)-Q(3)*spvak6k1(3)-Q(4)*spvak6k1(4))
      t10 = (Q(1)*spvak5k1(1)-Q(2)*spvak5k1(2)-Q(3)*spvak5k1(3)-Q(4)*spvak5k1(4)&
      &)
      t11 = (Q(1)*spvak5k6(1)-Q(2)*spvak5k6(2)-Q(3)*spvak5k6(3)-Q(4)*spvak5k6(4)&
      &)
      t12 = (Q(1)*k6(1)-Q(2)*k6(2)-Q(3)*k6(3)-Q(4)*k6(4))
      t13 = (Q(1)*spvak2k5(1)-Q(2)*spvak2k5(2)-Q(3)*spvak2k5(3)-Q(4)*spvak2k5(4)&
      &)
      t14 = t6*abb91n43
      d91 = (t1*abb91n1+t12*t14+t14*t8+t2*abb91n10+t3*abb91n2+t4*abb91n3+t5*abb9&
      &1n4+t6*abb91n8+t6*t6*abb91n42+t7*abb91n5+t8*abb91n9+t1*t10*abb91n12+t1*t1&
      &1*abb91n17+t1*t2*abb91n51+t1*t4*abb91n22+t1*t5*abb91n25+t1*t6*abb91n44+t1&
      &*t7*abb91n29+t1*t8*abb91n45+t10*t4*abb91n15+t11*t12*abb91n16+t11*t13*abb9&
      &1n27+t11*t2*abb91n48+t11*t3*abb91n16+t11*t4*abb91n18+t11*t5*abb91n21+t11*&
      &t6*abb91n37+t11*t8*abb91n36+t12*t2*abb91n50+t12*t4*abb91n19+t12*t5*abb91n&
      &24+t12*t7*abb91n28+t12*t8*abb91n41+t2*t6*abb91n49+t3*t5*abb91n14+t3*t7*ab&
      &b91n6+t3*t9*abb91n11+t4*t6*abb91n20+t4*t7*abb91n7+t4*t9*abb91n13+t5*t6*ab&
      &b91n23+t6*t7*abb91n26+t1*t10*t11*abb91n52+t1*t11*t13*abb91n33+t1*t11*t2*a&
      &bb91n47+t1*t11*t5*abb91n59+t1*t11*t6*abb91n32+t1*t11*t7*abb91n35+t1*t11*t&
      &8*abb91n31+t1*t11*t9*abb91n54+t1*t11*abb91n30*(Q(1)*spvak2k4(1)-Q(2)*spva&
      &k2k4(2)-Q(3)*spvak2k4(3)-Q(4)*spvak2k4(4))+t1*t4*t7*abb91n46+t10*t12*t4*a&
      &bb91n61+t10*t4*t6*abb91n60+t11*t12*t13*abb91n34+t11*t12*t5*abb91n57+t11*t&
      &12*t9*abb91n53+t11*t13*t3*abb91n34+t11*t13*t4*abb91n39+t11*t13*t6*abb91n3&
      &5+t11*t3*t5*abb91n57+t11*t3*t9*abb91n53+t11*t5*t6*abb91n58+t11*t6*t9*abb9&
      &1n52+t12*t4*t7*abb91n40+t12*t4*t9*abb91n55+t4*t6*t7*abb91n38+t4*t6*t9*abb&
      &91n56+t1*t11*t2*t4*abb91n62)
      numerator = cmplx(real(d91, ki), aimag(d91), ki_sam)
   end function numerator_samurai
   !------#] function numerator_samurai:
   !------#[ function numerator_golem95:
   function numerator_golem95(Q_ext, mu2_ext) result(numerator)
      use precision_golem, only: ki_gol => ki
      use p26_udbar_neepgg_globalsl1, only: epspow
      use p26_udbar_neepgg_kinematics
      use p26_udbar_neepgg_abbrevd91h0
      implicit none

      real(ki_gol), dimension(0:3), intent(in) :: Q_ext
      real(ki_gol), intent(in) :: mu2_ext
      complex(ki_gol) :: numerator
      complex(ki) :: d91
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11
      complex(ki) :: t12
      complex(ki) :: t13
      complex(ki) :: t14

      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      Q(:) = cmplx(real(+Q_ext(:), ki_gol), 0.0_ki_gol, ki)
      d91 = 0.0_ki
      t1 = (Q(1)*spvak6k5(1)-Q(2)*spvak6k5(2)-Q(3)*spvak6k5(3)-Q(4)*spvak6k5(4))
      t2 = (Q(1)*spvak2k1(1)-Q(2)*spvak2k1(2)-Q(3)*spvak2k1(3)-Q(4)*spvak2k1(4))
      t3 = (Q(1)*k5(1)-Q(2)*k5(2)-Q(3)*k5(3)-Q(4)*k5(4))
      t4 = (Q(1)*spvak3k4(1)-Q(2)*spvak3k4(2)-Q(3)*spvak3k4(3)-Q(4)*spvak3k4(4))
      t5 = (Q(1)*spvak3k1(1)-Q(2)*spvak3k1(2)-Q(3)*spvak3k1(3)-Q(4)*spvak3k1(4))
      t6 = (Q(1)*Q(1)-Q(2)*Q(2)-Q(3)*Q(3)-Q(4)*Q(4))
      t7 = (Q(1)*spvak2k6(1)-Q(2)*spvak2k6(2)-Q(3)*spvak2k6(3)-Q(4)*spvak2k6(4))
      t8 = (Q(1)*k2(1)-Q(2)*k2(2)-Q(3)*k2(3)-Q(4)*k2(4))
      t9 = (Q(1)*spvak6k1(1)-Q(2)*spvak6k1(2)-Q(3)*spvak6k1(3)-Q(4)*spvak6k1(4))
      t10 = (Q(1)*spvak5k1(1)-Q(2)*spvak5k1(2)-Q(3)*spvak5k1(3)-Q(4)*spvak5k1(4)&
      &)
      t11 = (Q(1)*spvak5k6(1)-Q(2)*spvak5k6(2)-Q(3)*spvak5k6(3)-Q(4)*spvak5k6(4)&
      &)
      t12 = (Q(1)*k6(1)-Q(2)*k6(2)-Q(3)*k6(3)-Q(4)*k6(4))
      t13 = (Q(1)*spvak2k5(1)-Q(2)*spvak2k5(2)-Q(3)*spvak2k5(3)-Q(4)*spvak2k5(4)&
      &)
      t14 = t6*abb91n43
      d91 = (t1*abb91n1+t12*t14+t14*t8+t2*abb91n10+t3*abb91n2+t4*abb91n3+t5*abb9&
      &1n4+t6*abb91n8+t6*t6*abb91n42+t7*abb91n5+t8*abb91n9+t1*t10*abb91n12+t1*t1&
      &1*abb91n17+t1*t2*abb91n51+t1*t4*abb91n22+t1*t5*abb91n25+t1*t6*abb91n44+t1&
      &*t7*abb91n29+t1*t8*abb91n45+t10*t4*abb91n15+t11*t12*abb91n16+t11*t13*abb9&
      &1n27+t11*t2*abb91n48+t11*t3*abb91n16+t11*t4*abb91n18+t11*t5*abb91n21+t11*&
      &t6*abb91n37+t11*t8*abb91n36+t12*t2*abb91n50+t12*t4*abb91n19+t12*t5*abb91n&
      &24+t12*t7*abb91n28+t12*t8*abb91n41+t2*t6*abb91n49+t3*t5*abb91n14+t3*t7*ab&
      &b91n6+t3*t9*abb91n11+t4*t6*abb91n20+t4*t7*abb91n7+t4*t9*abb91n13+t5*t6*ab&
      &b91n23+t6*t7*abb91n26+t1*t10*t11*abb91n52+t1*t11*t13*abb91n33+t1*t11*t2*a&
      &bb91n47+t1*t11*t5*abb91n59+t1*t11*t6*abb91n32+t1*t11*t7*abb91n35+t1*t11*t&
      &8*abb91n31+t1*t11*t9*abb91n54+t1*t11*abb91n30*(Q(1)*spvak2k4(1)-Q(2)*spva&
      &k2k4(2)-Q(3)*spvak2k4(3)-Q(4)*spvak2k4(4))+t1*t4*t7*abb91n46+t10*t12*t4*a&
      &bb91n61+t10*t4*t6*abb91n60+t11*t12*t13*abb91n34+t11*t12*t5*abb91n57+t11*t&
      &12*t9*abb91n53+t11*t13*t3*abb91n34+t11*t13*t4*abb91n39+t11*t13*t6*abb91n3&
      &5+t11*t3*t5*abb91n57+t11*t3*t9*abb91n53+t11*t5*t6*abb91n58+t11*t6*t9*abb9&
      &1n52+t12*t4*t7*abb91n40+t12*t4*t9*abb91n55+t4*t6*t7*abb91n38+t4*t6*t9*abb&
      &91n56+t1*t11*t2*t4*abb91n62)

      numerator = cmplx(real(d91, ki), aimag(d91), ki_gol)
   end function numerator_golem95
   !------#] function numerator_golem95:
!---#] numerator interfaces:
end module p26_udbar_neepgg_d91h0l1
