module     p26_udbar_neepgg_d99h0l1
   ! file:      /home/pcl305a/luisonig/Documents/GoSamSherpa/W2jets/1.4/Virtual/
   ! p26_udbar_neepgg/helicity0/d99h0l1.f90
   ! generator: haggies (1.1)
   use p26_udbar_neepgg_config, only: ki
   use p26_udbar_neepgg_util, only: cond
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   public :: numerator_samurai
   public :: numerator_golem95
contains
!---#[ numerator interfaces:
   !------#[ function numerator_samurai:
   function numerator_samurai(ncut,Q_ext, mu2_ext) result(numerator)
      use precision, only: ki_sam => ki
!      use p26_udbar_neepgg_groups, only: &
!           & sign => diagram99_sign, shift => diagram99_shift
      use p26_udbar_neepgg_globalsl1, only: epspow
      use p26_udbar_neepgg_kinematics
      use p26_udbar_neepgg_abbrevd99h0
      implicit none

      integer, intent(in) :: ncut
      complex(ki_sam), dimension(4), intent(in) :: Q_ext
      complex(ki_sam), intent(in) :: mu2_ext
      complex(ki_sam) :: numerator
      complex(ki) :: d99
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11
      complex(ki) :: t12
      complex(ki) :: t13
      complex(ki) :: t14

      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q

      Q(1)   = cmplx(real(-Q_ext(4),   ki_sam), aimag(-Q_ext(4)),   ki)
      Q(2:4) = cmplx(real(-Q_ext(1:3), ki_sam), aimag(-Q_ext(1:3)), ki)
      d99 = 0.0_ki
      t1 = (Q(1)*spvak5k6(1)-Q(2)*spvak5k6(2)-Q(3)*spvak5k6(3)-Q(4)*spvak5k6(4))
      t2 = (Q(1)*spvak6k5(1)-Q(2)*spvak6k5(2)-Q(3)*spvak6k5(3)-Q(4)*spvak6k5(4))
      t3 = (Q(1)*k5(1)-Q(2)*k5(2)-Q(3)*k5(3)-Q(4)*k5(4))
      t4 = (Q(1)*k3(1)-Q(2)*k3(2)-Q(3)*k3(3)-Q(4)*k3(4))
      t5 = (Q(1)*k4(1)-Q(2)*k4(2)-Q(3)*k4(3)-Q(4)*k4(4))
      t6 = (Q(1)*k1(1)-Q(2)*k1(2)-Q(3)*k1(3)-Q(4)*k1(4))
      t7 = (Q(1)*spvak3k4(1)-Q(2)*spvak3k4(2)-Q(3)*spvak3k4(3)-Q(4)*spvak3k4(4))
      t8 = (Q(1)*spvak2k6(1)-Q(2)*spvak2k6(2)-Q(3)*spvak2k6(3)-Q(4)*spvak2k6(4))
      t9 = (Q(1)*spvak3k1(1)-Q(2)*spvak3k1(2)-Q(3)*spvak3k1(3)-Q(4)*spvak3k1(4))
      t10 = (Q(1)*k6(1)-Q(2)*k6(2)-Q(3)*k6(3)-Q(4)*k6(4))
      t11 = (Q(1)*k2(1)-Q(2)*k2(2)-Q(3)*k2(3)-Q(4)*k2(4))
      t12 = (Q(1)*Q(1)-Q(2)*Q(2)-Q(3)*Q(3)-Q(4)*Q(4))
      t13 = t11*abb99n3
      t14 = t12*abb99n43
      d99 = (abb99n1+t1*abb99n19+t10*abb99n5+t11*abb99n6+t12*abb99n8+t13*t4+t13*&
      &t5+t14*t4+t14*t5+t2*abb99n27+t3*abb99n28+t4*abb99n29+t5*abb99n29+t6*abb99&
      &n30+t7*abb99n31+t8*abb99n32+t9*abb99n33+t1*t10*abb99n39+t1*t11*abb99n20+t&
      &1*t12*abb99n38+t1*t2*abb99n41+t1*t3*abb99n40+t1*t4*abb99n21+t1*t5*abb99n2&
      &1+t1*t6*abb99n22+t1*t7*abb99n23+t1*t9*abb99n26+t1*abb99n49*(Q(1)*spvak2k5&
      &(1)-Q(2)*spvak2k5(2)-Q(3)*spvak2k5(3)-Q(4)*spvak2k5(4))+t10*t2*abb99n12+t&
      &10*t4*abb99n42+t10*t5*abb99n42+t10*t6*abb99n45+t10*t7*abb99n47+t10*t8*abb&
      &99n48+t10*t9*abb99n54+t11*t2*abb99n9+t11*t6*abb99n2+t11*t7*abb99n4+t11*t9&
      &*abb99n7+t12*t2*abb99n10+t12*t6*abb99n44+t12*t7*abb99n46+t12*t8*abb99n49+&
      &t12*t9*abb99n53+t2*t3*abb99n11+t2*t4*abb99n14+t2*t5*abb99n14+t2*t6*abb99n&
      &13+t2*t7*abb99n17+t2*t8*abb99n50+t2*t9*abb99n24+t3*t4*abb99n15+t3*t5*abb9&
      &9n15+t3*t6*abb99n16+t3*t7*abb99n18+t3*t9*abb99n25+t1*t2*t4*abb99n36+t1*t2&
      &*t5*abb99n36+t1*t2*t6*abb99n35+t1*t2*t7*abb99n37+t1*t2*t9*abb99n52+t1*t2*&
      &abb99n34*(Q(1)*spvak2k1(1)-Q(2)*spvak2k1(2)-Q(3)*spvak2k1(3)-Q(4)*spvak2k&
      &1(4))+t1*t2*abb99n51*(Q(1)*spvak2k4(1)-Q(2)*spvak2k4(2)-Q(3)*spvak2k4(3)-&
      &Q(4)*spvak2k4(4)))
      numerator = cmplx(real(d99, ki), aimag(d99), ki_sam)
   end function numerator_samurai
   !------#] function numerator_samurai:
   !------#[ function numerator_golem95:
   function numerator_golem95(Q_ext, mu2_ext) result(numerator)
      use precision_golem, only: ki_gol => ki
      use p26_udbar_neepgg_globalsl1, only: epspow
      use p26_udbar_neepgg_kinematics
      use p26_udbar_neepgg_abbrevd99h0
      implicit none

      real(ki_gol), dimension(0:3), intent(in) :: Q_ext
      real(ki_gol), intent(in) :: mu2_ext
      complex(ki_gol) :: numerator
      complex(ki) :: d99
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11
      complex(ki) :: t12
      complex(ki) :: t13
      complex(ki) :: t14

      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      Q(:) = cmplx(real(-Q_ext(:), ki_gol), 0.0_ki_gol, ki)
      d99 = 0.0_ki
      t1 = (Q(1)*spvak5k6(1)-Q(2)*spvak5k6(2)-Q(3)*spvak5k6(3)-Q(4)*spvak5k6(4))
      t2 = (Q(1)*spvak6k5(1)-Q(2)*spvak6k5(2)-Q(3)*spvak6k5(3)-Q(4)*spvak6k5(4))
      t3 = (Q(1)*k5(1)-Q(2)*k5(2)-Q(3)*k5(3)-Q(4)*k5(4))
      t4 = (Q(1)*k3(1)-Q(2)*k3(2)-Q(3)*k3(3)-Q(4)*k3(4))
      t5 = (Q(1)*k4(1)-Q(2)*k4(2)-Q(3)*k4(3)-Q(4)*k4(4))
      t6 = (Q(1)*k1(1)-Q(2)*k1(2)-Q(3)*k1(3)-Q(4)*k1(4))
      t7 = (Q(1)*spvak3k4(1)-Q(2)*spvak3k4(2)-Q(3)*spvak3k4(3)-Q(4)*spvak3k4(4))
      t8 = (Q(1)*spvak2k6(1)-Q(2)*spvak2k6(2)-Q(3)*spvak2k6(3)-Q(4)*spvak2k6(4))
      t9 = (Q(1)*spvak3k1(1)-Q(2)*spvak3k1(2)-Q(3)*spvak3k1(3)-Q(4)*spvak3k1(4))
      t10 = (Q(1)*k6(1)-Q(2)*k6(2)-Q(3)*k6(3)-Q(4)*k6(4))
      t11 = (Q(1)*k2(1)-Q(2)*k2(2)-Q(3)*k2(3)-Q(4)*k2(4))
      t12 = (Q(1)*Q(1)-Q(2)*Q(2)-Q(3)*Q(3)-Q(4)*Q(4))
      t13 = t11*abb99n3
      t14 = t12*abb99n43
      d99 = (abb99n1+t1*abb99n19+t10*abb99n5+t11*abb99n6+t12*abb99n8+t13*t4+t13*&
      &t5+t14*t4+t14*t5+t2*abb99n27+t3*abb99n28+t4*abb99n29+t5*abb99n29+t6*abb99&
      &n30+t7*abb99n31+t8*abb99n32+t9*abb99n33+t1*t10*abb99n39+t1*t11*abb99n20+t&
      &1*t12*abb99n38+t1*t2*abb99n41+t1*t3*abb99n40+t1*t4*abb99n21+t1*t5*abb99n2&
      &1+t1*t6*abb99n22+t1*t7*abb99n23+t1*t9*abb99n26+t1*abb99n49*(Q(1)*spvak2k5&
      &(1)-Q(2)*spvak2k5(2)-Q(3)*spvak2k5(3)-Q(4)*spvak2k5(4))+t10*t2*abb99n12+t&
      &10*t4*abb99n42+t10*t5*abb99n42+t10*t6*abb99n45+t10*t7*abb99n47+t10*t8*abb&
      &99n48+t10*t9*abb99n54+t11*t2*abb99n9+t11*t6*abb99n2+t11*t7*abb99n4+t11*t9&
      &*abb99n7+t12*t2*abb99n10+t12*t6*abb99n44+t12*t7*abb99n46+t12*t8*abb99n49+&
      &t12*t9*abb99n53+t2*t3*abb99n11+t2*t4*abb99n14+t2*t5*abb99n14+t2*t6*abb99n&
      &13+t2*t7*abb99n17+t2*t8*abb99n50+t2*t9*abb99n24+t3*t4*abb99n15+t3*t5*abb9&
      &9n15+t3*t6*abb99n16+t3*t7*abb99n18+t3*t9*abb99n25+t1*t2*t4*abb99n36+t1*t2&
      &*t5*abb99n36+t1*t2*t6*abb99n35+t1*t2*t7*abb99n37+t1*t2*t9*abb99n52+t1*t2*&
      &abb99n34*(Q(1)*spvak2k1(1)-Q(2)*spvak2k1(2)-Q(3)*spvak2k1(3)-Q(4)*spvak2k&
      &1(4))+t1*t2*abb99n51*(Q(1)*spvak2k4(1)-Q(2)*spvak2k4(2)-Q(3)*spvak2k4(3)-&
      &Q(4)*spvak2k4(4)))

      numerator = cmplx(real(d99, ki), aimag(d99), ki_gol)
   end function numerator_golem95
   !------#] function numerator_golem95:
!---#] numerator interfaces:
end module p26_udbar_neepgg_d99h0l1
