module     p26_udbar_neepgg_d107h1l1
   ! file:      /home/pcl305a/luisonig/Documents/GoSamSherpa/W2jets/1.4/Virtual/
   ! p26_udbar_neepgg/helicity1/d107h1l1.f90
   ! generator: haggies (1.1)
   use p26_udbar_neepgg_config, only: ki
   use p26_udbar_neepgg_util, only: cond
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   public :: numerator_samurai
   public :: numerator_golem95
contains
!---#[ numerator interfaces:
   !------#[ function numerator_samurai:
   function numerator_samurai(ncut,Q_ext, mu2_ext) result(numerator)
      use precision, only: ki_sam => ki
!      use p26_udbar_neepgg_groups, only: &
!           & sign => diagram107_sign, shift => diagram107_shift
      use p26_udbar_neepgg_globalsl1, only: epspow
      use p26_udbar_neepgg_kinematics
      use p26_udbar_neepgg_abbrevd107h1
      implicit none

      integer, intent(in) :: ncut
      complex(ki_sam), dimension(4), intent(in) :: Q_ext
      complex(ki_sam), intent(in) :: mu2_ext
      complex(ki_sam) :: numerator
      complex(ki) :: d107
      complex(ki) :: t1
      complex(ki) :: t2

      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      real(ki), dimension(0:3) :: qshift

      qshift = k5
      Q(1)   = cmplx(real(+Q_ext(4) - qshift(0),   ki_sam), aimag(+Q_ext(4)),   &
      &ki)
      Q(2:4) = cmplx(real(+Q_ext(1:3) - qshift(1:3), ki_sam), aimag(+Q_ext(1:3))&
      &, ki)
      d107 = 0.0_ki
      t1 = (Q(1)*spvak5k6(1)-Q(2)*spvak5k6(2)-Q(3)*spvak5k6(3)-Q(4)*spvak5k6(4))
      t2 = t1*t1
      d107 = (t1*abb107n7+t2*abb107n1+t1*abb107n11*(Q(1)*spvak2k6(1)-Q(2)*spvak2&
      &k6(2)-Q(3)*spvak2k6(3)-Q(4)*spvak2k6(4))+t1*abb107n12*(Q(1)*k6(1)-Q(2)*k6&
      &(2)-Q(3)*k6(3)-Q(4)*k6(4))+t1*abb107n13*(Q(1)*k5(1)-Q(2)*k5(2)-Q(3)*k5(3)&
      &-Q(4)*k5(4))+t1*abb107n14*(Q(1)*spvak3k6(1)-Q(2)*spvak3k6(2)-Q(3)*spvak3k&
      &6(3)-Q(4)*spvak3k6(4))+t1*abb107n15*(Q(1)*spvak5k1(1)-Q(2)*spvak5k1(2)-Q(&
      &3)*spvak5k1(3)-Q(4)*spvak5k1(4))+t1*abb107n6*(Q(1)*spvak5k4(1)-Q(2)*spvak&
      &5k4(2)-Q(3)*spvak5k4(3)-Q(4)*spvak5k4(4))+t1*abb107n8*(Q(1)*Q(1)-Q(2)*Q(2&
      &)-Q(3)*Q(3)-Q(4)*Q(4))+t2*abb107n10*(Q(1)*spvak3k1(1)-Q(2)*spvak3k1(2)-Q(&
      &3)*spvak3k1(3)-Q(4)*spvak3k1(4))+t2*abb107n2*(Q(1)*k1(1)-Q(2)*k1(2)-Q(3)*&
      &k1(3)-Q(4)*k1(4))+t2*abb107n3*(Q(1)*k3(1)-Q(2)*k3(2)-Q(3)*k3(3)-Q(4)*k3(4&
      &))+t2*abb107n3*(Q(1)*k4(1)-Q(2)*k4(2)-Q(3)*k4(3)-Q(4)*k4(4))+t2*abb107n4*&
      &(Q(1)*spvak3k4(1)-Q(2)*spvak3k4(2)-Q(3)*spvak3k4(3)-Q(4)*spvak3k4(4))+t2*&
      &abb107n5*(Q(1)*spvak2k4(1)-Q(2)*spvak2k4(2)-Q(3)*spvak2k4(3)-Q(4)*spvak2k&
      &4(4))+t2*abb107n9*(Q(1)*spvak2k1(1)-Q(2)*spvak2k1(2)-Q(3)*spvak2k1(3)-Q(4&
      &)*spvak2k1(4)))
      numerator = cmplx(real(d107, ki), aimag(d107), ki_sam)
   end function numerator_samurai
   !------#] function numerator_samurai:
   !------#[ function numerator_golem95:
   function numerator_golem95(Q_ext, mu2_ext) result(numerator)
      use precision_golem, only: ki_gol => ki
      use p26_udbar_neepgg_globalsl1, only: epspow
      use p26_udbar_neepgg_kinematics
      use p26_udbar_neepgg_abbrevd107h1
      implicit none

      real(ki_gol), dimension(0:3), intent(in) :: Q_ext
      real(ki_gol), intent(in) :: mu2_ext
      complex(ki_gol) :: numerator
      complex(ki) :: d107
      complex(ki) :: t1
      complex(ki) :: t2

      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      real(ki), dimension(4) :: qshift

      qshift = k5
      Q(:) = cmplx(real(+Q_ext(:) - qshift(:), ki_gol), 0.0_ki_gol, ki)
      d107 = 0.0_ki
      t1 = (Q(1)*spvak5k6(1)-Q(2)*spvak5k6(2)-Q(3)*spvak5k6(3)-Q(4)*spvak5k6(4))
      t2 = t1*t1
      d107 = (t1*abb107n7+t2*abb107n1+t1*abb107n11*(Q(1)*spvak2k6(1)-Q(2)*spvak2&
      &k6(2)-Q(3)*spvak2k6(3)-Q(4)*spvak2k6(4))+t1*abb107n12*(Q(1)*k6(1)-Q(2)*k6&
      &(2)-Q(3)*k6(3)-Q(4)*k6(4))+t1*abb107n13*(Q(1)*k5(1)-Q(2)*k5(2)-Q(3)*k5(3)&
      &-Q(4)*k5(4))+t1*abb107n14*(Q(1)*spvak3k6(1)-Q(2)*spvak3k6(2)-Q(3)*spvak3k&
      &6(3)-Q(4)*spvak3k6(4))+t1*abb107n15*(Q(1)*spvak5k1(1)-Q(2)*spvak5k1(2)-Q(&
      &3)*spvak5k1(3)-Q(4)*spvak5k1(4))+t1*abb107n6*(Q(1)*spvak5k4(1)-Q(2)*spvak&
      &5k4(2)-Q(3)*spvak5k4(3)-Q(4)*spvak5k4(4))+t1*abb107n8*(Q(1)*Q(1)-Q(2)*Q(2&
      &)-Q(3)*Q(3)-Q(4)*Q(4))+t2*abb107n10*(Q(1)*spvak3k1(1)-Q(2)*spvak3k1(2)-Q(&
      &3)*spvak3k1(3)-Q(4)*spvak3k1(4))+t2*abb107n2*(Q(1)*k1(1)-Q(2)*k1(2)-Q(3)*&
      &k1(3)-Q(4)*k1(4))+t2*abb107n3*(Q(1)*k3(1)-Q(2)*k3(2)-Q(3)*k3(3)-Q(4)*k3(4&
      &))+t2*abb107n3*(Q(1)*k4(1)-Q(2)*k4(2)-Q(3)*k4(3)-Q(4)*k4(4))+t2*abb107n4*&
      &(Q(1)*spvak3k4(1)-Q(2)*spvak3k4(2)-Q(3)*spvak3k4(3)-Q(4)*spvak3k4(4))+t2*&
      &abb107n5*(Q(1)*spvak2k4(1)-Q(2)*spvak2k4(2)-Q(3)*spvak2k4(3)-Q(4)*spvak2k&
      &4(4))+t2*abb107n9*(Q(1)*spvak2k1(1)-Q(2)*spvak2k1(2)-Q(3)*spvak2k1(3)-Q(4&
      &)*spvak2k1(4)))

      numerator = cmplx(real(d107, ki), aimag(d107), ki_gol)
   end function numerator_golem95
   !------#] function numerator_golem95:
!---#] numerator interfaces:
end module p26_udbar_neepgg_d107h1l1
