module     p26_udbar_neepgg_d88h1l1
   ! file:      /home/pcl305a/luisonig/Documents/GoSamSherpa/W2jets/1.4/Virtual/
   ! p26_udbar_neepgg/helicity1/d88h1l1.f90
   ! generator: haggies (1.1)
   use p26_udbar_neepgg_config, only: ki
   use p26_udbar_neepgg_util, only: cond
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   public :: numerator_samurai
   public :: numerator_golem95
contains
!---#[ numerator interfaces:
   !------#[ function numerator_samurai:
   function numerator_samurai(ncut,Q_ext, mu2_ext) result(numerator)
      use precision, only: ki_sam => ki
!      use p26_udbar_neepgg_groups, only: &
!           & sign => diagram88_sign, shift => diagram88_shift
      use p26_udbar_neepgg_globalsl1, only: epspow
      use p26_udbar_neepgg_kinematics
      use p26_udbar_neepgg_abbrevd88h1
      implicit none

      integer, intent(in) :: ncut
      complex(ki_sam), dimension(4), intent(in) :: Q_ext
      complex(ki_sam), intent(in) :: mu2_ext
      complex(ki_sam) :: numerator
      complex(ki) :: d88
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11
      complex(ki) :: t12
      complex(ki) :: t13
      complex(ki) :: t14
      complex(ki) :: t15

      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      real(ki), dimension(0:3) :: qshift

      qshift = -k6
      Q(1)   = cmplx(real(-Q_ext(4) - qshift(0),   ki_sam), aimag(-Q_ext(4)),   &
      &ki)
      Q(2:4) = cmplx(real(-Q_ext(1:3) - qshift(1:3), ki_sam), aimag(-Q_ext(1:3))&
      &, ki)
      d88 = 0.0_ki
      t1 = (Q(1)*spvak3k4(1)-Q(2)*spvak3k4(2)-Q(3)*spvak3k4(3)-Q(4)*spvak3k4(4))
      t2 = (Q(1)*k5(1)-Q(2)*k5(2)-Q(3)*k5(3)-Q(4)*k5(4))
      t3 = (Q(1)*spvak6k1(1)-Q(2)*spvak6k1(2)-Q(3)*spvak6k1(3)-Q(4)*spvak6k1(4))
      t4 = (Q(1)*spvak5k6(1)-Q(2)*spvak5k6(2)-Q(3)*spvak5k6(3)-Q(4)*spvak5k6(4))
      t5 = (Q(1)*spvak5k1(1)-Q(2)*spvak5k1(2)-Q(3)*spvak5k1(3)-Q(4)*spvak5k1(4))
      t6 = t4*t4
      t7 = (Q(1)*Q(1)-Q(2)*Q(2)-Q(3)*Q(3)-Q(4)*Q(4))
      t8 = (Q(1)*k1(1)-Q(2)*k1(2)-Q(3)*k1(3)-Q(4)*k1(4))
      t9 = (Q(1)*k2(1)-Q(2)*k2(2)-Q(3)*k2(3)-Q(4)*k2(4))
      t10 = (Q(1)*k6(1)-Q(2)*k6(2)-Q(3)*k6(3)-Q(4)*k6(4))
      t11 = (Q(1)*spvak2k6(1)-Q(2)*spvak2k6(2)-Q(3)*spvak2k6(3)-Q(4)*spvak2k6(4)&
      &)
      t12 = (Q(1)*spvak2k4(1)-Q(2)*spvak2k4(2)-Q(3)*spvak2k4(3)-Q(4)*spvak2k4(4)&
      &)
      t13 = t7*abb88n31
      t14 = (Q(1)*spvak2k1(1)-Q(2)*spvak2k1(2)-Q(3)*spvak2k1(3)-Q(4)*spvak2k1(4)&
      &)
      t15 = (Q(1)*spvak3k1(1)-Q(2)*spvak3k1(2)-Q(3)*spvak3k1(3)-Q(4)*spvak3k1(4)&
      &)
      d88 = (abb88n1+t1*abb88n11+t10*t13+t10*abb88n5+t13*t8+t2*abb88n15+t3*abb88&
      &n19+t4*abb88n2+t5*abb88n20+t6*abb88n23+t7*abb88n25+t7*t7*abb88n30+t8*abb8&
      &8n26+t8*t8*abb88n28+t9*abb88n4+t1*t10*abb88n14+t1*t4*abb88n16+t1*t6*abb88&
      &n39+t1*t7*abb88n12+t1*t8*abb88n13+t10*t2*abb88n32+t10*t4*abb88n22+t10*t5*&
      &abb88n18+t10*t6*abb88n8+t10*t8*abb88n27+t11*t4*abb88n6+t11*t6*abb88n10+t1&
      &2*t6*abb88n24+t14*t6*abb88n43+t15*t6*abb88n56+t2*t4*abb88n36+t2*t7*abb88n&
      &29+t2*t8*abb88n31+t3*t4*abb88n50+t3*t6*abb88n47+t4*t5*abb88n55+t4*t7*abb8&
      &8n37+t4*t8*abb88n38+t5*t6*abb88n44+t5*t7*abb88n51+t5*t8*abb88n50+t5*t9*ab&
      &b88n17+t6*t7*abb88n9+t6*t8*abb88n7+t6*t9*abb88n8+t1*t10*t4*abb88n34+t1*t1&
      &4*t4*abb88n21+t1*t14*t6*abb88n57+t1*t4*t5*abb88n3+t1*t4*t7*abb88n35+t1*t4&
      &*t8*abb88n33+t10*t4*t5*abb88n46+t12*t2*t4*abb88n42+t12*t4*t7*abb88n41+t12&
      &*t4*t8*abb88n40+t15*t2*t4*abb88n52+t15*t4*t7*abb88n53+t15*t4*t8*abb88n54+&
      &t2*t4*t5*abb88n49+t4*t5*t7*abb88n48+t4*t5*t8*abb88n45+t4*t5*t9*abb88n47)
      numerator = cmplx(real(d88, ki), aimag(d88), ki_sam)
   end function numerator_samurai
   !------#] function numerator_samurai:
   !------#[ function numerator_golem95:
   function numerator_golem95(Q_ext, mu2_ext) result(numerator)
      use precision_golem, only: ki_gol => ki
      use p26_udbar_neepgg_globalsl1, only: epspow
      use p26_udbar_neepgg_kinematics
      use p26_udbar_neepgg_abbrevd88h1
      implicit none

      real(ki_gol), dimension(0:3), intent(in) :: Q_ext
      real(ki_gol), intent(in) :: mu2_ext
      complex(ki_gol) :: numerator
      complex(ki) :: d88
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11
      complex(ki) :: t12
      complex(ki) :: t13
      complex(ki) :: t14
      complex(ki) :: t15

      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      real(ki), dimension(4) :: qshift

      qshift = -k6
      Q(:) = cmplx(real(-Q_ext(:) - qshift(:), ki_gol), 0.0_ki_gol, ki)
      d88 = 0.0_ki
      t1 = (Q(1)*spvak3k4(1)-Q(2)*spvak3k4(2)-Q(3)*spvak3k4(3)-Q(4)*spvak3k4(4))
      t2 = (Q(1)*k5(1)-Q(2)*k5(2)-Q(3)*k5(3)-Q(4)*k5(4))
      t3 = (Q(1)*spvak6k1(1)-Q(2)*spvak6k1(2)-Q(3)*spvak6k1(3)-Q(4)*spvak6k1(4))
      t4 = (Q(1)*spvak5k6(1)-Q(2)*spvak5k6(2)-Q(3)*spvak5k6(3)-Q(4)*spvak5k6(4))
      t5 = (Q(1)*spvak5k1(1)-Q(2)*spvak5k1(2)-Q(3)*spvak5k1(3)-Q(4)*spvak5k1(4))
      t6 = t4*t4
      t7 = (Q(1)*Q(1)-Q(2)*Q(2)-Q(3)*Q(3)-Q(4)*Q(4))
      t8 = (Q(1)*k1(1)-Q(2)*k1(2)-Q(3)*k1(3)-Q(4)*k1(4))
      t9 = (Q(1)*k2(1)-Q(2)*k2(2)-Q(3)*k2(3)-Q(4)*k2(4))
      t10 = (Q(1)*k6(1)-Q(2)*k6(2)-Q(3)*k6(3)-Q(4)*k6(4))
      t11 = (Q(1)*spvak2k6(1)-Q(2)*spvak2k6(2)-Q(3)*spvak2k6(3)-Q(4)*spvak2k6(4)&
      &)
      t12 = (Q(1)*spvak2k4(1)-Q(2)*spvak2k4(2)-Q(3)*spvak2k4(3)-Q(4)*spvak2k4(4)&
      &)
      t13 = t7*abb88n31
      t14 = (Q(1)*spvak2k1(1)-Q(2)*spvak2k1(2)-Q(3)*spvak2k1(3)-Q(4)*spvak2k1(4)&
      &)
      t15 = (Q(1)*spvak3k1(1)-Q(2)*spvak3k1(2)-Q(3)*spvak3k1(3)-Q(4)*spvak3k1(4)&
      &)
      d88 = (abb88n1+t1*abb88n11+t10*t13+t10*abb88n5+t13*t8+t2*abb88n15+t3*abb88&
      &n19+t4*abb88n2+t5*abb88n20+t6*abb88n23+t7*abb88n25+t7*t7*abb88n30+t8*abb8&
      &8n26+t8*t8*abb88n28+t9*abb88n4+t1*t10*abb88n14+t1*t4*abb88n16+t1*t6*abb88&
      &n39+t1*t7*abb88n12+t1*t8*abb88n13+t10*t2*abb88n32+t10*t4*abb88n22+t10*t5*&
      &abb88n18+t10*t6*abb88n8+t10*t8*abb88n27+t11*t4*abb88n6+t11*t6*abb88n10+t1&
      &2*t6*abb88n24+t14*t6*abb88n43+t15*t6*abb88n56+t2*t4*abb88n36+t2*t7*abb88n&
      &29+t2*t8*abb88n31+t3*t4*abb88n50+t3*t6*abb88n47+t4*t5*abb88n55+t4*t7*abb8&
      &8n37+t4*t8*abb88n38+t5*t6*abb88n44+t5*t7*abb88n51+t5*t8*abb88n50+t5*t9*ab&
      &b88n17+t6*t7*abb88n9+t6*t8*abb88n7+t6*t9*abb88n8+t1*t10*t4*abb88n34+t1*t1&
      &4*t4*abb88n21+t1*t14*t6*abb88n57+t1*t4*t5*abb88n3+t1*t4*t7*abb88n35+t1*t4&
      &*t8*abb88n33+t10*t4*t5*abb88n46+t12*t2*t4*abb88n42+t12*t4*t7*abb88n41+t12&
      &*t4*t8*abb88n40+t15*t2*t4*abb88n52+t15*t4*t7*abb88n53+t15*t4*t8*abb88n54+&
      &t2*t4*t5*abb88n49+t4*t5*t7*abb88n48+t4*t5*t8*abb88n45+t4*t5*t9*abb88n47)

      numerator = cmplx(real(d88, ki), aimag(d88), ki_gol)
   end function numerator_golem95
   !------#] function numerator_golem95:
!---#] numerator interfaces:
end module p26_udbar_neepgg_d88h1l1
