module     p26_udbar_neepgg_d19h3l1d
   ! file:      /home/pcl305a/luisonig/Documents/GoSamSherpa/W2jets/1.4/Virtual/
   ! p26_udbar_neepgg/helicity3/d19h3l1d.f90
   ! generator: haggies (1.1)
   use p26_udbar_neepgg_config, only: ki
   use p26_udbar_neepgg_util, only: cond, d => metric_tensor
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   integer, private :: iv0
   integer, private :: iv1
   integer, private :: iv2
   integer, private :: iv3
   real(ki), dimension(4), private :: qshift


   public :: derivative, reconstruct_d19
contains

!---#[ function derivative:
   function derivative(mu2, i1, i2, i3) result(numerator)
      use p26_udbar_neepgg_globalsl1, only: epspow
      use p26_udbar_neepgg_kinematics
      use p26_udbar_neepgg_abbrevd19h3
      implicit none
      complex(ki), intent(in) :: mu2
      integer, intent(in), optional :: i1
      integer, intent(in), optional :: i2
      integer, intent(in), optional :: i3
      complex(ki) :: numerator
      complex(ki) :: loc
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11
      complex(ki) :: t12
      complex(ki) :: t13
      complex(ki) :: t14
      complex(ki) :: t15
      complex(ki) :: t16
      complex(ki) :: t17
      complex(ki) :: t18
      complex(ki) :: t19
      complex(ki) :: t20
      complex(ki) :: t21
      complex(ki) :: t22
      complex(ki) :: t23
      complex(ki) :: t24
      complex(ki) :: t25
      complex(ki) :: t26
      complex(ki) :: t27
      complex(ki) :: t28
      complex(ki) :: t29
      complex(ki) :: t30
      complex(ki) :: t31
      complex(ki) :: t32
      complex(ki) :: t33
      complex(ki) :: t34
      complex(ki) :: t35
      complex(ki) :: t36
      complex(ki) :: t37
      complex(ki) :: t38
      complex(ki) :: t39
      complex(ki) :: t40
      complex(ki) :: t41
      real(ki) :: t42
      real(ki) :: t43
      real(ki) :: t44
      real(ki) :: t45
      integer :: deg
      complex(ki), dimension(4), parameter :: Q = (/&
        &(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki)/)
      qshift = k2-k6
      numerator = 0.0_ki
      deg = 0
      if(present(i1)) then
         iv1 = i1
         deg = 1
      else
         iv1 = 1
      end if
      if(present(i2)) then
         iv2 = i2
         deg = 2
      else
         iv2 = 1
      end if
      if(present(i3)) then
         iv3 = i3
         deg = 3
      else
         iv3 = 1
      end if
      t1 = (spvak6k2(1)*qshift(1)-spvak6k2(2)*qshift(2)-spvak6k2(3)*qshift(3)-sp&
      &vak6k2(4)*qshift(4))
      t2 = (spvak5k1(1)*qshift(1)-spvak5k1(2)*qshift(2)-spvak5k1(3)*qshift(3)-sp&
      &vak5k1(4)*qshift(4))
      t42 = dotproduct(qshift, qshift)
      t43 = dotproduct(k6, qshift)
      t3 = (spvak2k6(1)*qshift(1)-spvak2k6(2)*qshift(2)-spvak2k6(3)*qshift(3)-sp&
      &vak2k6(4)*qshift(4))
      t4 = (spvak2k1(1)*qshift(1)-spvak2k1(2)*qshift(2)-spvak2k1(3)*qshift(3)-sp&
      &vak2k1(4)*qshift(4))
      t44 = dotproduct(k2, qshift)
      t45 = dotproduct(k5, qshift)
      t5 = (spvak3k1(1)*qshift(1)-spvak3k1(2)*qshift(2)-spvak3k1(3)*qshift(3)-sp&
      &vak3k1(4)*qshift(4))
      t6 = (spvak5k6(1)*qshift(1)-spvak5k6(2)*qshift(2)-spvak5k6(3)*qshift(3)-sp&
      &vak5k6(4)*qshift(4))
      t7 = (spvak6k1(1)*qshift(1)-spvak6k1(2)*qshift(2)-spvak6k1(3)*qshift(3)-sp&
      &vak6k1(4)*qshift(4))
      t8 = (spvak3k4(1)*qshift(1)-spvak3k4(2)*qshift(2)-spvak3k4(3)*qshift(3)-sp&
      &vak3k4(4)*qshift(4))
      t9 = (spvak6k5(1)*qshift(1)-spvak6k5(2)*qshift(2)-spvak6k5(3)*qshift(3)-sp&
      &vak6k5(4)*qshift(4))
      t10 = (spvak2k5(1)*qshift(1)-spvak2k5(2)*qshift(2)-spvak2k5(3)*qshift(3)-s&
      &pvak2k5(4)*qshift(4))
      if(deg.eq.0) then
         numerator = (abb19n42+t1*abb19n101+t2*abb19n121+t3*abb19n83+t4*abb19n84&
         &+t42*abb19n53+t43*abb19n94+t43*t43*abb19n59+t44*abb19n93+t45*abb19n95+&
         &t5*abb19n96+t6*abb19n98+t1*t6*abb19n65+t1*t8*abb19n52+t10*t6*abb19n62+&
         &t2*t42*abb19n128+t2*t43*abb19n46+t2*t44*abb19n44+t2*t45*abb19n46+t2*t6&
         &*abb19n47+t2*t8*abb19n78+t3*t42*abb19n104+t3*t43*abb19n63+t3*t44*abb19&
         &n61+t3*t45*abb19n63+t3*t6*abb19n60+t3*t8*abb19n77+t4*t6*abb19n50+t4*t8&
         &*abb19n81+t42*t43*abb19n112+t42*t5*abb19n90+t42*t6*abb19n116+t43*t44*a&
         &bb19n56+t43*t45*abb19n59+t43*t5*abb19n73+t43*t6*abb19n54+t43*t8*abb19n&
         &68+t44*t5*abb19n75+t44*t6*abb19n66+t44*t8*abb19n76+t45*t5*abb19n73+t5*&
         &t6*abb19n49+t6*t7*abb19n45+t6*t9*abb19n58+t4*t6*t8*abb19n124+t6*t7*t8*&
         &abb19n131)
         return
      end if
      t11 = k2(iv1)
      t12 = k5(iv1)
      t13 = k6(iv1)
      t14 = qshift(iv1)
      t15 = spvak2k1(iv1)
      t16 = spvak2k6(iv1)
      t17 = spvak3k1(iv1)
      t18 = spvak5k1(iv1)
      t19 = spvak5k6(iv1)
      t20 = spvak6k2(iv1)
      t21 = spvak2k5(iv1)
      t22 = t16*abb19n102
      t23 = t17*abb19n92
      t24 = spvak3k4(iv1)
      t25 = t18*abb19n126
      t26 = spvak6k1(iv1)
      t27 = spvak6k5(iv1)
      if(deg.eq.1) then
         numerator = (t11*abb19n72+t12*abb19n70+t13*abb19n71+t14*abb19n119+t15*a&
         &bb19n79+t16*abb19n80+t17*abb19n69+t18*abb19n51+t19*abb19n67+t20*abb19n&
         &64+t22*t43+t22*t45+t23*t43+t23*t45+t25*t43+t25*t45+t1*t19*abb19n100+t1&
         &*t24*abb19n120+t10*t19*abb19n104+t11*t2*abb19n130+t11*t3*abb19n106+t11&
         &*t43*abb19n114+t11*t5*abb19n88+t11*t6*abb19n99+t11*t8*abb19n87+t12*t2*&
         &abb19n126+t12*t3*abb19n102+t12*t43*abb19n108+t12*t5*abb19n92+t13*t2*ab&
         &b19n126+t13*t3*abb19n102+t13*t42*abb19n57+t13*t43*abb19n109+t13*t44*ab&
         &b19n114+t13*t45*abb19n108+t13*t5*abb19n92+t13*t6*abb19n118+t13*t8*abb1&
         &9n97+t14*t2*abb19n127+t14*t3*abb19n103+t14*t43*abb19n111+t14*t5*abb19n&
         &89+t14*t6*abb19n115+t15*t6*abb19n122+t15*t8*abb19n82+t16*t42*abb19n62+&
         &t16*t44*abb19n106+t16*t6*abb19n107+t16*t8*abb19n86+t17*t42*abb19n74+t1&
         &7*t44*abb19n88+t17*t6*abb19n123+t18*t42*abb19n45+t18*t44*abb19n130+t18&
         &*t6*abb19n125+t18*t8*abb19n85+t19*t2*abb19n125+t19*t3*abb19n107+t19*t4&
         &*abb19n122+t19*t42*abb19n55+t19*t43*abb19n118+t19*t44*abb19n99+t19*t5*&
         &abb19n123+t19*t7*abb19n128+t19*t9*abb19n110+t2*t24*abb19n85+t20*t6*abb&
         &19n100+t20*t8*abb19n120+t21*t6*abb19n104+t24*t3*abb19n86+t24*t4*abb19n&
         &82+t24*t43*abb19n97+t24*t44*abb19n87+t26*t6*abb19n128+t27*t6*abb19n110&
         &+t15*t6*t8*abb19n48+t19*t4*t8*abb19n48+t19*t7*t8*abb19n43+t24*t4*t6*ab&
         &b19n48+t24*t6*t7*abb19n43+t26*t6*t8*abb19n43)
         return
      end if
      t42 = d(iv1,iv2)
      t1 = k6(iv2)
      t9 = spvak2k6(iv2)
      t10 = spvak3k1(iv2)
      t22 = spvak3k4(iv2)
      t23 = spvak5k1(iv2)
      t25 = spvak5k6(iv2)
      t28 = k2(iv2)
      t29 = k5(iv2)
      t30 = qshift(iv2)
      t31 = t15*t22
      t32 = t15*t25
      t33 = spvak2k1(iv2)
      t34 = t24*t33
      t35 = t19*t33
      t36 = spvak6k2(iv2)
      t37 = spvak6k1(iv2)
      t38 = t19*t37
      t39 = t25*t26
      t40 = t24*t25
      t41 = t19*t22
      if(deg.eq.2) then
         numerator = ((2.0_ki)*(t42*abb19n53+t1*t13*abb19n59+t2*t42*abb19n128+t3&
         &*t42*abb19n104+t42*t43*abb19n112+t42*t5*abb19n90+t42*t6*abb19n116)+t31&
         &*abb19n81+t32*abb19n50+t34*abb19n81+t35*abb19n50+t38*abb19n45+t39*abb1&
         &9n45+spvak2k5(iv2)*t19*abb19n62+spvak6k5(iv2)*t19*abb19n58+t1*t11*abb1&
         &9n56+t1*t12*abb19n59+t1*t14*abb19n113+t1*t16*abb19n63+t1*t17*abb19n73+&
         &t1*t18*abb19n46+t1*t19*abb19n54+t1*t24*abb19n68+t10*t11*abb19n75+t10*t&
         &12*abb19n73+t10*t13*abb19n73+t10*t14*abb19n91+t10*t19*abb19n49+t11*t22&
         &*abb19n76+t11*t23*abb19n44+t11*t25*abb19n66+t11*t9*abb19n61+t12*t23*ab&
         &b19n46+t12*t9*abb19n63+t13*t22*abb19n68+t13*t23*abb19n46+t13*t25*abb19&
         &n54+t13*t28*abb19n56+t13*t29*abb19n59+t13*t30*abb19n113+t13*t9*abb19n6&
         &3+t14*t23*abb19n129+t14*t25*abb19n117+t14*t9*abb19n105+t16*t22*abb19n7&
         &7+t16*t25*abb19n60+t16*t28*abb19n61+t16*t29*abb19n63+t16*t30*abb19n105&
         &+t17*t25*abb19n49+t17*t28*abb19n75+t17*t29*abb19n73+t17*t30*abb19n91+t&
         &18*t22*abb19n78+t18*t25*abb19n47+t18*t28*abb19n44+t18*t29*abb19n46+t18&
         &*t30*abb19n129+t19*t23*abb19n47+t19*t28*abb19n66+t19*t30*abb19n117+t19&
         &*t36*abb19n65+t19*t9*abb19n60+t20*t22*abb19n52+t20*t25*abb19n65+t21*t2&
         &5*abb19n62+t23*t24*abb19n78+t24*t28*abb19n76+t24*t36*abb19n52+t24*t9*a&
         &bb19n77+t25*t27*abb19n58+t31*t6*abb19n124+t32*t8*abb19n124+t34*t6*abb1&
         &9n124+t35*t8*abb19n124+t38*t8*abb19n131+t39*t8*abb19n131+t4*t40*abb19n&
         &124+t4*t41*abb19n124+t40*t7*abb19n131+t41*t7*abb19n131+t22*t26*t6*abb1&
         &9n131+t24*t37*t6*abb19n131)
         return
      end if
      t43 = d(iv2,iv3)
      t44 = d(iv1,iv3)
      t2 = spvak5k6(iv3)
      t3 = spvak3k4(iv3)
      t4 = spvak2k1(iv3)
      t5 = spvak6k1(iv3)
      if(deg.eq.3) then
         numerator = ((2.0_ki)*(k6(iv3)*t42*abb19n57+spvak2k6(iv3)*t42*abb19n62+&
         &spvak3k1(iv3)*t42*abb19n74+spvak5k1(iv3)*t42*abb19n45+t1*t44*abb19n57+&
         &t10*t44*abb19n74+t13*t43*abb19n57+t16*t43*abb19n62+t17*t43*abb19n74+t1&
         &8*t43*abb19n45+t19*t43*abb19n55+t2*t42*abb19n55+t23*t44*abb19n45+t25*t&
         &44*abb19n55+t44*t9*abb19n62)+t2*t31*abb19n48+t2*t34*abb19n48+t40*t5*ab&
         &b19n43+t41*t5*abb19n43+t15*t25*t3*abb19n48+t19*t22*t4*abb19n48+t19*t3*&
         &t33*abb19n48+t19*t3*t37*abb19n43+t2*t22*t26*abb19n43+t2*t24*t37*abb19n&
         &43+t24*t25*t4*abb19n48+t25*t26*t3*abb19n43)
         return
      end if
   end function derivative
!---#] function derivative:
!---#[ subroutine reconstruct_d19:
   subroutine     reconstruct_d19(coeffs)
      use p26_udbar_neepgg_groups, only: tensrec_info_group1
      implicit none
      complex(ki), parameter :: czip = (0.0_ki, 0.0_ki)
      complex(ki), parameter :: cone = (1.0_ki, 0.0_ki)

      type(tensrec_info_group1), intent(out) :: coeffs
      ! rank 3 case:
      !---[# reconstruct coeffs%coeffs_19:
      coeffs%coeffs_19%c0 = derivative(czip)
      coeffs%coeffs_19%c1(1,1) = derivative(czip,1)
      coeffs%coeffs_19%c1(1,2) = derivative(czip,1,1) / 2.0_ki
      coeffs%coeffs_19%c1(1,3) = derivative(czip,1,1,1) / 6.0_ki
      coeffs%coeffs_19%c1(2,1) = -derivative(czip,2)
      coeffs%coeffs_19%c1(2,2) = derivative(czip,2,2) / 2.0_ki
      coeffs%coeffs_19%c1(2,3) = -derivative(czip,2,2,2) / 6.0_ki
      coeffs%coeffs_19%c1(3,1) = -derivative(czip,3)
      coeffs%coeffs_19%c1(3,2) = derivative(czip,3,3) / 2.0_ki
      coeffs%coeffs_19%c1(3,3) = -derivative(czip,3,3,3) / 6.0_ki
      coeffs%coeffs_19%c1(4,1) = -derivative(czip,4)
      coeffs%coeffs_19%c1(4,2) = derivative(czip,4,4) / 2.0_ki
      coeffs%coeffs_19%c1(4,3) = -derivative(czip,4,4,4) / 6.0_ki
      coeffs%coeffs_19%c2(1,1) = -derivative(czip,1,2)
      coeffs%coeffs_19%c2(1,2) = derivative(czip,1,2,2) / 2.0_ki
      coeffs%coeffs_19%c2(1,3) = -derivative(czip,1,1,2) / 2.0_ki
      coeffs%coeffs_19%c2(2,1) = -derivative(czip,1,3)
      coeffs%coeffs_19%c2(2,2) = derivative(czip,1,3,3) / 2.0_ki
      coeffs%coeffs_19%c2(2,3) = -derivative(czip,1,1,3) / 2.0_ki
      coeffs%coeffs_19%c2(3,1) = -derivative(czip,1,4)
      coeffs%coeffs_19%c2(3,2) = derivative(czip,1,4,4) / 2.0_ki
      coeffs%coeffs_19%c2(3,3) = -derivative(czip,1,1,4) / 2.0_ki
      coeffs%coeffs_19%c2(4,1) = derivative(czip,2,3)
      coeffs%coeffs_19%c2(4,2) = -derivative(czip,2,3,3) / 2.0_ki
      coeffs%coeffs_19%c2(4,3) = -derivative(czip,2,2,3) / 2.0_ki
      coeffs%coeffs_19%c2(5,1) = derivative(czip,2,4)
      coeffs%coeffs_19%c2(5,2) = -derivative(czip,2,4,4) / 2.0_ki
      coeffs%coeffs_19%c2(5,3) = -derivative(czip,2,2,4) / 2.0_ki
      coeffs%coeffs_19%c2(6,1) = derivative(czip,3,4)
      coeffs%coeffs_19%c2(6,2) = -derivative(czip,3,4,4) / 2.0_ki
      coeffs%coeffs_19%c2(6,3) = -derivative(czip,3,3,4) / 2.0_ki
      coeffs%coeffs_19%c3(1,1) = derivative(czip,1,2,3)
      coeffs%coeffs_19%c3(2,1) = derivative(czip,1,2,4)
      coeffs%coeffs_19%c3(3,1) = derivative(czip,1,3,4)
      coeffs%coeffs_19%c3(4,1) = -derivative(czip,2,3,4)
      !---#] reconstruct coeffs%coeffs_19:
   end subroutine reconstruct_d19
!---#] subroutine reconstruct_d19:
end module p26_udbar_neepgg_d19h3l1d
