module     p26_udbar_neepgg_d97h3l1
   ! file:      /home/pcl305a/luisonig/Documents/GoSamSherpa/W2jets/1.4/Virtual/
   ! p26_udbar_neepgg/helicity3/d97h3l1.f90
   ! generator: haggies (1.1)
   use p26_udbar_neepgg_config, only: ki
   use p26_udbar_neepgg_util, only: cond
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   public :: numerator_samurai
   public :: numerator_golem95
contains
!---#[ numerator interfaces:
   !------#[ function numerator_samurai:
   function numerator_samurai(ncut,Q_ext, mu2_ext) result(numerator)
      use precision, only: ki_sam => ki
!      use p26_udbar_neepgg_groups, only: &
!           & sign => diagram97_sign, shift => diagram97_shift
      use p26_udbar_neepgg_globalsl1, only: epspow
      use p26_udbar_neepgg_kinematics
      use p26_udbar_neepgg_abbrevd97h3
      implicit none

      integer, intent(in) :: ncut
      complex(ki_sam), dimension(4), intent(in) :: Q_ext
      complex(ki_sam), intent(in) :: mu2_ext
      complex(ki_sam) :: numerator
      complex(ki) :: d97
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11
      complex(ki) :: t12
      complex(ki) :: t13
      complex(ki) :: t14

      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q

      Q(1)   = cmplx(real(-Q_ext(4),   ki_sam), aimag(-Q_ext(4)),   ki)
      Q(2:4) = cmplx(real(-Q_ext(1:3), ki_sam), aimag(-Q_ext(1:3)), ki)
      d97 = 0.0_ki
      t1 = (Q(1)*spvak3k1(1)-Q(2)*spvak3k1(2)-Q(3)*spvak3k1(3)-Q(4)*spvak3k1(4))
      t2 = (Q(1)*k6(1)-Q(2)*k6(2)-Q(3)*k6(3)-Q(4)*k6(4))
      t3 = (Q(1)*spvak6k5(1)-Q(2)*spvak6k5(2)-Q(3)*spvak6k5(3)-Q(4)*spvak6k5(4))
      t4 = (Q(1)*spvak5k6(1)-Q(2)*spvak5k6(2)-Q(3)*spvak5k6(3)-Q(4)*spvak5k6(4))
      t5 = (Q(1)*k5(1)-Q(2)*k5(2)-Q(3)*k5(3)-Q(4)*k5(4))
      t6 = (Q(1)*Q(1)-Q(2)*Q(2)-Q(3)*Q(3)-Q(4)*Q(4))
      t7 = (Q(1)*k1(1)-Q(2)*k1(2)-Q(3)*k1(3)-Q(4)*k1(4))
      t8 = (Q(1)*k3(1)-Q(2)*k3(2)-Q(3)*k3(3)-Q(4)*k3(4))
      t9 = (Q(1)*k4(1)-Q(2)*k4(2)-Q(3)*k4(3)-Q(4)*k4(4))
      t10 = (Q(1)*spvak3k4(1)-Q(2)*spvak3k4(2)-Q(3)*spvak3k4(3)-Q(4)*spvak3k4(4)&
      &)
      t11 = (Q(1)*k2(1)-Q(2)*k2(2)-Q(3)*k2(3)-Q(4)*k2(4))
      t12 = t11*abb97n3
      t13 = t6*abb97n42
      t14 = (Q(1)*spvak2k6(1)-Q(2)*spvak2k6(2)-Q(3)*spvak2k6(3)-Q(4)*spvak2k6(4)&
      &)
      d97 = (abb97n1+t1*abb97n10+t10*abb97n7+t11*abb97n8+t12*t8+t12*t9+t13*t8+t1&
      &3*t9+t2*abb97n11+t3*abb97n12+t4*abb97n30+t5*abb97n31+t6*abb97n32+t7*abb97&
      &n5+t8*abb97n6+t9*abb97n6+t1*t11*abb97n9+t1*t2*abb97n28+t1*t3*abb97n27+t1*&
      &t4*abb97n29+t1*t5*abb97n52+t1*t6*abb97n51+t10*t11*abb97n4+t10*t2*abb97n22&
      &+t10*t3*abb97n21+t10*t4*abb97n26+t10*t5*abb97n46+t10*t6*abb97n45+t11*t3*a&
      &bb97n13+t11*t4*abb97n23+t11*t7*abb97n2+t14*t5*abb97n47+t14*t6*abb97n48+t2&
      &*t3*abb97n15+t2*t4*abb97n39+t2*t7*abb97n20+t2*t8*abb97n19+t2*t9*abb97n19+&
      &t3*t4*abb97n40+t3*t5*abb97n16+t3*t6*abb97n14+t3*t7*abb97n18+t3*t8*abb97n1&
      &7+t3*t9*abb97n17+t4*t5*abb97n38+t4*t6*abb97n37+t4*t7*abb97n24+t4*t8*abb97&
      &n25+t4*t9*abb97n25+t5*t7*abb97n44+t5*t8*abb97n41+t5*t9*abb97n41+t6*t7*abb&
      &97n43+t1*t3*t4*abb97n50+t10*t3*t4*abb97n36+t3*t4*t7*abb97n34+t3*t4*t8*abb&
      &97n35+t3*t4*t9*abb97n35+t3*t4*abb97n33*(Q(1)*spvak2k1(1)-Q(2)*spvak2k1(2)&
      &-Q(3)*spvak2k1(3)-Q(4)*spvak2k1(4))+t3*t4*abb97n49*(Q(1)*spvak2k4(1)-Q(2)&
      &*spvak2k4(2)-Q(3)*spvak2k4(3)-Q(4)*spvak2k4(4)))
      numerator = cmplx(real(d97, ki), aimag(d97), ki_sam)
   end function numerator_samurai
   !------#] function numerator_samurai:
   !------#[ function numerator_golem95:
   function numerator_golem95(Q_ext, mu2_ext) result(numerator)
      use precision_golem, only: ki_gol => ki
      use p26_udbar_neepgg_globalsl1, only: epspow
      use p26_udbar_neepgg_kinematics
      use p26_udbar_neepgg_abbrevd97h3
      implicit none

      real(ki_gol), dimension(0:3), intent(in) :: Q_ext
      real(ki_gol), intent(in) :: mu2_ext
      complex(ki_gol) :: numerator
      complex(ki) :: d97
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11
      complex(ki) :: t12
      complex(ki) :: t13
      complex(ki) :: t14

      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      Q(:) = cmplx(real(-Q_ext(:), ki_gol), 0.0_ki_gol, ki)
      d97 = 0.0_ki
      t1 = (Q(1)*spvak3k1(1)-Q(2)*spvak3k1(2)-Q(3)*spvak3k1(3)-Q(4)*spvak3k1(4))
      t2 = (Q(1)*k6(1)-Q(2)*k6(2)-Q(3)*k6(3)-Q(4)*k6(4))
      t3 = (Q(1)*spvak6k5(1)-Q(2)*spvak6k5(2)-Q(3)*spvak6k5(3)-Q(4)*spvak6k5(4))
      t4 = (Q(1)*spvak5k6(1)-Q(2)*spvak5k6(2)-Q(3)*spvak5k6(3)-Q(4)*spvak5k6(4))
      t5 = (Q(1)*k5(1)-Q(2)*k5(2)-Q(3)*k5(3)-Q(4)*k5(4))
      t6 = (Q(1)*Q(1)-Q(2)*Q(2)-Q(3)*Q(3)-Q(4)*Q(4))
      t7 = (Q(1)*k1(1)-Q(2)*k1(2)-Q(3)*k1(3)-Q(4)*k1(4))
      t8 = (Q(1)*k3(1)-Q(2)*k3(2)-Q(3)*k3(3)-Q(4)*k3(4))
      t9 = (Q(1)*k4(1)-Q(2)*k4(2)-Q(3)*k4(3)-Q(4)*k4(4))
      t10 = (Q(1)*spvak3k4(1)-Q(2)*spvak3k4(2)-Q(3)*spvak3k4(3)-Q(4)*spvak3k4(4)&
      &)
      t11 = (Q(1)*k2(1)-Q(2)*k2(2)-Q(3)*k2(3)-Q(4)*k2(4))
      t12 = t11*abb97n3
      t13 = t6*abb97n42
      t14 = (Q(1)*spvak2k6(1)-Q(2)*spvak2k6(2)-Q(3)*spvak2k6(3)-Q(4)*spvak2k6(4)&
      &)
      d97 = (abb97n1+t1*abb97n10+t10*abb97n7+t11*abb97n8+t12*t8+t12*t9+t13*t8+t1&
      &3*t9+t2*abb97n11+t3*abb97n12+t4*abb97n30+t5*abb97n31+t6*abb97n32+t7*abb97&
      &n5+t8*abb97n6+t9*abb97n6+t1*t11*abb97n9+t1*t2*abb97n28+t1*t3*abb97n27+t1*&
      &t4*abb97n29+t1*t5*abb97n52+t1*t6*abb97n51+t10*t11*abb97n4+t10*t2*abb97n22&
      &+t10*t3*abb97n21+t10*t4*abb97n26+t10*t5*abb97n46+t10*t6*abb97n45+t11*t3*a&
      &bb97n13+t11*t4*abb97n23+t11*t7*abb97n2+t14*t5*abb97n47+t14*t6*abb97n48+t2&
      &*t3*abb97n15+t2*t4*abb97n39+t2*t7*abb97n20+t2*t8*abb97n19+t2*t9*abb97n19+&
      &t3*t4*abb97n40+t3*t5*abb97n16+t3*t6*abb97n14+t3*t7*abb97n18+t3*t8*abb97n1&
      &7+t3*t9*abb97n17+t4*t5*abb97n38+t4*t6*abb97n37+t4*t7*abb97n24+t4*t8*abb97&
      &n25+t4*t9*abb97n25+t5*t7*abb97n44+t5*t8*abb97n41+t5*t9*abb97n41+t6*t7*abb&
      &97n43+t1*t3*t4*abb97n50+t10*t3*t4*abb97n36+t3*t4*t7*abb97n34+t3*t4*t8*abb&
      &97n35+t3*t4*t9*abb97n35+t3*t4*abb97n33*(Q(1)*spvak2k1(1)-Q(2)*spvak2k1(2)&
      &-Q(3)*spvak2k1(3)-Q(4)*spvak2k1(4))+t3*t4*abb97n49*(Q(1)*spvak2k4(1)-Q(2)&
      &*spvak2k4(2)-Q(3)*spvak2k4(3)-Q(4)*spvak2k4(4)))

      numerator = cmplx(real(d97, ki), aimag(d97), ki_gol)
   end function numerator_golem95
   !------#] function numerator_golem95:
!---#] numerator interfaces:
end module p26_udbar_neepgg_d97h3l1
