module     p2_ddbar_emnebarcsbar_d29h1l1
   ! file:      /home/pcl305a/luisonig/Documents/GoSamSherpa/W2jets/1.4/Virtual/
   ! p2_ddbar_emnebarcsbar/helicity1/d29h1l1.f90
   ! generator: haggies (1.1)
   use p2_ddbar_emnebarcsbar_config, only: ki
   use p2_ddbar_emnebarcsbar_util, only: cond
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   public :: numerator_samurai
   public :: numerator_golem95
contains
!---#[ numerator interfaces:
   !------#[ function numerator_samurai:
   function numerator_samurai(ncut,Q_ext, mu2_ext) result(numerator)
      use precision, only: ki_sam => ki
!      use p2_ddbar_emnebarcsbar_groups, only: &
!           & sign => diagram29_sign, shift => diagram29_shift
      use p2_ddbar_emnebarcsbar_globalsl1, only: epspow
      use p2_ddbar_emnebarcsbar_kinematics
      use p2_ddbar_emnebarcsbar_abbrevd29h1
      implicit none

      integer, intent(in) :: ncut
      complex(ki_sam), dimension(4), intent(in) :: Q_ext
      complex(ki_sam), intent(in) :: mu2_ext
      complex(ki_sam) :: numerator
      complex(ki) :: d29
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6

      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      real(ki), dimension(0:3) :: qshift

      qshift = k2
      Q(1)   = cmplx(real(+Q_ext(4) - qshift(0),   ki_sam), aimag(+Q_ext(4)),   &
      &ki)
      Q(2:4) = cmplx(real(+Q_ext(1:3) - qshift(1:3), ki_sam), aimag(+Q_ext(1:3))&
      &, ki)
      d29 = 0.0_ki
      t1 = (Q(1)*Q(1)-Q(2)*Q(2)-Q(3)*Q(3)-Q(4)*Q(4))
      t2 = (Q(1)*k1(1)-Q(2)*k1(2)-Q(3)*k1(3)-Q(4)*k1(4))
      t3 = (Q(1)*k6(1)-Q(2)*k6(2)-Q(3)*k6(3)-Q(4)*k6(4))
      t4 = (Q(1)*spvak3k1(1)-Q(2)*spvak3k1(2)-Q(3)*spvak3k1(3)-Q(4)*spvak3k1(4))
      t5 = (Q(1)*spvak3k6(1)-Q(2)*spvak3k6(2)-Q(3)*spvak3k6(3)-Q(4)*spvak3k6(4))
      t6 = (Q(1)*spvak3k4(1)-Q(2)*spvak3k4(2)-Q(3)*spvak3k4(3)-Q(4)*spvak3k4(4))
      d29 = (t1*abb29n10+t2*abb29n3+t3*abb29n7+abb29n1*(Q(1)*spvak6k1(1)-Q(2)*sp&
      &vak6k1(2)-Q(3)*spvak6k1(3)-Q(4)*spvak6k1(4))+abb29n2*(Q(1)*spvak1k6(1)-Q(&
      &2)*spvak1k6(2)-Q(3)*spvak1k6(3)-Q(4)*spvak1k6(4))+t1*t4*abb29n12+t1*t5*ab&
      &b29n5+t1*t6*abb29n8+t2*t4*abb29n11+t2*t5*abb29n4+t2*t6*abb29n9+t3*t4*abb2&
      &9n13+t3*t5*abb29n6+t3*t6*abb29n8)
      numerator = cmplx(real(d29, ki), aimag(d29), ki_sam)
   end function numerator_samurai
   !------#] function numerator_samurai:
   !------#[ function numerator_golem95:
   function numerator_golem95(Q_ext, mu2_ext) result(numerator)
      use precision_golem, only: ki_gol => ki
      use p2_ddbar_emnebarcsbar_globalsl1, only: epspow
      use p2_ddbar_emnebarcsbar_kinematics
      use p2_ddbar_emnebarcsbar_abbrevd29h1
      implicit none

      real(ki_gol), dimension(0:3), intent(in) :: Q_ext
      real(ki_gol), intent(in) :: mu2_ext
      complex(ki_gol) :: numerator
      complex(ki) :: d29
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6

      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      real(ki), dimension(4) :: qshift

      qshift = k2
      Q(:) = cmplx(real(+Q_ext(:) - qshift(:), ki_gol), 0.0_ki_gol, ki)
      d29 = 0.0_ki
      t1 = (Q(1)*Q(1)-Q(2)*Q(2)-Q(3)*Q(3)-Q(4)*Q(4))
      t2 = (Q(1)*k1(1)-Q(2)*k1(2)-Q(3)*k1(3)-Q(4)*k1(4))
      t3 = (Q(1)*k6(1)-Q(2)*k6(2)-Q(3)*k6(3)-Q(4)*k6(4))
      t4 = (Q(1)*spvak3k1(1)-Q(2)*spvak3k1(2)-Q(3)*spvak3k1(3)-Q(4)*spvak3k1(4))
      t5 = (Q(1)*spvak3k6(1)-Q(2)*spvak3k6(2)-Q(3)*spvak3k6(3)-Q(4)*spvak3k6(4))
      t6 = (Q(1)*spvak3k4(1)-Q(2)*spvak3k4(2)-Q(3)*spvak3k4(3)-Q(4)*spvak3k4(4))
      d29 = (t1*abb29n10+t2*abb29n3+t3*abb29n7+abb29n1*(Q(1)*spvak6k1(1)-Q(2)*sp&
      &vak6k1(2)-Q(3)*spvak6k1(3)-Q(4)*spvak6k1(4))+abb29n2*(Q(1)*spvak1k6(1)-Q(&
      &2)*spvak1k6(2)-Q(3)*spvak1k6(3)-Q(4)*spvak1k6(4))+t1*t4*abb29n12+t1*t5*ab&
      &b29n5+t1*t6*abb29n8+t2*t4*abb29n11+t2*t5*abb29n4+t2*t6*abb29n9+t3*t4*abb2&
      &9n13+t3*t5*abb29n6+t3*t6*abb29n8)

      numerator = cmplx(real(d29, ki), aimag(d29), ki_gol)
   end function numerator_golem95
   !------#] function numerator_golem95:
!---#] numerator interfaces:
end module p2_ddbar_emnebarcsbar_d29h1l1
