module     p3_ud_emnebaruu_d53h0l1d
   ! file:      /home/pcl305a/luisonig/Documents/GoSamSherpa/W2jets/1.4/Virtual/
   ! p3_ud_emnebaruu/helicity0/d53h0l1d.f90
   ! generator: haggies (1.1)
   use p3_ud_emnebaruu_config, only: ki
   use p3_ud_emnebaruu_util, only: cond, d => metric_tensor
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   integer, private :: iv0
   integer, private :: iv1
   real(ki), dimension(4), private :: qshift


   public :: derivative, reconstruct_d53
contains

!---#[ function derivative:
   function derivative(mu2, i1) result(numerator)
      use p3_ud_emnebaruu_globalsl1, only: epspow
      use p3_ud_emnebaruu_kinematics
      use p3_ud_emnebaruu_abbrevd53h0
      implicit none
      complex(ki), intent(in) :: mu2
      integer, intent(in), optional :: i1
      complex(ki) :: numerator
      complex(ki) :: loc
      integer :: deg
      complex(ki), dimension(4), parameter :: Q = (/&
        &(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki)/)
      qshift = -k2
      numerator = 0.0_ki
      deg = 0
      if(present(i1)) then
         iv1 = i1
         deg = 1
      else
         iv1 = 1
      end if
      if(deg.eq.0) then
         numerator = (abb53n11+abb53n12*(spvak3k1(1)*qshift(1)-spvak3k1(2)*qshif&
         &t(2)-spvak3k1(3)*qshift(3)-spvak3k1(4)*qshift(4))+abb53n13*(spvak5k1(1&
         &)*qshift(1)-spvak5k1(2)*qshift(2)-spvak5k1(3)*qshift(3)-spvak5k1(4)*qs&
         &hift(4))+abb53n14*(spvak3k2(1)*qshift(1)-spvak3k2(2)*qshift(2)-spvak3k&
         &2(3)*qshift(3)-spvak3k2(4)*qshift(4))+abb53n15*(spvak5k2(1)*qshift(1)-&
         &spvak5k2(2)*qshift(2)-spvak5k2(3)*qshift(3)-spvak5k2(4)*qshift(4))+abb&
         &53n16*dotproduct(k1, qshift)+abb53n16*dotproduct(k2, qshift)+abb53n17*&
         &dotproduct(k6, qshift)+abb53n18*(spvak6k2(1)*qshift(1)-spvak6k2(2)*qsh&
         &ift(2)-spvak6k2(3)*qshift(3)-spvak6k2(4)*qshift(4))+abb53n19*(spvak6k1&
         &(1)*qshift(1)-spvak6k1(2)*qshift(2)-spvak6k1(3)*qshift(3)-spvak6k1(4)*&
         &qshift(4)))
         return
      end if
      if(deg.eq.1) then
         numerator = (k1(iv1)*abb53n16+k2(iv1)*abb53n16+k6(iv1)*abb53n17+spvak3k&
         &1(iv1)*abb53n12+spvak3k2(iv1)*abb53n14+spvak5k1(iv1)*abb53n13+spvak5k2&
         &(iv1)*abb53n15+spvak6k1(iv1)*abb53n19+spvak6k2(iv1)*abb53n18)
         return
      end if
   end function derivative
!---#] function derivative:
!---#[ subroutine reconstruct_d53:
   subroutine     reconstruct_d53(coeffs)
      use p3_ud_emnebaruu_groups, only: tensrec_info_group5
      implicit none
      complex(ki), parameter :: czip = (0.0_ki, 0.0_ki)
      complex(ki), parameter :: cone = (1.0_ki, 0.0_ki)

      type(tensrec_info_group5), intent(out) :: coeffs
      ! rank 1 case:
      !---[# reconstruct coeffs%coeffs_53:
      coeffs%coeffs_53%c0 = derivative(czip)
      coeffs%coeffs_53%c1(1,1) = derivative(czip,1)
      coeffs%coeffs_53%c1(2,1) = -derivative(czip,2)
      coeffs%coeffs_53%c1(3,1) = -derivative(czip,3)
      coeffs%coeffs_53%c1(4,1) = -derivative(czip,4)
      !---#] reconstruct coeffs%coeffs_53:
   end subroutine reconstruct_d53
!---#] subroutine reconstruct_d53:
end module p3_ud_emnebaruu_d53h0l1d
