module     p3_ud_emnebaruu_d64h0l1d
   ! file:      /home/pcl305a/luisonig/Documents/GoSamSherpa/W2jets/1.4/Virtual/
   ! p3_ud_emnebaruu/helicity0/d64h0l1d.f90
   ! generator: haggies (1.1)
   use p3_ud_emnebaruu_config, only: ki
   use p3_ud_emnebaruu_util, only: cond, d => metric_tensor
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   integer, private :: iv0
   integer, private :: iv1
   integer, private :: iv2
   real(ki), dimension(4), private :: qshift


   public :: derivative, reconstruct_d64
contains

!---#[ function derivative:
   function derivative(mu2, i1, i2) result(numerator)
      use p3_ud_emnebaruu_globalsl1, only: epspow
      use p3_ud_emnebaruu_kinematics
      use p3_ud_emnebaruu_abbrevd64h0
      implicit none
      complex(ki), intent(in) :: mu2
      integer, intent(in), optional :: i1
      integer, intent(in), optional :: i2
      complex(ki) :: numerator
      complex(ki) :: loc
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      integer :: deg
      complex(ki), dimension(4), parameter :: Q = (/&
        &(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki)/)
      qshift = k6
      numerator = 0.0_ki
      deg = 0
      if(present(i1)) then
         iv1 = i1
         deg = 1
      else
         iv1 = 1
      end if
      if(present(i2)) then
         iv2 = i2
         deg = 2
      else
         iv2 = 1
      end if
      t1 = (spvak3k2(1)*qshift(1)-spvak3k2(2)*qshift(2)-spvak3k2(3)*qshift(3)-sp&
      &vak3k2(4)*qshift(4))
      t2 = (spvak5k2(1)*qshift(1)-spvak5k2(2)*qshift(2)-spvak5k2(3)*qshift(3)-sp&
      &vak5k2(4)*qshift(4))
      t3 = (spvak6k1(1)*qshift(1)-spvak6k1(2)*qshift(2)-spvak6k1(3)*qshift(3)-sp&
      &vak6k1(4)*qshift(4))
      if(deg.eq.0) then
         numerator = (t1*abb64n11+t2*abb64n6+t1*t3*abb64n8+t2*t3*abb64n7)
         return
      end if
      t4 = spvak3k2(iv1)
      t5 = spvak5k2(iv1)
      t6 = spvak6k1(iv1)
      if(deg.eq.1) then
         numerator = (t4*abb64n9+t5*abb64n10+t1*t6*abb64n12+t2*t6*abb64n13+t3*t4&
         &*abb64n12+t3*t5*abb64n13)
         return
      end if
      t1 = spvak6k1(iv2)
      if(deg.eq.2) then
         numerator = (spvak3k2(iv2)*t6*abb64n8+spvak5k2(iv2)*t6*abb64n7+t1*t4*ab&
         &b64n8+t1*t5*abb64n7)
         return
      end if
   end function derivative
!---#] function derivative:
!---#[ subroutine reconstruct_d64:
   subroutine     reconstruct_d64(coeffs)
      use p3_ud_emnebaruu_groups, only: tensrec_info_group5
      implicit none
      complex(ki), parameter :: czip = (0.0_ki, 0.0_ki)
      complex(ki), parameter :: cone = (1.0_ki, 0.0_ki)

      type(tensrec_info_group5), intent(out) :: coeffs
      ! rank 2 case:
      !---[# reconstruct coeffs%coeffs_64:
      coeffs%coeffs_64%c0 = derivative(czip)
      coeffs%coeffs_64%c1(1,1) = derivative(czip,1)
      coeffs%coeffs_64%c1(1,2) = derivative(czip,1,1) / 2.0_ki
      coeffs%coeffs_64%c1(2,1) = -derivative(czip,2)
      coeffs%coeffs_64%c1(2,2) = derivative(czip,2,2) / 2.0_ki
      coeffs%coeffs_64%c1(3,1) = -derivative(czip,3)
      coeffs%coeffs_64%c1(3,2) = derivative(czip,3,3) / 2.0_ki
      coeffs%coeffs_64%c1(4,1) = -derivative(czip,4)
      coeffs%coeffs_64%c1(4,2) = derivative(czip,4,4) / 2.0_ki
      coeffs%coeffs_64%c2(1,1) = -derivative(czip,1,2)
      coeffs%coeffs_64%c2(2,1) = -derivative(czip,1,3)
      coeffs%coeffs_64%c2(3,1) = -derivative(czip,1,4)
      coeffs%coeffs_64%c2(4,1) = derivative(czip,2,3)
      coeffs%coeffs_64%c2(5,1) = derivative(czip,2,4)
      coeffs%coeffs_64%c2(6,1) = derivative(czip,3,4)
      !---#] reconstruct coeffs%coeffs_64:
   end subroutine reconstruct_d64
!---#] subroutine reconstruct_d64:
end module p3_ud_emnebaruu_d64h0l1d
