module     p3_ud_emnebaruu_d9h0l1d
   ! file:      /home/pcl305a/luisonig/Documents/GoSamSherpa/W2jets/1.4/Virtual/
   ! p3_ud_emnebaruu/helicity0/d9h0l1d.f90
   ! generator: haggies (1.1)
   use p3_ud_emnebaruu_config, only: ki
   use p3_ud_emnebaruu_util, only: cond, d => metric_tensor
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   integer, private :: iv0
   integer, private :: iv1
   integer, private :: iv2
   real(ki), dimension(4), private :: qshift


   public :: derivative, reconstruct_d9
contains

!---#[ function derivative:
   function derivative(mu2, i1, i2) result(numerator)
      use p3_ud_emnebaruu_globalsl1, only: epspow
      use p3_ud_emnebaruu_kinematics
      use p3_ud_emnebaruu_abbrevd9h0
      implicit none
      complex(ki), intent(in) :: mu2
      integer, intent(in), optional :: i1
      integer, intent(in), optional :: i2
      complex(ki) :: numerator
      complex(ki) :: loc
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11
      complex(ki) :: t12
      complex(ki) :: t13
      complex(ki) :: t14
      real(ki) :: t15
      real(ki) :: t16
      real(ki) :: t17
      integer :: deg
      complex(ki), dimension(4), parameter :: Q = (/&
        &(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki)/)
      qshift = -k3+k2-k4
      numerator = 0.0_ki
      deg = 0
      if(present(i1)) then
         iv1 = i1
         deg = 1
      else
         iv1 = 1
      end if
      if(present(i2)) then
         iv2 = i2
         deg = 2
      else
         iv2 = 1
      end if
      t1 = (spvak3k4(1)*qshift(1)-spvak3k4(2)*qshift(2)-spvak3k4(3)*qshift(3)-sp&
      &vak3k4(4)*qshift(4))
      t2 = (spvak6k1(1)*qshift(1)-spvak6k1(2)*qshift(2)-spvak6k1(3)*qshift(3)-sp&
      &vak6k1(4)*qshift(4))
      t3 = (spvak6k2(1)*qshift(1)-spvak6k2(2)*qshift(2)-spvak6k2(3)*qshift(3)-sp&
      &vak6k2(4)*qshift(4))
      t15 = dotproduct(k1, qshift)
      t16 = dotproduct(k2, qshift)
      t17 = dotproduct(k6, qshift)
      t4 = (spvak5k2(1)*qshift(1)-spvak5k2(2)*qshift(2)-spvak5k2(3)*qshift(3)-sp&
      &vak5k2(4)*qshift(4))
      t5 = (spvak5k1(1)*qshift(1)-spvak5k1(2)*qshift(2)-spvak5k1(3)*qshift(3)-sp&
      &vak5k1(4)*qshift(4))
      if(deg.eq.0) then
         numerator = (t1*abb9n27+abb9n13*(spvak5k4(1)*qshift(1)-spvak5k4(2)*qshi&
         &ft(2)-spvak5k4(3)*qshift(3)-spvak5k4(4)*qshift(4))+abb9n20*dotproduct(&
         &qshift, qshift)+abb9n25*dotproduct(k3, qshift)+abb9n25*dotproduct(k4, &
         &qshift)+t1*t15*abb9n16+t1*t16*abb9n16+t1*t17*abb9n17+t1*t2*abb9n14+t1*&
         &t3*abb9n15+t1*t4*abb9n18+t1*t5*abb9n23)
         return
      end if
      t6 = spvak3k4(iv1)
      t7 = k1(iv1)
      t8 = k2(iv1)
      t9 = k6(iv1)
      t10 = t6*abb9n30
      t11 = spvak5k1(iv1)
      t12 = spvak5k2(iv1)
      t13 = spvak6k1(iv1)
      t14 = spvak6k2(iv1)
      if(deg.eq.1) then
         numerator = (k3(iv1)*abb9n21+k4(iv1)*abb9n21+qshift(iv1)*abb9n26+spvak5&
         &k4(iv1)*abb9n22+t10*t15+t10*t16+t6*abb9n19+t1*t11*abb9n24+t1*t12*abb9n&
         &28+t1*t13*abb9n32+t1*t14*abb9n31+t1*t7*abb9n30+t1*t8*abb9n30+t1*t9*abb&
         &9n29+t17*t6*abb9n29+t2*t6*abb9n32+t3*t6*abb9n31+t4*t6*abb9n28+t5*t6*ab&
         &b9n24)
         return
      end if
      t1 = spvak3k4(iv2)
      if(deg.eq.2) then
         numerator = ((2.0_ki)*d(iv1,iv2)*abb9n20+k1(iv2)*t6*abb9n16+k2(iv2)*t6*&
         &abb9n16+k6(iv2)*t6*abb9n17+spvak5k1(iv2)*t6*abb9n23+spvak5k2(iv2)*t6*a&
         &bb9n18+spvak6k1(iv2)*t6*abb9n14+spvak6k2(iv2)*t6*abb9n15+t1*t11*abb9n2&
         &3+t1*t12*abb9n18+t1*t13*abb9n14+t1*t14*abb9n15+t1*t7*abb9n16+t1*t8*abb&
         &9n16+t1*t9*abb9n17)
         return
      end if
   end function derivative
!---#] function derivative:
!---#[ subroutine reconstruct_d9:
   subroutine     reconstruct_d9(coeffs)
      use p3_ud_emnebaruu_groups, only: tensrec_info_group5
      implicit none
      complex(ki), parameter :: czip = (0.0_ki, 0.0_ki)
      complex(ki), parameter :: cone = (1.0_ki, 0.0_ki)

      type(tensrec_info_group5), intent(out) :: coeffs
      ! rank 2 case:
      !---[# reconstruct coeffs%coeffs_9:
      coeffs%coeffs_9%c0 = derivative(czip)
      coeffs%coeffs_9%c1(1,1) = derivative(czip,1)
      coeffs%coeffs_9%c1(1,2) = derivative(czip,1,1) / 2.0_ki
      coeffs%coeffs_9%c1(2,1) = -derivative(czip,2)
      coeffs%coeffs_9%c1(2,2) = derivative(czip,2,2) / 2.0_ki
      coeffs%coeffs_9%c1(3,1) = -derivative(czip,3)
      coeffs%coeffs_9%c1(3,2) = derivative(czip,3,3) / 2.0_ki
      coeffs%coeffs_9%c1(4,1) = -derivative(czip,4)
      coeffs%coeffs_9%c1(4,2) = derivative(czip,4,4) / 2.0_ki
      coeffs%coeffs_9%c2(1,1) = -derivative(czip,1,2)
      coeffs%coeffs_9%c2(2,1) = -derivative(czip,1,3)
      coeffs%coeffs_9%c2(3,1) = -derivative(czip,1,4)
      coeffs%coeffs_9%c2(4,1) = derivative(czip,2,3)
      coeffs%coeffs_9%c2(5,1) = derivative(czip,2,4)
      coeffs%coeffs_9%c2(6,1) = derivative(czip,3,4)
      !---#] reconstruct coeffs%coeffs_9:
   end subroutine reconstruct_d9
!---#] subroutine reconstruct_d9:
end module p3_ud_emnebaruu_d9h0l1d
