module     p3_ud_emnebaruu_d65h1l1d
   ! file:      /home/pcl305a/luisonig/Documents/GoSamSherpa/W2jets/1.4/Virtual/
   ! p3_ud_emnebaruu/helicity1/d65h1l1d.f90
   ! generator: haggies (1.1)
   use p3_ud_emnebaruu_config, only: ki
   use p3_ud_emnebaruu_util, only: cond, d => metric_tensor
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   integer, private :: iv0
   integer, private :: iv1
   integer, private :: iv2
   real(ki), dimension(4), private :: qshift


   public :: derivative, reconstruct_d65
contains

!---#[ function derivative:
   function derivative(mu2, i1, i2) result(numerator)
      use p3_ud_emnebaruu_globalsl1, only: epspow
      use p3_ud_emnebaruu_kinematics
      use p3_ud_emnebaruu_abbrevd65h1
      implicit none
      complex(ki), intent(in) :: mu2
      integer, intent(in), optional :: i1
      integer, intent(in), optional :: i2
      complex(ki) :: numerator
      complex(ki) :: loc
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      integer :: deg
      complex(ki), dimension(4), parameter :: Q = (/&
        &(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki)/)
      qshift = k2
      numerator = 0.0_ki
      deg = 0
      if(present(i1)) then
         iv1 = i1
         deg = 1
      else
         iv1 = 1
      end if
      if(present(i2)) then
         iv2 = i2
         deg = 2
      else
         iv2 = 1
      end if
      t1 = (spvak1k5(1)*qshift(1)-spvak1k5(2)*qshift(2)-spvak1k5(3)*qshift(3)-sp&
      &vak1k5(4)*qshift(4))
      t2 = (spvak3k2(1)*qshift(1)-spvak3k2(2)*qshift(2)-spvak3k2(3)*qshift(3)-sp&
      &vak3k2(4)*qshift(4))
      t3 = (spvak6k2(1)*qshift(1)-spvak6k2(2)*qshift(2)-spvak6k2(3)*qshift(3)-sp&
      &vak6k2(4)*qshift(4))
      if(deg.eq.0) then
         numerator = (abb65n8+abb65n14*dotproduct(k2, qshift)+abb65n15*dotproduc&
         &t(k1, qshift)+abb65n16*(spvak1k2(1)*qshift(1)-spvak1k2(2)*qshift(2)-sp&
         &vak1k2(3)*qshift(3)-spvak1k2(4)*qshift(4))+t1*t2*abb65n10+t1*t3*abb65n&
         &9)
         return
      end if
      t4 = spvak1k5(iv1)
      t5 = spvak3k2(iv1)
      t6 = spvak6k2(iv1)
      if(deg.eq.1) then
         numerator = (k1(iv1)*abb65n12+k2(iv1)*abb65n13+spvak1k2(iv1)*abb65n11+t&
         &1*t5*abb65n17+t1*t6*abb65n18+t2*t4*abb65n17+t3*t4*abb65n18)
         return
      end if
      t1 = spvak1k5(iv2)
      if(deg.eq.2) then
         numerator = (spvak3k2(iv2)*t4*abb65n10+spvak6k2(iv2)*t4*abb65n9+t1*t5*a&
         &bb65n10+t1*t6*abb65n9)
         return
      end if
   end function derivative
!---#] function derivative:
!---#[ subroutine reconstruct_d65:
   subroutine     reconstruct_d65(coeffs)
      use p3_ud_emnebaruu_groups, only: tensrec_info_group7
      implicit none
      complex(ki), parameter :: czip = (0.0_ki, 0.0_ki)
      complex(ki), parameter :: cone = (1.0_ki, 0.0_ki)

      type(tensrec_info_group7), intent(out) :: coeffs
      ! rank 2 case:
      !---[# reconstruct coeffs%coeffs_65:
      coeffs%coeffs_65%c0 = derivative(czip)
      coeffs%coeffs_65%c1(1,1) = derivative(czip,1)
      coeffs%coeffs_65%c1(1,2) = derivative(czip,1,1) / 2.0_ki
      coeffs%coeffs_65%c1(2,1) = -derivative(czip,2)
      coeffs%coeffs_65%c1(2,2) = derivative(czip,2,2) / 2.0_ki
      coeffs%coeffs_65%c1(3,1) = -derivative(czip,3)
      coeffs%coeffs_65%c1(3,2) = derivative(czip,3,3) / 2.0_ki
      coeffs%coeffs_65%c1(4,1) = -derivative(czip,4)
      coeffs%coeffs_65%c1(4,2) = derivative(czip,4,4) / 2.0_ki
      coeffs%coeffs_65%c2(1,1) = -derivative(czip,1,2)
      coeffs%coeffs_65%c2(2,1) = -derivative(czip,1,3)
      coeffs%coeffs_65%c2(3,1) = -derivative(czip,1,4)
      coeffs%coeffs_65%c2(4,1) = derivative(czip,2,3)
      coeffs%coeffs_65%c2(5,1) = derivative(czip,2,4)
      coeffs%coeffs_65%c2(6,1) = derivative(czip,3,4)
      !---#] reconstruct coeffs%coeffs_65:
   end subroutine reconstruct_d65
!---#] subroutine reconstruct_d65:
end module p3_ud_emnebaruu_d65h1l1d
