module     p7_dubar_emnebargg_d87h0l1
   ! file:      /home/pcl305a/luisonig/Documents/GoSamSherpa/W2jets/1.4/Virtual/
   ! p7_dubar_emnebargg/helicity0/d87h0l1.f90
   ! generator: haggies (1.1)
   use p7_dubar_emnebargg_config, only: ki
   use p7_dubar_emnebargg_util, only: cond
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   public :: numerator_samurai
   public :: numerator_golem95
contains
!---#[ numerator interfaces:
   !------#[ function numerator_samurai:
   function numerator_samurai(ncut,Q_ext, mu2_ext) result(numerator)
      use precision, only: ki_sam => ki
!      use p7_dubar_emnebargg_groups, only: &
!           & sign => diagram87_sign, shift => diagram87_shift
      use p7_dubar_emnebargg_globalsl1, only: epspow
      use p7_dubar_emnebargg_kinematics
      use p7_dubar_emnebargg_abbrevd87h0
      implicit none

      integer, intent(in) :: ncut
      complex(ki_sam), dimension(4), intent(in) :: Q_ext
      complex(ki_sam), intent(in) :: mu2_ext
      complex(ki_sam) :: numerator
      complex(ki) :: d87
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11
      complex(ki) :: t12
      complex(ki) :: t13
      complex(ki) :: t14

      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      real(ki), dimension(0:3) :: qshift

      qshift = -k3-k6-k5-k4
      Q(1)   = cmplx(real(-Q_ext(4) - qshift(0),   ki_sam), aimag(-Q_ext(4)),   &
      &ki)
      Q(2:4) = cmplx(real(-Q_ext(1:3) - qshift(1:3), ki_sam), aimag(-Q_ext(1:3))&
      &, ki)
      d87 = 0.0_ki
      t1 = (Q(1)*spvak6k1(1)-Q(2)*spvak6k1(2)-Q(3)*spvak6k1(3)-Q(4)*spvak6k1(4))
      t2 = (Q(1)*Q(1)-Q(2)*Q(2)-Q(3)*Q(3)-Q(4)*Q(4))
      t3 = (Q(1)*spvak5k1(1)-Q(2)*spvak5k1(2)-Q(3)*spvak5k1(3)-Q(4)*spvak5k1(4))
      t4 = (Q(1)*spvak2k1(1)-Q(2)*spvak2k1(2)-Q(3)*spvak2k1(3)-Q(4)*spvak2k1(4))
      t5 = (Q(1)*k2(1)-Q(2)*k2(2)-Q(3)*k2(3)-Q(4)*k2(4))
      t6 = (Q(1)*spvak3k4(1)-Q(2)*spvak3k4(2)-Q(3)*spvak3k4(3)-Q(4)*spvak3k4(4))
      t7 = (Q(1)*spvak5k6(1)-Q(2)*spvak5k6(2)-Q(3)*spvak5k6(3)-Q(4)*spvak5k6(4))
      t8 = (Q(1)*k6(1)-Q(2)*k6(2)-Q(3)*k6(3)-Q(4)*k6(4))
      t9 = (Q(1)*spvak6k5(1)-Q(2)*spvak6k5(2)-Q(3)*spvak6k5(3)-Q(4)*spvak6k5(4))
      t10 = (Q(1)*k5(1)-Q(2)*k5(2)-Q(3)*k5(3)-Q(4)*k5(4))
      t11 = t2*abb87n22
      t12 = (Q(1)*spvak2k4(1)-Q(2)*spvak2k4(2)-Q(3)*spvak2k4(3)-Q(4)*spvak2k4(4)&
      &)
      t13 = (Q(1)*spvak2k5(1)-Q(2)*spvak2k5(2)-Q(3)*spvak2k5(3)-Q(4)*spvak2k5(4)&
      &)
      t14 = (Q(1)*spvak3k1(1)-Q(2)*spvak3k1(2)-Q(3)*spvak3k1(3)-Q(4)*spvak3k1(4)&
      &)
      d87 = (t1*abb87n1+t10*t11+t11*t8+t2*abb87n2+t2*t2*abb87n23+t3*abb87n3+t4*a&
      &bb87n4+t5*abb87n6+t1*t10*abb87n43+t1*t2*abb87n37+t1*t6*abb87n10+t1*t7*abb&
      &87n12+t1*t8*abb87n36+t1*t9*abb87n42+t10*t12*abb87n8+t10*t3*abb87n47+t12*t&
      &9*abb87n7+t13*t6*abb87n9+t2*t3*abb87n14+t2*t4*abb87n17+t2*t5*abb87n29+t2*&
      &t6*abb87n5+t2*t9*abb87n21+t3*t6*abb87n11+t3*t7*abb87n38+t3*t8*abb87n15+t3&
      &*t9*abb87n46+t4*t7*abb87n13+t4*t8*abb87n16+t4*t9*abb87n18+t5*t7*abb87n24+&
      &t5*t8*abb87n28+t5*t9*abb87n30+t1*t10*t7*abb87n40+t1*t2*t6*abb87n45+t1*t2*&
      &t7*abb87n39+t1*t6*t8*abb87n44+t1*t7*t8*abb87n40+t1*t7*t9*abb87n41+t10*t12&
      &*t7*abb87n26+t10*t14*t7*abb87n48+t12*t2*t7*abb87n25+t12*t7*t8*abb87n26+t1&
      &2*t7*t9*abb87n32+t13*t2*t6*abb87n34+t13*t6*t7*abb87n27+t13*t6*t8*abb87n33&
      &+t14*t2*t7*abb87n49+t14*t7*t8*abb87n48+t14*t7*t9*abb87n50+t2*t3*t6*abb87n&
      &51+t2*t6*t9*abb87n31+t3*t6*t8*abb87n52+t3*t7*t9*abb87n39+t4*t7*t9*abb87n3&
      &5+t5*t7*t9*abb87n19+t6*t9*abb87n34*(Q(1)*spvak2k6(1)-Q(2)*spvak2k6(2)-Q(3&
      &)*spvak2k6(3)-Q(4)*spvak2k6(4))+t7*t9*abb87n20*(Q(1)*k1(1)-Q(2)*k1(2)-Q(3&
      &)*k1(3)-Q(4)*k1(4))+t4*t6*t7*t9*abb87n53)
      numerator = cmplx(real(d87, ki), aimag(d87), ki_sam)
   end function numerator_samurai
   !------#] function numerator_samurai:
   !------#[ function numerator_golem95:
   function numerator_golem95(Q_ext, mu2_ext) result(numerator)
      use precision_golem, only: ki_gol => ki
      use p7_dubar_emnebargg_globalsl1, only: epspow
      use p7_dubar_emnebargg_kinematics
      use p7_dubar_emnebargg_abbrevd87h0
      implicit none

      real(ki_gol), dimension(0:3), intent(in) :: Q_ext
      real(ki_gol), intent(in) :: mu2_ext
      complex(ki_gol) :: numerator
      complex(ki) :: d87
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11
      complex(ki) :: t12
      complex(ki) :: t13
      complex(ki) :: t14

      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      real(ki), dimension(4) :: qshift

      qshift = -k3-k6-k5-k4
      Q(:) = cmplx(real(-Q_ext(:) - qshift(:), ki_gol), 0.0_ki_gol, ki)
      d87 = 0.0_ki
      t1 = (Q(1)*spvak6k1(1)-Q(2)*spvak6k1(2)-Q(3)*spvak6k1(3)-Q(4)*spvak6k1(4))
      t2 = (Q(1)*Q(1)-Q(2)*Q(2)-Q(3)*Q(3)-Q(4)*Q(4))
      t3 = (Q(1)*spvak5k1(1)-Q(2)*spvak5k1(2)-Q(3)*spvak5k1(3)-Q(4)*spvak5k1(4))
      t4 = (Q(1)*spvak2k1(1)-Q(2)*spvak2k1(2)-Q(3)*spvak2k1(3)-Q(4)*spvak2k1(4))
      t5 = (Q(1)*k2(1)-Q(2)*k2(2)-Q(3)*k2(3)-Q(4)*k2(4))
      t6 = (Q(1)*spvak3k4(1)-Q(2)*spvak3k4(2)-Q(3)*spvak3k4(3)-Q(4)*spvak3k4(4))
      t7 = (Q(1)*spvak5k6(1)-Q(2)*spvak5k6(2)-Q(3)*spvak5k6(3)-Q(4)*spvak5k6(4))
      t8 = (Q(1)*k6(1)-Q(2)*k6(2)-Q(3)*k6(3)-Q(4)*k6(4))
      t9 = (Q(1)*spvak6k5(1)-Q(2)*spvak6k5(2)-Q(3)*spvak6k5(3)-Q(4)*spvak6k5(4))
      t10 = (Q(1)*k5(1)-Q(2)*k5(2)-Q(3)*k5(3)-Q(4)*k5(4))
      t11 = t2*abb87n22
      t12 = (Q(1)*spvak2k4(1)-Q(2)*spvak2k4(2)-Q(3)*spvak2k4(3)-Q(4)*spvak2k4(4)&
      &)
      t13 = (Q(1)*spvak2k5(1)-Q(2)*spvak2k5(2)-Q(3)*spvak2k5(3)-Q(4)*spvak2k5(4)&
      &)
      t14 = (Q(1)*spvak3k1(1)-Q(2)*spvak3k1(2)-Q(3)*spvak3k1(3)-Q(4)*spvak3k1(4)&
      &)
      d87 = (t1*abb87n1+t10*t11+t11*t8+t2*abb87n2+t2*t2*abb87n23+t3*abb87n3+t4*a&
      &bb87n4+t5*abb87n6+t1*t10*abb87n43+t1*t2*abb87n37+t1*t6*abb87n10+t1*t7*abb&
      &87n12+t1*t8*abb87n36+t1*t9*abb87n42+t10*t12*abb87n8+t10*t3*abb87n47+t12*t&
      &9*abb87n7+t13*t6*abb87n9+t2*t3*abb87n14+t2*t4*abb87n17+t2*t5*abb87n29+t2*&
      &t6*abb87n5+t2*t9*abb87n21+t3*t6*abb87n11+t3*t7*abb87n38+t3*t8*abb87n15+t3&
      &*t9*abb87n46+t4*t7*abb87n13+t4*t8*abb87n16+t4*t9*abb87n18+t5*t7*abb87n24+&
      &t5*t8*abb87n28+t5*t9*abb87n30+t1*t10*t7*abb87n40+t1*t2*t6*abb87n45+t1*t2*&
      &t7*abb87n39+t1*t6*t8*abb87n44+t1*t7*t8*abb87n40+t1*t7*t9*abb87n41+t10*t12&
      &*t7*abb87n26+t10*t14*t7*abb87n48+t12*t2*t7*abb87n25+t12*t7*t8*abb87n26+t1&
      &2*t7*t9*abb87n32+t13*t2*t6*abb87n34+t13*t6*t7*abb87n27+t13*t6*t8*abb87n33&
      &+t14*t2*t7*abb87n49+t14*t7*t8*abb87n48+t14*t7*t9*abb87n50+t2*t3*t6*abb87n&
      &51+t2*t6*t9*abb87n31+t3*t6*t8*abb87n52+t3*t7*t9*abb87n39+t4*t7*t9*abb87n3&
      &5+t5*t7*t9*abb87n19+t6*t9*abb87n34*(Q(1)*spvak2k6(1)-Q(2)*spvak2k6(2)-Q(3&
      &)*spvak2k6(3)-Q(4)*spvak2k6(4))+t7*t9*abb87n20*(Q(1)*k1(1)-Q(2)*k1(2)-Q(3&
      &)*k1(3)-Q(4)*k1(4))+t4*t6*t7*t9*abb87n53)

      numerator = cmplx(real(d87, ki), aimag(d87), ki_gol)
   end function numerator_golem95
   !------#] function numerator_golem95:
!---#] numerator interfaces:
end module p7_dubar_emnebargg_d87h0l1
