module     p7_dubar_emnebargg_d14h1l1d
   ! file:      /home/pcl305a/luisonig/Documents/GoSamSherpa/W2jets/1.4/Virtual/
   ! p7_dubar_emnebargg/helicity1/d14h1l1d.f90
   ! generator: haggies (1.1)
   use p7_dubar_emnebargg_config, only: ki
   use p7_dubar_emnebargg_util, only: cond, d => metric_tensor
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   integer, private :: iv0
   integer, private :: iv1
   real(ki), dimension(4), private :: qshift


   public :: derivative, reconstruct_d14
contains

!---#[ function derivative:
   function derivative(mu2, i1) result(numerator)
      use p7_dubar_emnebargg_globalsl1, only: epspow
      use p7_dubar_emnebargg_kinematics
      use p7_dubar_emnebargg_abbrevd14h1
      implicit none
      complex(ki), intent(in) :: mu2
      integer, intent(in), optional :: i1
      complex(ki) :: numerator
      complex(ki) :: loc
      integer :: deg
      complex(ki), dimension(4), parameter :: Q = (/&
        &(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki)/)
      qshift = -k3+k2-k4
      numerator = 0.0_ki
      deg = 0
      if(present(i1)) then
         iv1 = i1
         deg = 1
      else
         iv1 = 1
      end if
      if(deg.eq.0) then
         numerator = (abb14n9+abb14n16*(spvak5k1(1)*qshift(1)-spvak5k1(2)*qshift&
         &(2)-spvak5k1(3)*qshift(3)-spvak5k1(4)*qshift(4))+abb14n17*(spvak6k1(1)&
         &*qshift(1)-spvak6k1(2)*qshift(2)-spvak6k1(3)*qshift(3)-spvak6k1(4)*qsh&
         &ift(4))+abb14n18*(spvak5k6(1)*qshift(1)-spvak5k6(2)*qshift(2)-spvak5k6&
         &(3)*qshift(3)-spvak5k6(4)*qshift(4))+abb14n19*dotproduct(k6, qshift)+a&
         &bb14n20*dotproduct(k1, qshift)+abb14n21*(spvak1k6(1)*qshift(1)-spvak1k&
         &6(2)*qshift(2)-spvak1k6(3)*qshift(3)-spvak1k6(4)*qshift(4)))
         return
      end if
      if(deg.eq.1) then
         numerator = (k1(iv1)*abb14n11+k6(iv1)*abb14n12+spvak1k6(iv1)*abb14n10+s&
         &pvak5k1(iv1)*abb14n15+spvak5k6(iv1)*abb14n13+spvak6k1(iv1)*abb14n14)
         return
      end if
   end function derivative
!---#] function derivative:
!---#[ subroutine reconstruct_d14:
   subroutine     reconstruct_d14(coeffs)
      use p7_dubar_emnebargg_groups, only: tensrec_info_group3
      implicit none
      complex(ki), parameter :: czip = (0.0_ki, 0.0_ki)
      complex(ki), parameter :: cone = (1.0_ki, 0.0_ki)

      type(tensrec_info_group3), intent(out) :: coeffs
      ! rank 1 case:
      !---[# reconstruct coeffs%coeffs_14:
      coeffs%coeffs_14%c0 = derivative(czip)
      coeffs%coeffs_14%c1(1,1) = derivative(czip,1)
      coeffs%coeffs_14%c1(2,1) = -derivative(czip,2)
      coeffs%coeffs_14%c1(3,1) = -derivative(czip,3)
      coeffs%coeffs_14%c1(4,1) = -derivative(czip,4)
      !---#] reconstruct coeffs%coeffs_14:
   end subroutine reconstruct_d14
!---#] subroutine reconstruct_d14:
end module p7_dubar_emnebargg_d14h1l1d
