module     p7_dubar_emnebargg_d22h1l1d
   ! file:      /home/pcl305a/luisonig/Documents/GoSamSherpa/W2jets/1.4/Virtual/
   ! p7_dubar_emnebargg/helicity1/d22h1l1d.f90
   ! generator: haggies (1.1)
   use p7_dubar_emnebargg_config, only: ki
   use p7_dubar_emnebargg_util, only: cond, d => metric_tensor
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   integer, private :: iv0
   integer, private :: iv1
   integer, private :: iv2
   integer, private :: iv3
   real(ki), dimension(4), private :: qshift


   public :: derivative, reconstruct_d22
contains

!---#[ function derivative:
   function derivative(mu2, i1, i2, i3) result(numerator)
      use p7_dubar_emnebargg_globalsl1, only: epspow
      use p7_dubar_emnebargg_kinematics
      use p7_dubar_emnebargg_abbrevd22h1
      implicit none
      complex(ki), intent(in) :: mu2
      integer, intent(in), optional :: i1
      integer, intent(in), optional :: i2
      integer, intent(in), optional :: i3
      complex(ki) :: numerator
      complex(ki) :: loc
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11
      complex(ki) :: t12
      complex(ki) :: t13
      complex(ki) :: t14
      complex(ki) :: t15
      complex(ki) :: t16
      complex(ki) :: t17
      complex(ki) :: t18
      complex(ki) :: t19
      complex(ki) :: t20
      complex(ki) :: t21
      complex(ki) :: t22
      complex(ki) :: t23
      complex(ki) :: t24
      real(ki) :: t25
      real(ki) :: t26
      real(ki) :: t27
      integer :: deg
      complex(ki), dimension(4), parameter :: Q = (/&
        &(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki)/)
      qshift(:) = 0.0_ki
      numerator = 0.0_ki
      deg = 0
      if(present(i1)) then
         iv1 = i1
         deg = 1
      else
         iv1 = 1
      end if
      if(present(i2)) then
         iv2 = i2
         deg = 2
      else
         iv2 = 1
      end if
      if(present(i3)) then
         iv3 = i3
         deg = 3
      else
         iv3 = 1
      end if
      if(deg.eq.0) then
         numerator = abb22n37
         return
      end if
      t1 = k1(iv1)
      t2 = k2(iv1)
      t3 = k5(iv1)
      t4 = k6(iv1)
      t5 = spvak3k4(iv1)
      t6 = spvak5k1(iv1)
      t7 = spvak5k6(iv1)
      if(deg.eq.1) then
         numerator = (t1*abb22n65+t2*abb22n56+t3*abb22n64+t4*abb22n58+t5*abb22n5&
         &5+t6*abb22n59+t7*abb22n61)
         return
      end if
      t25 = d(iv1,iv2)
      t8 = k1(iv2)
      t9 = k5(iv2)
      t10 = spvak5k6(iv2)
      t11 = k6(iv2)
      t12 = spvak3k4(iv2)
      t13 = t1*t12
      t14 = spvak5k1(iv2)
      t15 = t5*t8
      t16 = k2(iv2)
      t17 = t12*t3
      t18 = t5*t9
      t19 = t10*t5
      t20 = t12*t7
      if(deg.eq.2) then
         numerator = ((2.0_ki)*(t25*abb22n51+t1*t8*abb22n43+t10*t7*abb22n46+t3*t&
         &9*abb22n43)+t13*abb22n53+t15*abb22n53+t17*abb22n52+t18*abb22n52+t19*ab&
         &b22n50+t20*abb22n50+spvak2k4(iv1)*t10*abb22n49+spvak2k4(iv2)*t7*abb22n&
         &49+t1*t10*abb22n41+t1*t11*abb22n44+t1*t14*abb22n39+t1*t9*abb22n45+t10*&
         &t2*abb22n54+t10*t3*abb22n42+t10*t4*abb22n47+t10*t6*abb22n38+t11*t3*abb&
         &22n43+t11*t5*abb22n53+t11*t6*abb22n40+t11*t7*abb22n47+t12*t4*abb22n53+&
         &t14*t2*abb22n48+t14*t3*abb22n40+t14*t4*abb22n40+t14*t7*abb22n38+t16*t6&
         &*abb22n48+t16*t7*abb22n54+t3*t8*abb22n45+t4*t8*abb22n44+t4*t9*abb22n43&
         &+t6*t8*abb22n39+t6*t9*abb22n40+t7*t8*abb22n41+t7*t9*abb22n42)
         return
      end if
      t26 = d(iv2,iv3)
      t27 = d(iv1,iv3)
      t2 = k1(iv3)
      t4 = k5(iv3)
      t11 = spvak3k4(iv3)
      t16 = spvak5k1(iv3)
      t21 = spvak5k6(iv3)
      t22 = spvak2k1(iv1)
      t23 = spvak2k1(iv2)
      t24 = spvak2k1(iv3)
      if(deg.eq.3) then
         numerator = ((2.0_ki)*(t1*t26*abb22n66+t10*t27*abb22n62+t11*t25*abb22n5&
         &7+t12*t27*abb22n57+t14*t27*abb22n70+t16*t25*abb22n70+t19*t21*abb22n63+&
         &t2*t25*abb22n66+t20*t21*abb22n63+t21*t25*abb22n62+t25*t4*abb22n67+t26*&
         &t3*abb22n67+t26*t5*abb22n57+t26*t6*abb22n70+t26*t7*abb22n62+t27*t8*abb&
         &22n66+t27*t9*abb22n67+t10*t11*t7*abb22n63)+t13*t21*abb22n69+t15*t21*ab&
         &b22n69+t17*t21*abb22n68+t18*t21*abb22n68+t1*t10*t11*abb22n69+t10*t11*t&
         &22*abb22n60+t10*t11*t3*abb22n68+t10*t11*t6*abb22n71+t10*t16*t5*abb22n7&
         &1+t10*t2*t5*abb22n69+t10*t24*t5*abb22n60+t10*t4*t5*abb22n68+t11*t14*t7&
         &*abb22n71+t11*t23*t7*abb22n60+t11*t7*t8*abb22n69+t11*t7*t9*abb22n68+t1&
         &2*t16*t7*abb22n71+t12*t2*t7*abb22n69+t12*t21*t22*abb22n60+t12*t21*t6*a&
         &bb22n71+t12*t24*t7*abb22n60+t12*t4*t7*abb22n68+t14*t21*t5*abb22n71+t21&
         &*t23*t5*abb22n60)
         return
      end if
   end function derivative
!---#] function derivative:
!---#[ subroutine reconstruct_d22:
   subroutine     reconstruct_d22(coeffs)
      use p7_dubar_emnebargg_groups, only: tensrec_info_group7
      implicit none
      complex(ki), parameter :: czip = (0.0_ki, 0.0_ki)
      complex(ki), parameter :: cone = (1.0_ki, 0.0_ki)

      type(tensrec_info_group7), intent(out) :: coeffs
      ! rank 3 case:
      !---[# reconstruct coeffs%coeffs_22:
      coeffs%coeffs_22%c0 = derivative(czip)
      coeffs%coeffs_22%c1(1,1) = derivative(czip,1)
      coeffs%coeffs_22%c1(1,2) = derivative(czip,1,1) / 2.0_ki
      coeffs%coeffs_22%c1(1,3) = derivative(czip,1,1,1) / 6.0_ki
      coeffs%coeffs_22%c1(2,1) = -derivative(czip,2)
      coeffs%coeffs_22%c1(2,2) = derivative(czip,2,2) / 2.0_ki
      coeffs%coeffs_22%c1(2,3) = -derivative(czip,2,2,2) / 6.0_ki
      coeffs%coeffs_22%c1(3,1) = -derivative(czip,3)
      coeffs%coeffs_22%c1(3,2) = derivative(czip,3,3) / 2.0_ki
      coeffs%coeffs_22%c1(3,3) = -derivative(czip,3,3,3) / 6.0_ki
      coeffs%coeffs_22%c1(4,1) = -derivative(czip,4)
      coeffs%coeffs_22%c1(4,2) = derivative(czip,4,4) / 2.0_ki
      coeffs%coeffs_22%c1(4,3) = -derivative(czip,4,4,4) / 6.0_ki
      coeffs%coeffs_22%c2(1,1) = -derivative(czip,1,2)
      coeffs%coeffs_22%c2(1,2) = derivative(czip,1,2,2) / 2.0_ki
      coeffs%coeffs_22%c2(1,3) = -derivative(czip,1,1,2) / 2.0_ki
      coeffs%coeffs_22%c2(2,1) = -derivative(czip,1,3)
      coeffs%coeffs_22%c2(2,2) = derivative(czip,1,3,3) / 2.0_ki
      coeffs%coeffs_22%c2(2,3) = -derivative(czip,1,1,3) / 2.0_ki
      coeffs%coeffs_22%c2(3,1) = -derivative(czip,1,4)
      coeffs%coeffs_22%c2(3,2) = derivative(czip,1,4,4) / 2.0_ki
      coeffs%coeffs_22%c2(3,3) = -derivative(czip,1,1,4) / 2.0_ki
      coeffs%coeffs_22%c2(4,1) = derivative(czip,2,3)
      coeffs%coeffs_22%c2(4,2) = -derivative(czip,2,3,3) / 2.0_ki
      coeffs%coeffs_22%c2(4,3) = -derivative(czip,2,2,3) / 2.0_ki
      coeffs%coeffs_22%c2(5,1) = derivative(czip,2,4)
      coeffs%coeffs_22%c2(5,2) = -derivative(czip,2,4,4) / 2.0_ki
      coeffs%coeffs_22%c2(5,3) = -derivative(czip,2,2,4) / 2.0_ki
      coeffs%coeffs_22%c2(6,1) = derivative(czip,3,4)
      coeffs%coeffs_22%c2(6,2) = -derivative(czip,3,4,4) / 2.0_ki
      coeffs%coeffs_22%c2(6,3) = -derivative(czip,3,3,4) / 2.0_ki
      coeffs%coeffs_22%c3(1,1) = derivative(czip,1,2,3)
      coeffs%coeffs_22%c3(2,1) = derivative(czip,1,2,4)
      coeffs%coeffs_22%c3(3,1) = derivative(czip,1,3,4)
      coeffs%coeffs_22%c3(4,1) = -derivative(czip,2,3,4)
      !---#] reconstruct coeffs%coeffs_22:
   end subroutine reconstruct_d22
!---#] subroutine reconstruct_d22:
end module p7_dubar_emnebargg_d22h1l1d
