module     p7_dubar_emnebargg_d22h3l1d
   ! file:      /home/pcl305a/luisonig/Documents/GoSamSherpa/W2jets/1.4/Virtual/
   ! p7_dubar_emnebargg/helicity3/d22h3l1d.f90
   ! generator: haggies (1.1)
   use p7_dubar_emnebargg_config, only: ki
   use p7_dubar_emnebargg_util, only: cond, d => metric_tensor
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   integer, private :: iv0
   integer, private :: iv1
   integer, private :: iv2
   integer, private :: iv3
   real(ki), dimension(4), private :: qshift


   public :: derivative, reconstruct_d22
contains

!---#[ function derivative:
   function derivative(mu2, i1, i2, i3) result(numerator)
      use p7_dubar_emnebargg_globalsl1, only: epspow
      use p7_dubar_emnebargg_kinematics
      use p7_dubar_emnebargg_abbrevd22h3
      implicit none
      complex(ki), intent(in) :: mu2
      integer, intent(in), optional :: i1
      integer, intent(in), optional :: i2
      integer, intent(in), optional :: i3
      complex(ki) :: numerator
      complex(ki) :: loc
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11
      complex(ki) :: t12
      complex(ki) :: t13
      complex(ki) :: t14
      complex(ki) :: t15
      complex(ki) :: t16
      complex(ki) :: t17
      complex(ki) :: t18
      complex(ki) :: t19
      complex(ki) :: t20
      complex(ki) :: t21
      complex(ki) :: t22
      complex(ki) :: t23
      complex(ki) :: t24
      complex(ki) :: t25
      complex(ki) :: t26
      complex(ki) :: t27
      complex(ki) :: t28
      complex(ki) :: t29
      real(ki) :: t30
      real(ki) :: t31
      real(ki) :: t32
      integer :: deg
      complex(ki), dimension(4), parameter :: Q = (/&
        &(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki)/)
      qshift(:) = 0.0_ki
      numerator = 0.0_ki
      deg = 0
      if(present(i1)) then
         iv1 = i1
         deg = 1
      else
         iv1 = 1
      end if
      if(present(i2)) then
         iv2 = i2
         deg = 2
      else
         iv2 = 1
      end if
      if(present(i3)) then
         iv3 = i3
         deg = 3
      else
         iv3 = 1
      end if
      if(deg.eq.0) then
         numerator = abb22n47
         return
      end if
      t1 = k1(iv1)
      t2 = k2(iv1)
      t3 = k5(iv1)
      t4 = k6(iv1)
      t5 = spvak3k4(iv1)
      t6 = spvak5k1(iv1)
      t7 = spvak5k6(iv1)
      t8 = spvak6k5(iv1)
      if(deg.eq.1) then
         numerator = (t1*abb22n85+t2*abb22n74+t3*abb22n84+t4*abb22n76+t5*abb22n7&
         &3+t6*abb22n79+t7*abb22n81+t8*abb22n78)
         return
      end if
      t30 = d(iv1,iv2)
      t9 = k1(iv2)
      t10 = k5(iv2)
      t11 = k2(iv2)
      t12 = k6(iv2)
      t13 = spvak3k4(iv2)
      t14 = t1*t13
      t15 = spvak5k1(iv2)
      t16 = spvak5k6(iv2)
      t17 = spvak6k5(iv2)
      t18 = t5*t9
      t19 = t13*t3
      t20 = t10*t5
      t21 = t15*t5
      t22 = t16*t5
      t23 = t13*t6
      t24 = t13*t7
      if(deg.eq.2) then
         numerator = ((2.0_ki)*(t30*abb22n64+t1*t9*abb22n53+t10*t3*abb22n53)+t14&
         &*abb22n70+t18*abb22n70+t19*abb22n69+t20*abb22n69+t21*abb22n67+t22*abb2&
         &2n72+t23*abb22n67+t24*abb22n72+spvak2k4(iv1)*t17*abb22n62+spvak2k4(iv2&
         &)*t8*abb22n62+t1*t10*abb22n55+t1*t11*abb22n57+t1*t12*abb22n54+t1*t15*a&
         &bb22n49+t1*t16*abb22n59+t1*t17*abb22n51+t10*t2*abb22n56+t10*t4*abb22n5&
         &3+t10*t6*abb22n50+t10*t7*abb22n60+t10*t8*abb22n52+t11*t3*abb22n56+t11*&
         &t6*abb22n68+t11*t7*abb22n61+t11*t8*abb22n65+t12*t3*abb22n53+t12*t5*abb&
         &22n71+t12*t6*abb22n50+t12*t7*abb22n60+t12*t8*abb22n66+t13*t4*abb22n71+&
         &t13*t8*abb22n63+t15*t2*abb22n68+t15*t3*abb22n50+t15*t4*abb22n50+t15*t8&
         &*abb22n48+t16*t2*abb22n61+t16*t3*abb22n60+t16*t4*abb22n60+t16*t8*abb22&
         &n58+t17*t2*abb22n65+t17*t3*abb22n52+t17*t4*abb22n66+t17*t5*abb22n63+t1&
         &7*t6*abb22n48+t17*t7*abb22n58+t2*t9*abb22n57+t3*t9*abb22n55+t4*t9*abb2&
         &2n54+t6*t9*abb22n49+t7*t9*abb22n59+t8*t9*abb22n51)
         return
      end if
      t31 = d(iv2,iv3)
      t32 = d(iv1,iv3)
      t2 = k1(iv3)
      t4 = k5(iv3)
      t11 = spvak3k4(iv3)
      t12 = spvak5k1(iv3)
      t25 = spvak5k6(iv3)
      t26 = spvak6k5(iv3)
      t27 = spvak2k1(iv1)
      t28 = spvak2k1(iv2)
      t29 = spvak2k1(iv3)
      if(deg.eq.3) then
         numerator = ((2.0_ki)*(t1*t31*abb22n88+t10*t32*abb22n89+t11*t30*abb22n7&
         &5+t12*t30*abb22n91+t13*t32*abb22n75+t15*t32*abb22n91+t16*t32*abb22n83+&
         &t17*t32*abb22n77+t2*t30*abb22n88+t25*t30*abb22n83+t26*t30*abb22n77+t3*&
         &t31*abb22n89+t30*t4*abb22n89+t31*t5*abb22n75+t31*t6*abb22n91+t31*t7*ab&
         &b22n83+t31*t8*abb22n77+t32*t9*abb22n88)+t14*t26*abb22n87+t18*t26*abb22&
         &n87+t19*t26*abb22n86+t20*t26*abb22n86+t21*t26*abb22n90+t22*t26*abb22n8&
         &2+t23*t26*abb22n90+t24*t26*abb22n82+t1*t11*t17*abb22n87+t10*t11*t8*abb&
         &22n86+t11*t15*t8*abb22n90+t11*t16*t8*abb22n82+t11*t17*t27*abb22n80+t11&
         &*t17*t3*abb22n86+t11*t17*t6*abb22n90+t11*t17*t7*abb22n82+t11*t28*t8*ab&
         &b22n80+t11*t8*t9*abb22n87+t12*t13*t8*abb22n90+t12*t17*t5*abb22n90+t13*&
         &t2*t8*abb22n87+t13*t25*t8*abb22n82+t13*t26*t27*abb22n80+t13*t29*t8*abb&
         &22n80+t13*t4*t8*abb22n86+t17*t2*t5*abb22n87+t17*t25*t5*abb22n82+t17*t2&
         &9*t5*abb22n80+t17*t4*t5*abb22n86+t26*t28*t5*abb22n80)
         return
      end if
   end function derivative
!---#] function derivative:
!---#[ subroutine reconstruct_d22:
   subroutine     reconstruct_d22(coeffs)
      use p7_dubar_emnebargg_groups, only: tensrec_info_group7
      implicit none
      complex(ki), parameter :: czip = (0.0_ki, 0.0_ki)
      complex(ki), parameter :: cone = (1.0_ki, 0.0_ki)

      type(tensrec_info_group7), intent(out) :: coeffs
      ! rank 3 case:
      !---[# reconstruct coeffs%coeffs_22:
      coeffs%coeffs_22%c0 = derivative(czip)
      coeffs%coeffs_22%c1(1,1) = derivative(czip,1)
      coeffs%coeffs_22%c1(1,2) = derivative(czip,1,1) / 2.0_ki
      coeffs%coeffs_22%c1(1,3) = derivative(czip,1,1,1) / 6.0_ki
      coeffs%coeffs_22%c1(2,1) = -derivative(czip,2)
      coeffs%coeffs_22%c1(2,2) = derivative(czip,2,2) / 2.0_ki
      coeffs%coeffs_22%c1(2,3) = -derivative(czip,2,2,2) / 6.0_ki
      coeffs%coeffs_22%c1(3,1) = -derivative(czip,3)
      coeffs%coeffs_22%c1(3,2) = derivative(czip,3,3) / 2.0_ki
      coeffs%coeffs_22%c1(3,3) = -derivative(czip,3,3,3) / 6.0_ki
      coeffs%coeffs_22%c1(4,1) = -derivative(czip,4)
      coeffs%coeffs_22%c1(4,2) = derivative(czip,4,4) / 2.0_ki
      coeffs%coeffs_22%c1(4,3) = -derivative(czip,4,4,4) / 6.0_ki
      coeffs%coeffs_22%c2(1,1) = -derivative(czip,1,2)
      coeffs%coeffs_22%c2(1,2) = derivative(czip,1,2,2) / 2.0_ki
      coeffs%coeffs_22%c2(1,3) = -derivative(czip,1,1,2) / 2.0_ki
      coeffs%coeffs_22%c2(2,1) = -derivative(czip,1,3)
      coeffs%coeffs_22%c2(2,2) = derivative(czip,1,3,3) / 2.0_ki
      coeffs%coeffs_22%c2(2,3) = -derivative(czip,1,1,3) / 2.0_ki
      coeffs%coeffs_22%c2(3,1) = -derivative(czip,1,4)
      coeffs%coeffs_22%c2(3,2) = derivative(czip,1,4,4) / 2.0_ki
      coeffs%coeffs_22%c2(3,3) = -derivative(czip,1,1,4) / 2.0_ki
      coeffs%coeffs_22%c2(4,1) = derivative(czip,2,3)
      coeffs%coeffs_22%c2(4,2) = -derivative(czip,2,3,3) / 2.0_ki
      coeffs%coeffs_22%c2(4,3) = -derivative(czip,2,2,3) / 2.0_ki
      coeffs%coeffs_22%c2(5,1) = derivative(czip,2,4)
      coeffs%coeffs_22%c2(5,2) = -derivative(czip,2,4,4) / 2.0_ki
      coeffs%coeffs_22%c2(5,3) = -derivative(czip,2,2,4) / 2.0_ki
      coeffs%coeffs_22%c2(6,1) = derivative(czip,3,4)
      coeffs%coeffs_22%c2(6,2) = -derivative(czip,3,4,4) / 2.0_ki
      coeffs%coeffs_22%c2(6,3) = -derivative(czip,3,3,4) / 2.0_ki
      coeffs%coeffs_22%c3(1,1) = derivative(czip,1,2,3)
      coeffs%coeffs_22%c3(2,1) = derivative(czip,1,2,4)
      coeffs%coeffs_22%c3(3,1) = derivative(czip,1,3,4)
      coeffs%coeffs_22%c3(4,1) = -derivative(czip,2,3,4)
      !---#] reconstruct coeffs%coeffs_22:
   end subroutine reconstruct_d22
!---#] subroutine reconstruct_d22:
end module p7_dubar_emnebargg_d22h3l1d
