module     p7_dubar_emnebargg_d23h3l1d
   ! file:      /home/pcl305a/luisonig/Documents/GoSamSherpa/W2jets/1.4/Virtual/
   ! p7_dubar_emnebargg/helicity3/d23h3l1d.f90
   ! generator: haggies (1.1)
   use p7_dubar_emnebargg_config, only: ki
   use p7_dubar_emnebargg_util, only: cond, d => metric_tensor
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   integer, private :: iv0
   integer, private :: iv1
   integer, private :: iv2
   integer, private :: iv3
   real(ki), dimension(4), private :: qshift


   public :: derivative, reconstruct_d23
contains

!---#[ function derivative:
   function derivative(mu2, i1, i2, i3) result(numerator)
      use p7_dubar_emnebargg_globalsl1, only: epspow
      use p7_dubar_emnebargg_kinematics
      use p7_dubar_emnebargg_abbrevd23h3
      implicit none
      complex(ki), intent(in) :: mu2
      integer, intent(in), optional :: i1
      integer, intent(in), optional :: i2
      integer, intent(in), optional :: i3
      complex(ki) :: numerator
      complex(ki) :: loc
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11
      complex(ki) :: t12
      complex(ki) :: t13
      complex(ki) :: t14
      complex(ki) :: t15
      complex(ki) :: t16
      complex(ki) :: t17
      complex(ki) :: t18
      complex(ki) :: t19
      complex(ki) :: t20
      complex(ki) :: t21
      complex(ki) :: t22
      complex(ki) :: t23
      complex(ki) :: t24
      complex(ki) :: t25
      complex(ki) :: t26
      complex(ki) :: t27
      complex(ki) :: t28
      complex(ki) :: t29
      real(ki) :: t30
      real(ki) :: t31
      real(ki) :: t32
      integer :: deg
      complex(ki), dimension(4), parameter :: Q = (/&
        &(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki)/)
      qshift(:) = 0.0_ki
      numerator = 0.0_ki
      deg = 0
      if(present(i1)) then
         iv1 = i1
         deg = 1
      else
         iv1 = 1
      end if
      if(present(i2)) then
         iv2 = i2
         deg = 2
      else
         iv2 = 1
      end if
      if(present(i3)) then
         iv3 = i3
         deg = 3
      else
         iv3 = 1
      end if
      if(deg.eq.0) then
         numerator = (0.0_ki)
         return
      end if
      t1 = k5(iv1)
      t2 = spvak5k6(iv1)
      if(deg.eq.1) then
         numerator = (t1*abb23n53+t2*abb23n28)
         return
      end if
      t30 = d(iv1,iv2)
      t3 = k1(iv1)
      t4 = k5(iv2)
      t5 = spvak5k6(iv2)
      t6 = k1(iv2)
      t7 = k6(iv2)
      t8 = spvak2k6(iv2)
      t9 = spvak6k1(iv2)
      t10 = spvak6k5(iv2)
      t11 = k6(iv1)
      t12 = spvak2k6(iv1)
      t13 = spvak6k1(iv1)
      t14 = spvak6k5(iv1)
      t15 = spvak3k4(iv1)
      t16 = t15*t5
      t17 = spvak3k4(iv2)
      t18 = t17*t2
      if(deg.eq.2) then
         numerator = (t16*abb23n51+t18*abb23n51+(2.0_ki)*t30*abb23n52+k2(iv1)*t5&
         &*abb23n48+k2(iv2)*t2*abb23n48+spvak2k4(iv1)*t5*abb23n50+spvak2k4(iv2)*&
         &t2*abb23n50+spvak2k5(iv1)*t5*abb23n47+spvak2k5(iv2)*t2*abb23n47+t1*t10&
         &*abb23n35+t1*t6*abb23n41+t1*t7*abb23n44+t1*t8*abb23n46+t1*t9*abb23n32+&
         &t10*t2*abb23n34+t11*t4*abb23n44+t11*t5*abb23n40+t12*t4*abb23n46+t13*t4&
         &*abb23n32+t13*t5*abb23n30+t14*t4*abb23n35+t14*t5*abb23n34+t2*t6*abb23n&
         &39+t2*t7*abb23n40+t2*t9*abb23n30+t3*t4*abb23n41+t3*t5*abb23n39)
         return
      end if
      t31 = d(iv2,iv3)
      t32 = d(iv1,iv3)
      t1 = k1(iv3)
      t4 = k6(iv3)
      t19 = spvak5k6(iv3)
      t20 = spvak6k1(iv3)
      t21 = spvak6k5(iv3)
      t22 = spvak3k4(iv3)
      t23 = spvak2k1(iv1)
      t24 = spvak2k1(iv2)
      t25 = spvak2k1(iv3)
      t26 = t15*t19
      t27 = t17*t19
      t28 = t2*t22
      t29 = t22*t5
      if(deg.eq.3) then
         numerator = ((2.0_ki)*(spvak2k6(iv3)*t30*abb23n47+t1*t30*abb23n43+t10*t&
         &32*abb23n36+t11*t31*abb23n42+t12*t31*abb23n47+t13*t31*abb23n31+t14*t31&
         &*abb23n36+t19*t30*abb23n49+t2*t31*abb23n49+t20*t30*abb23n31+t21*t30*ab&
         &b23n36+t3*t31*abb23n43+t30*t4*abb23n42+t32*t5*abb23n49+t32*t6*abb23n43&
         &+t32*t7*abb23n42+t32*t8*abb23n47+t32*t9*abb23n31)+t10*t26*abb23n33+t10&
         &*t28*abb23n33+t13*t27*abb23n29+t13*t29*abb23n29+t14*t27*abb23n33+t14*t&
         &29*abb23n33+t16*t20*abb23n29+t16*t21*abb23n33+t18*t20*abb23n29+t18*t21&
         &*abb23n33+t26*t9*abb23n29+t28*t9*abb23n29+t1*t15*t5*abb23n37+t1*t17*t2&
         &*abb23n37+t11*t17*t19*abb23n38+t11*t22*t5*abb23n38+t15*t19*t24*abb23n4&
         &5+t15*t19*t6*abb23n37+t15*t19*t7*abb23n38+t15*t25*t5*abb23n45+t15*t4*t&
         &5*abb23n38+t17*t19*t23*abb23n45+t17*t19*t3*abb23n37+t17*t2*t25*abb23n4&
         &5+t17*t2*t4*abb23n38+t2*t22*t24*abb23n45+t2*t22*t6*abb23n37+t2*t22*t7*&
         &abb23n38+t22*t23*t5*abb23n45+t22*t3*t5*abb23n37)
         return
      end if
   end function derivative
!---#] function derivative:
!---#[ subroutine reconstruct_d23:
   subroutine     reconstruct_d23(coeffs)
      use p7_dubar_emnebargg_groups, only: tensrec_info_group6
      implicit none
      complex(ki), parameter :: czip = (0.0_ki, 0.0_ki)
      complex(ki), parameter :: cone = (1.0_ki, 0.0_ki)

      type(tensrec_info_group6), intent(out) :: coeffs
      ! rank 3 case:
      !---[# reconstruct coeffs%coeffs_23:
      coeffs%coeffs_23%c0 = derivative(czip)
      coeffs%coeffs_23%c1(1,1) = derivative(czip,1)
      coeffs%coeffs_23%c1(1,2) = derivative(czip,1,1) / 2.0_ki
      coeffs%coeffs_23%c1(1,3) = derivative(czip,1,1,1) / 6.0_ki
      coeffs%coeffs_23%c1(2,1) = -derivative(czip,2)
      coeffs%coeffs_23%c1(2,2) = derivative(czip,2,2) / 2.0_ki
      coeffs%coeffs_23%c1(2,3) = -derivative(czip,2,2,2) / 6.0_ki
      coeffs%coeffs_23%c1(3,1) = -derivative(czip,3)
      coeffs%coeffs_23%c1(3,2) = derivative(czip,3,3) / 2.0_ki
      coeffs%coeffs_23%c1(3,3) = -derivative(czip,3,3,3) / 6.0_ki
      coeffs%coeffs_23%c1(4,1) = -derivative(czip,4)
      coeffs%coeffs_23%c1(4,2) = derivative(czip,4,4) / 2.0_ki
      coeffs%coeffs_23%c1(4,3) = -derivative(czip,4,4,4) / 6.0_ki
      coeffs%coeffs_23%c2(1,1) = -derivative(czip,1,2)
      coeffs%coeffs_23%c2(1,2) = derivative(czip,1,2,2) / 2.0_ki
      coeffs%coeffs_23%c2(1,3) = -derivative(czip,1,1,2) / 2.0_ki
      coeffs%coeffs_23%c2(2,1) = -derivative(czip,1,3)
      coeffs%coeffs_23%c2(2,2) = derivative(czip,1,3,3) / 2.0_ki
      coeffs%coeffs_23%c2(2,3) = -derivative(czip,1,1,3) / 2.0_ki
      coeffs%coeffs_23%c2(3,1) = -derivative(czip,1,4)
      coeffs%coeffs_23%c2(3,2) = derivative(czip,1,4,4) / 2.0_ki
      coeffs%coeffs_23%c2(3,3) = -derivative(czip,1,1,4) / 2.0_ki
      coeffs%coeffs_23%c2(4,1) = derivative(czip,2,3)
      coeffs%coeffs_23%c2(4,2) = -derivative(czip,2,3,3) / 2.0_ki
      coeffs%coeffs_23%c2(4,3) = -derivative(czip,2,2,3) / 2.0_ki
      coeffs%coeffs_23%c2(5,1) = derivative(czip,2,4)
      coeffs%coeffs_23%c2(5,2) = -derivative(czip,2,4,4) / 2.0_ki
      coeffs%coeffs_23%c2(5,3) = -derivative(czip,2,2,4) / 2.0_ki
      coeffs%coeffs_23%c2(6,1) = derivative(czip,3,4)
      coeffs%coeffs_23%c2(6,2) = -derivative(czip,3,4,4) / 2.0_ki
      coeffs%coeffs_23%c2(6,3) = -derivative(czip,3,3,4) / 2.0_ki
      coeffs%coeffs_23%c3(1,1) = derivative(czip,1,2,3)
      coeffs%coeffs_23%c3(2,1) = derivative(czip,1,2,4)
      coeffs%coeffs_23%c3(3,1) = derivative(czip,1,3,4)
      coeffs%coeffs_23%c3(4,1) = -derivative(czip,2,3,4)
      !---#] reconstruct coeffs%coeffs_23:
   end subroutine reconstruct_d23
!---#] subroutine reconstruct_d23:
end module p7_dubar_emnebargg_d23h3l1d
