module     p7_dubar_emnebargg_d30h3l1
   ! file:      /home/pcl305a/luisonig/Documents/GoSamSherpa/W2jets/1.4/Virtual/
   ! p7_dubar_emnebargg/helicity3/d30h3l1.f90
   ! generator: haggies (1.1)
   use p7_dubar_emnebargg_config, only: ki
   use p7_dubar_emnebargg_util, only: cond
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   public :: numerator_samurai
   public :: numerator_golem95
contains
!---#[ numerator interfaces:
   !------#[ function numerator_samurai:
   function numerator_samurai(ncut,Q_ext, mu2_ext) result(numerator)
      use precision, only: ki_sam => ki
!      use p7_dubar_emnebargg_groups, only: &
!           & sign => diagram30_sign, shift => diagram30_shift
      use p7_dubar_emnebargg_globalsl1, only: epspow
      use p7_dubar_emnebargg_kinematics
      use p7_dubar_emnebargg_abbrevd30h3
      implicit none

      integer, intent(in) :: ncut
      complex(ki_sam), dimension(4), intent(in) :: Q_ext
      complex(ki_sam), intent(in) :: mu2_ext
      complex(ki_sam) :: numerator
      complex(ki) :: d30
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11
      complex(ki) :: t12

      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      real(ki), dimension(0:3) :: qshift

      qshift = -k2
      Q(1)   = cmplx(real(-Q_ext(4) - qshift(0),   ki_sam), aimag(-Q_ext(4)),   &
      &ki)
      Q(2:4) = cmplx(real(-Q_ext(1:3) - qshift(1:3), ki_sam), aimag(-Q_ext(1:3))&
      &, ki)
      d30 = 0.0_ki
      t1 = (Q(1)*Q(1)-Q(2)*Q(2)-Q(3)*Q(3)-Q(4)*Q(4))
      t2 = (Q(1)*k2(1)-Q(2)*k2(2)-Q(3)*k2(3)-Q(4)*k2(4))
      t3 = (Q(1)*spvak2k1(1)-Q(2)*spvak2k1(2)-Q(3)*spvak2k1(3)-Q(4)*spvak2k1(4))
      t4 = (Q(1)*spvak5k1(1)-Q(2)*spvak5k1(2)-Q(3)*spvak5k1(3)-Q(4)*spvak5k1(4))
      t5 = (Q(1)*spvak6k1(1)-Q(2)*spvak6k1(2)-Q(3)*spvak6k1(3)-Q(4)*spvak6k1(4))
      t6 = (Q(1)*spvak3k1(1)-Q(2)*spvak3k1(2)-Q(3)*spvak3k1(3)-Q(4)*spvak3k1(4))
      t7 = (Q(1)*k5(1)-Q(2)*k5(2)-Q(3)*k5(3)-Q(4)*k5(4))
      t8 = (Q(1)*k6(1)-Q(2)*k6(2)-Q(3)*k6(3)-Q(4)*k6(4))
      t9 = (Q(1)*k3(1)-Q(2)*k3(2)-Q(3)*k3(3)-Q(4)*k3(4))
      t10 = (Q(1)*k4(1)-Q(2)*k4(2)-Q(3)*k4(3)-Q(4)*k4(4))
      t11 = (Q(1)*spvak3k4(1)-Q(2)*spvak3k4(2)-Q(3)*spvak3k4(3)-Q(4)*spvak3k4(4)&
      &)
      t12 = (Q(1)*spvak2k4(1)-Q(2)*spvak2k4(2)-Q(3)*spvak2k4(3)-Q(4)*spvak2k4(4)&
      &)
      d30 = (abb30n1+t1*abb30n11+t10*abb30n7+t11*abb30n8+t2*abb30n14+t3*abb30n2+&
      &t4*abb30n22+t5*abb30n23+t6*abb30n3+t7*abb30n5+t8*abb30n6+t9*abb30n7+t1*t1&
      &1*abb30n16+t1*t12*abb30n18+t1*t4*abb30n27+t1*t5*abb30n30+t1*t6*abb30n37+t&
      &10*t12*abb30n17+t10*t4*abb30n28+t10*t5*abb30n29+t10*t6*abb30n38+t11*t12*a&
      &bb30n21+t11*t2*abb30n15+t11*t3*abb30n4+t11*t4*abb30n32+t11*t5*abb30n33+t1&
      &1*t6*abb30n34+t11*abb30n19*(Q(1)*spvak2k3(1)-Q(2)*spvak2k3(2)-Q(3)*spvak2&
      &k3(3)-Q(4)*spvak2k3(4))+t11*abb30n36*(Q(1)*spvak4k1(1)-Q(2)*spvak4k1(2)-Q&
      &(3)*spvak4k1(3)-Q(4)*spvak4k1(4))+t12*t2*abb30n20+t12*t7*abb30n12+t12*t8*&
      &abb30n13+t12*t9*abb30n17+t2*t4*abb30n26+t2*t5*abb30n31+t2*t6*abb30n35+t2*&
      &t7*abb30n10+t2*t8*abb30n9+t3*t7*abb30n24+t3*t8*abb30n25+t4*t9*abb30n28+t5&
      &*t9*abb30n29+t6*t9*abb30n38+t11*t3*t7*abb30n40+t11*t3*t8*abb30n39)
      numerator = cmplx(real(d30, ki), aimag(d30), ki_sam)
   end function numerator_samurai
   !------#] function numerator_samurai:
   !------#[ function numerator_golem95:
   function numerator_golem95(Q_ext, mu2_ext) result(numerator)
      use precision_golem, only: ki_gol => ki
      use p7_dubar_emnebargg_globalsl1, only: epspow
      use p7_dubar_emnebargg_kinematics
      use p7_dubar_emnebargg_abbrevd30h3
      implicit none

      real(ki_gol), dimension(0:3), intent(in) :: Q_ext
      real(ki_gol), intent(in) :: mu2_ext
      complex(ki_gol) :: numerator
      complex(ki) :: d30
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11
      complex(ki) :: t12

      ! The Q that goes into the diagram
      complex(ki), dimension(4) :: Q
      real(ki), dimension(4) :: qshift

      qshift = -k2
      Q(:) = cmplx(real(-Q_ext(:) - qshift(:), ki_gol), 0.0_ki_gol, ki)
      d30 = 0.0_ki
      t1 = (Q(1)*Q(1)-Q(2)*Q(2)-Q(3)*Q(3)-Q(4)*Q(4))
      t2 = (Q(1)*k2(1)-Q(2)*k2(2)-Q(3)*k2(3)-Q(4)*k2(4))
      t3 = (Q(1)*spvak2k1(1)-Q(2)*spvak2k1(2)-Q(3)*spvak2k1(3)-Q(4)*spvak2k1(4))
      t4 = (Q(1)*spvak5k1(1)-Q(2)*spvak5k1(2)-Q(3)*spvak5k1(3)-Q(4)*spvak5k1(4))
      t5 = (Q(1)*spvak6k1(1)-Q(2)*spvak6k1(2)-Q(3)*spvak6k1(3)-Q(4)*spvak6k1(4))
      t6 = (Q(1)*spvak3k1(1)-Q(2)*spvak3k1(2)-Q(3)*spvak3k1(3)-Q(4)*spvak3k1(4))
      t7 = (Q(1)*k5(1)-Q(2)*k5(2)-Q(3)*k5(3)-Q(4)*k5(4))
      t8 = (Q(1)*k6(1)-Q(2)*k6(2)-Q(3)*k6(3)-Q(4)*k6(4))
      t9 = (Q(1)*k3(1)-Q(2)*k3(2)-Q(3)*k3(3)-Q(4)*k3(4))
      t10 = (Q(1)*k4(1)-Q(2)*k4(2)-Q(3)*k4(3)-Q(4)*k4(4))
      t11 = (Q(1)*spvak3k4(1)-Q(2)*spvak3k4(2)-Q(3)*spvak3k4(3)-Q(4)*spvak3k4(4)&
      &)
      t12 = (Q(1)*spvak2k4(1)-Q(2)*spvak2k4(2)-Q(3)*spvak2k4(3)-Q(4)*spvak2k4(4)&
      &)
      d30 = (abb30n1+t1*abb30n11+t10*abb30n7+t11*abb30n8+t2*abb30n14+t3*abb30n2+&
      &t4*abb30n22+t5*abb30n23+t6*abb30n3+t7*abb30n5+t8*abb30n6+t9*abb30n7+t1*t1&
      &1*abb30n16+t1*t12*abb30n18+t1*t4*abb30n27+t1*t5*abb30n30+t1*t6*abb30n37+t&
      &10*t12*abb30n17+t10*t4*abb30n28+t10*t5*abb30n29+t10*t6*abb30n38+t11*t12*a&
      &bb30n21+t11*t2*abb30n15+t11*t3*abb30n4+t11*t4*abb30n32+t11*t5*abb30n33+t1&
      &1*t6*abb30n34+t11*abb30n19*(Q(1)*spvak2k3(1)-Q(2)*spvak2k3(2)-Q(3)*spvak2&
      &k3(3)-Q(4)*spvak2k3(4))+t11*abb30n36*(Q(1)*spvak4k1(1)-Q(2)*spvak4k1(2)-Q&
      &(3)*spvak4k1(3)-Q(4)*spvak4k1(4))+t12*t2*abb30n20+t12*t7*abb30n12+t12*t8*&
      &abb30n13+t12*t9*abb30n17+t2*t4*abb30n26+t2*t5*abb30n31+t2*t6*abb30n35+t2*&
      &t7*abb30n10+t2*t8*abb30n9+t3*t7*abb30n24+t3*t8*abb30n25+t4*t9*abb30n28+t5&
      &*t9*abb30n29+t6*t9*abb30n38+t11*t3*t7*abb30n40+t11*t3*t8*abb30n39)

      numerator = cmplx(real(d30, ki), aimag(d30), ki_gol)
   end function numerator_golem95
   !------#] function numerator_golem95:
!---#] numerator interfaces:
end module p7_dubar_emnebargg_d30h3l1
