module     p7_dubar_emnebargg_d31h3l1d
   ! file:      /home/pcl305a/luisonig/Documents/GoSamSherpa/W2jets/1.4/Virtual/
   ! p7_dubar_emnebargg/helicity3/d31h3l1d.f90
   ! generator: haggies (1.1)
   use p7_dubar_emnebargg_config, only: ki
   use p7_dubar_emnebargg_util, only: cond, d => metric_tensor
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   integer, private :: iv0
   integer, private :: iv1
   integer, private :: iv2
   real(ki), dimension(4), private :: qshift


   public :: derivative, reconstruct_d31
contains

!---#[ function derivative:
   function derivative(mu2, i1, i2) result(numerator)
      use p7_dubar_emnebargg_globalsl1, only: epspow
      use p7_dubar_emnebargg_kinematics
      use p7_dubar_emnebargg_abbrevd31h3
      implicit none
      complex(ki), intent(in) :: mu2
      integer, intent(in), optional :: i1
      integer, intent(in), optional :: i2
      complex(ki) :: numerator
      complex(ki) :: loc
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11
      complex(ki) :: t12
      complex(ki) :: t13
      complex(ki) :: t14
      real(ki) :: t15
      real(ki) :: t16
      real(ki) :: t17
      real(ki) :: t18
      integer :: deg
      complex(ki), dimension(4), parameter :: Q = (/&
        &(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki)/)
      qshift = -k2
      numerator = 0.0_ki
      deg = 0
      if(present(i1)) then
         iv1 = i1
         deg = 1
      else
         iv1 = 1
      end if
      if(present(i2)) then
         iv2 = i2
         deg = 2
      else
         iv2 = 1
      end if
      t15 = dotproduct(k5, qshift)
      t1 = (spvak5k1(1)*qshift(1)-spvak5k1(2)*qshift(2)-spvak5k1(3)*qshift(3)-sp&
      &vak5k1(4)*qshift(4))
      t16 = dotproduct(k1, qshift)
      t2 = (spvak3k4(1)*qshift(1)-spvak3k4(2)*qshift(2)-spvak3k4(3)*qshift(3)-sp&
      &vak3k4(4)*qshift(4))
      t17 = dotproduct(k2, qshift)
      t3 = (spvak5k6(1)*qshift(1)-spvak5k6(2)*qshift(2)-spvak5k6(3)*qshift(3)-sp&
      &vak5k6(4)*qshift(4))
      t4 = (spvak6k5(1)*qshift(1)-spvak6k5(2)*qshift(2)-spvak6k5(3)*qshift(3)-sp&
      &vak6k5(4)*qshift(4))
      t18 = dotproduct(k6, qshift)
      t5 = (spvak2k6(1)*qshift(1)-spvak2k6(2)*qshift(2)-spvak2k6(3)*qshift(3)-sp&
      &vak2k6(4)*qshift(4))
      if(deg.eq.0) then
         numerator = (abb31n23+t1*abb31n34+t15*abb31n33+t16*abb31n35+t17*abb31n3&
         &9+t18*abb31n42+t2*abb31n37+t3*abb31n40+t4*abb31n41+abb31n28*dotproduct&
         &(qshift, qshift)+abb31n36*dotproduct(k3, qshift)+abb31n36*dotproduct(k&
         &4, qshift)+abb31n38*(spvak3k1(1)*qshift(1)-spvak3k1(2)*qshift(2)-spvak&
         &3k1(3)*qshift(3)-spvak3k1(4)*qshift(4))+t1*t4*abb31n29+t15*t4*abb31n30&
         &+t16*t4*abb31n31+t17*t4*abb31n26+t18*t4*abb31n27+t2*t4*abb31n32+t3*t4*&
         &abb31n25+t4*t5*abb31n24)
         return
      end if
      t6 = k1(iv1)
      t7 = k2(iv1)
      t8 = k5(iv1)
      t9 = k6(iv1)
      t10 = spvak3k4(iv1)
      t11 = spvak5k1(iv1)
      t12 = spvak5k6(iv1)
      t13 = spvak6k5(iv1)
      t14 = spvak2k6(iv1)
      if(deg.eq.1) then
         numerator = (k3(iv1)*abb31n36+k4(iv1)*abb31n36+qshift(iv1)*abb31n43+spv&
         &ak3k1(iv1)*abb31n38+t10*abb31n37+t11*abb31n34+t12*abb31n40+t13*abb31n4&
         &1+t6*abb31n35+t7*abb31n39+t8*abb31n33+t9*abb31n42+t1*t13*abb31n29+t10*&
         &t4*abb31n32+t11*t4*abb31n29+t12*t4*abb31n25+t13*t15*abb31n30+t13*t16*a&
         &bb31n31+t13*t17*abb31n26+t13*t18*abb31n27+t13*t2*abb31n32+t13*t3*abb31&
         &n25+t13*t5*abb31n24+t14*t4*abb31n24+t4*t6*abb31n31+t4*t7*abb31n26+t4*t&
         &8*abb31n30+t4*t9*abb31n27)
         return
      end if
      t1 = spvak6k5(iv2)
      if(deg.eq.2) then
         numerator = ((2.0_ki)*d(iv1,iv2)*abb31n28+k1(iv2)*t13*abb31n31+k2(iv2)*&
         &t13*abb31n26+k5(iv2)*t13*abb31n30+k6(iv2)*t13*abb31n27+spvak2k6(iv2)*t&
         &13*abb31n24+spvak3k4(iv2)*t13*abb31n32+spvak5k1(iv2)*t13*abb31n29+spva&
         &k5k6(iv2)*t13*abb31n25+t1*t10*abb31n32+t1*t11*abb31n29+t1*t12*abb31n25&
         &+t1*t14*abb31n24+t1*t6*abb31n31+t1*t7*abb31n26+t1*t8*abb31n30+t1*t9*ab&
         &b31n27)
         return
      end if
   end function derivative
!---#] function derivative:
!---#[ subroutine reconstruct_d31:
   subroutine     reconstruct_d31(coeffs)
      use p7_dubar_emnebargg_groups, only: tensrec_info_group2
      implicit none
      complex(ki), parameter :: czip = (0.0_ki, 0.0_ki)
      complex(ki), parameter :: cone = (1.0_ki, 0.0_ki)

      type(tensrec_info_group2), intent(out) :: coeffs
      ! rank 2 case:
      !---[# reconstruct coeffs%coeffs_31:
      coeffs%coeffs_31%c0 = derivative(czip)
      coeffs%coeffs_31%c1(1,1) = derivative(czip,1)
      coeffs%coeffs_31%c1(1,2) = derivative(czip,1,1) / 2.0_ki
      coeffs%coeffs_31%c1(2,1) = -derivative(czip,2)
      coeffs%coeffs_31%c1(2,2) = derivative(czip,2,2) / 2.0_ki
      coeffs%coeffs_31%c1(3,1) = -derivative(czip,3)
      coeffs%coeffs_31%c1(3,2) = derivative(czip,3,3) / 2.0_ki
      coeffs%coeffs_31%c1(4,1) = -derivative(czip,4)
      coeffs%coeffs_31%c1(4,2) = derivative(czip,4,4) / 2.0_ki
      coeffs%coeffs_31%c2(1,1) = -derivative(czip,1,2)
      coeffs%coeffs_31%c2(2,1) = -derivative(czip,1,3)
      coeffs%coeffs_31%c2(3,1) = -derivative(czip,1,4)
      coeffs%coeffs_31%c2(4,1) = derivative(czip,2,3)
      coeffs%coeffs_31%c2(5,1) = derivative(czip,2,4)
      coeffs%coeffs_31%c2(6,1) = derivative(czip,3,4)
      !---#] reconstruct coeffs%coeffs_31:
   end subroutine reconstruct_d31
!---#] subroutine reconstruct_d31:
end module p7_dubar_emnebargg_d31h3l1d
