module     p7_dubar_emnebargg_d43h3l1d
   ! file:      /home/pcl305a/luisonig/Documents/GoSamSherpa/W2jets/1.4/Virtual/
   ! p7_dubar_emnebargg/helicity3/d43h3l1d.f90
   ! generator: haggies (1.1)
   use p7_dubar_emnebargg_config, only: ki
   use p7_dubar_emnebargg_util, only: cond, d => metric_tensor
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   integer, private :: iv0
   integer, private :: iv1
   integer, private :: iv2
   real(ki), dimension(4), private :: qshift


   public :: derivative, reconstruct_d43
contains

!---#[ function derivative:
   function derivative(mu2, i1, i2) result(numerator)
      use p7_dubar_emnebargg_globalsl1, only: epspow
      use p7_dubar_emnebargg_kinematics
      use p7_dubar_emnebargg_abbrevd43h3
      implicit none
      complex(ki), intent(in) :: mu2
      integer, intent(in), optional :: i1
      integer, intent(in), optional :: i2
      complex(ki) :: numerator
      complex(ki) :: loc
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      complex(ki) :: t7
      complex(ki) :: t8
      complex(ki) :: t9
      complex(ki) :: t10
      complex(ki) :: t11
      complex(ki) :: t12
      real(ki) :: t13
      real(ki) :: t14
      integer :: deg
      complex(ki), dimension(4), parameter :: Q = (/&
        &(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki)/)
      qshift = k3-k2+k6+k4
      numerator = 0.0_ki
      deg = 0
      if(present(i1)) then
         iv1 = i1
         deg = 1
      else
         iv1 = 1
      end if
      if(present(i2)) then
         iv2 = i2
         deg = 2
      else
         iv2 = 1
      end if
      t1 = (spvak5k1(1)*qshift(1)-spvak5k1(2)*qshift(2)-spvak5k1(3)*qshift(3)-sp&
      &vak5k1(4)*qshift(4))
      t2 = (spvak5k6(1)*qshift(1)-spvak5k6(2)*qshift(2)-spvak5k6(3)*qshift(3)-sp&
      &vak5k6(4)*qshift(4))
      t13 = dotproduct(k5, qshift)
      t14 = dotproduct(k1, qshift)
      t3 = (spvak6k5(1)*qshift(1)-spvak6k5(2)*qshift(2)-spvak6k5(3)*qshift(3)-sp&
      &vak6k5(4)*qshift(4))
      t4 = (spvak3k1(1)*qshift(1)-spvak3k1(2)*qshift(2)-spvak3k1(3)*qshift(3)-sp&
      &vak3k1(4)*qshift(4))
      t5 = (spvak2k1(1)*qshift(1)-spvak2k1(2)*qshift(2)-spvak2k1(3)*qshift(3)-sp&
      &vak2k1(4)*qshift(4))
      if(deg.eq.0) then
         numerator = (abb43n17+t1*abb43n26+t13*abb43n28+t14*abb43n29+t2*abb43n27&
         &+t3*abb43n30+abb43n24*dotproduct(qshift, qshift)+abb43n25*dotproduct(k&
         &6, qshift)+t1*t3*abb43n18+t13*t3*abb43n19+t14*t3*abb43n20+t2*t3*abb43n&
         &21+t3*t4*abb43n22+t3*t5*abb43n23)
         return
      end if
      t6 = k1(iv1)
      t7 = k5(iv1)
      t8 = spvak5k1(iv1)
      t9 = spvak5k6(iv1)
      t10 = spvak6k5(iv1)
      t11 = spvak2k1(iv1)
      t12 = spvak3k1(iv1)
      if(deg.eq.1) then
         numerator = (k6(iv1)*abb43n25+qshift(iv1)*abb43n31+t10*abb43n30+t6*abb4&
         &3n29+t7*abb43n28+t8*abb43n26+t9*abb43n27+t1*t10*abb43n18+t10*t13*abb43&
         &n19+t10*t14*abb43n20+t10*t2*abb43n21+t10*t4*abb43n22+t10*t5*abb43n23+t&
         &11*t3*abb43n23+t12*t3*abb43n22+t3*t6*abb43n20+t3*t7*abb43n19+t3*t8*abb&
         &43n18+t3*t9*abb43n21)
         return
      end if
      t1 = spvak6k5(iv2)
      if(deg.eq.2) then
         numerator = ((2.0_ki)*d(iv1,iv2)*abb43n24+k1(iv2)*t10*abb43n20+k5(iv2)*&
         &t10*abb43n19+spvak2k1(iv2)*t10*abb43n23+spvak3k1(iv2)*t10*abb43n22+spv&
         &ak5k1(iv2)*t10*abb43n18+spvak5k6(iv2)*t10*abb43n21+t1*t11*abb43n23+t1*&
         &t12*abb43n22+t1*t6*abb43n20+t1*t7*abb43n19+t1*t8*abb43n18+t1*t9*abb43n&
         &21)
         return
      end if
   end function derivative
!---#] function derivative:
!---#[ subroutine reconstruct_d43:
   subroutine     reconstruct_d43(coeffs)
      use p7_dubar_emnebargg_groups, only: tensrec_info_group5
      implicit none
      complex(ki), parameter :: czip = (0.0_ki, 0.0_ki)
      complex(ki), parameter :: cone = (1.0_ki, 0.0_ki)

      type(tensrec_info_group5), intent(out) :: coeffs
      ! rank 2 case:
      !---[# reconstruct coeffs%coeffs_43:
      coeffs%coeffs_43%c0 = derivative(czip)
      coeffs%coeffs_43%c1(1,1) = derivative(czip,1)
      coeffs%coeffs_43%c1(1,2) = derivative(czip,1,1) / 2.0_ki
      coeffs%coeffs_43%c1(2,1) = -derivative(czip,2)
      coeffs%coeffs_43%c1(2,2) = derivative(czip,2,2) / 2.0_ki
      coeffs%coeffs_43%c1(3,1) = -derivative(czip,3)
      coeffs%coeffs_43%c1(3,2) = derivative(czip,3,3) / 2.0_ki
      coeffs%coeffs_43%c1(4,1) = -derivative(czip,4)
      coeffs%coeffs_43%c1(4,2) = derivative(czip,4,4) / 2.0_ki
      coeffs%coeffs_43%c2(1,1) = -derivative(czip,1,2)
      coeffs%coeffs_43%c2(2,1) = -derivative(czip,1,3)
      coeffs%coeffs_43%c2(3,1) = -derivative(czip,1,4)
      coeffs%coeffs_43%c2(4,1) = derivative(czip,2,3)
      coeffs%coeffs_43%c2(5,1) = derivative(czip,2,4)
      coeffs%coeffs_43%c2(6,1) = derivative(czip,3,4)
      !---#] reconstruct coeffs%coeffs_43:
   end subroutine reconstruct_d43
!---#] subroutine reconstruct_d43:
end module p7_dubar_emnebargg_d43h3l1d
