module     p7_dubar_emnebargg_d81h3l1d
   ! file:      /home/pcl305a/luisonig/Documents/GoSamSherpa/W2jets/1.4/Virtual/
   ! p7_dubar_emnebargg/helicity3/d81h3l1d.f90
   ! generator: haggies (1.1)
   use p7_dubar_emnebargg_config, only: ki
   use p7_dubar_emnebargg_util, only: cond, d => metric_tensor
   implicit none
   private

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   integer, private :: iv0
   integer, private :: iv1
   real(ki), dimension(4), private :: qshift


   public :: derivative, reconstruct_d81
contains

!---#[ function derivative:
   function derivative(mu2, i1) result(numerator)
      use p7_dubar_emnebargg_globalsl1, only: epspow
      use p7_dubar_emnebargg_kinematics
      use p7_dubar_emnebargg_abbrevd81h3
      implicit none
      complex(ki), intent(in) :: mu2
      integer, intent(in), optional :: i1
      complex(ki) :: numerator
      complex(ki) :: loc
      integer :: deg
      complex(ki), dimension(4), parameter :: Q = (/&
        &(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki),(0.0_ki,0.0_ki)/)
      qshift = -k6-k5
      numerator = 0.0_ki
      deg = 0
      if(present(i1)) then
         iv1 = i1
         deg = 1
      else
         iv1 = 1
      end if
      if(deg.eq.0) then
         numerator = (abb81n13+abb81n14*(spvak2k1(1)*qshift(1)-spvak2k1(2)*qshif&
         &t(2)-spvak2k1(3)*qshift(3)-spvak2k1(4)*qshift(4))+abb81n15*(spvak2k4(1&
         &)*qshift(1)-spvak2k4(2)*qshift(2)-spvak2k4(3)*qshift(3)-spvak2k4(4)*qs&
         &hift(4))+abb81n16*(spvak6k1(1)*qshift(1)-spvak6k1(2)*qshift(2)-spvak6k&
         &1(3)*qshift(3)-spvak6k1(4)*qshift(4))+abb81n17*(spvak5k1(1)*qshift(1)-&
         &spvak5k1(2)*qshift(2)-spvak5k1(3)*qshift(3)-spvak5k1(4)*qshift(4))+abb&
         &81n18*(spvak6k4(1)*qshift(1)-spvak6k4(2)*qshift(2)-spvak6k4(3)*qshift(&
         &3)-spvak6k4(4)*qshift(4))+abb81n19*(spvak5k4(1)*qshift(1)-spvak5k4(2)*&
         &qshift(2)-spvak5k4(3)*qshift(3)-spvak5k4(4)*qshift(4))+abb81n20*dotpro&
         &duct(k1, qshift)+abb81n21*dotproduct(k3, qshift)+abb81n21*dotproduct(k&
         &4, qshift)+abb81n22*(spvak3k4(1)*qshift(1)-spvak3k4(2)*qshift(2)-spvak&
         &3k4(3)*qshift(3)-spvak3k4(4)*qshift(4))+abb81n23*(spvak3k1(1)*qshift(1&
         &)-spvak3k1(2)*qshift(2)-spvak3k1(3)*qshift(3)-spvak3k1(4)*qshift(4)))
         return
      end if
      if(deg.eq.1) then
         numerator = (k1(iv1)*abb81n20+k3(iv1)*abb81n21+k4(iv1)*abb81n21+spvak2k&
         &1(iv1)*abb81n14+spvak2k4(iv1)*abb81n15+spvak3k1(iv1)*abb81n23+spvak3k4&
         &(iv1)*abb81n22+spvak5k1(iv1)*abb81n17+spvak5k4(iv1)*abb81n19+spvak6k1(&
         &iv1)*abb81n16+spvak6k4(iv1)*abb81n18)
         return
      end if
   end function derivative
!---#] function derivative:
!---#[ subroutine reconstruct_d81:
   subroutine     reconstruct_d81(coeffs)
      use p7_dubar_emnebargg_groups, only: tensrec_info_group4
      implicit none
      complex(ki), parameter :: czip = (0.0_ki, 0.0_ki)
      complex(ki), parameter :: cone = (1.0_ki, 0.0_ki)

      type(tensrec_info_group4), intent(out) :: coeffs
      ! rank 1 case:
      !---[# reconstruct coeffs%coeffs_81:
      coeffs%coeffs_81%c0 = derivative(czip)
      coeffs%coeffs_81%c1(1,1) = derivative(czip,1)
      coeffs%coeffs_81%c1(2,1) = -derivative(czip,2)
      coeffs%coeffs_81%c1(3,1) = -derivative(czip,3)
      coeffs%coeffs_81%c1(4,1) = -derivative(czip,4)
      !---#] reconstruct coeffs%coeffs_81:
   end subroutine reconstruct_d81
!---#] subroutine reconstruct_d81:
end module p7_dubar_emnebargg_d81h3l1d
